/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.Log;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsConstants;
import com.denova.util.StringArray;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;

public class CustomUninstaller
implements JExpressConstants,
WindowsConstants,
InstallPropertyNames {
    private static Log log;
    private final StringArray generalCommands = new StringArray();
    private final StringArray windowsCommands = new StringArray();
    private final StringArray menuCommands = new StringArray();
    private final String homeDir = System.getProperty("user.home", "");
    private final String javaDir = JRE.getActiveJavaHome();
    private String customClasses = null;

    public CustomUninstaller() {
        CustomUninstaller.initLog();
    }

    public boolean append(String string) {
        boolean bl = true;
        log.write("appending commands");
        if (!this.saveCustomClasses(string)) {
            bl = false;
        }
        if (!this.appendGeneralCommands(string)) {
            bl = false;
        }
        if (!this.appendWindowsCommands(string)) {
            bl = false;
        }
        if (!this.appendMenuCommands(string)) {
            bl = false;
        }
        this.resetUninstallerCommands();
        return bl;
    }

    public boolean prepend(String string) {
        boolean bl = true;
        log.write("prepending commands");
        if (!this.saveCustomClasses(string)) {
            bl = false;
        }
        if (!this.prependGeneralCommands(string)) {
            bl = false;
        }
        if (!this.prependWindowsCommands(string)) {
            bl = false;
        }
        if (!this.prependMenuCommands(string)) {
            bl = false;
        }
        this.resetUninstallerCommands();
        return bl;
    }

    public boolean save(String string, String string2) {
        boolean bl = true;
        log.write("creating uninstall command files");
        if (!this.createGeneralUninstallerCommandFile(string, string2)) {
            bl = false;
        }
        if (!this.createWindowsUninstallerCommandFile(string)) {
            bl = false;
        }
        if (!this.createMenuUninstallerCommandFile(string)) {
            bl = false;
        }
        this.resetUninstallerCommands();
        return bl;
    }

    public boolean tempSave(String string, String string2) {
        boolean bl = true;
        log.write("creating temporary uninstall command files");
        if (this.generalCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, string2);
            log.write("adding general uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath());
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.generalCommands.getCount();
                log.write("number of general uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    String string3 = this.replaceDirs(this.generalCommands.getItem(i), string);
                    printWriter.println(string3);
                    log.write("    " + string3);
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var7_8) {
                bl = false;
                CustomInstaller.logException("Unable to save general uninstaller commands.", var7_8);
            }
        } else {
            log.write("No temporary general uninstaller commands to save.");
        }
        this.resetUninstallerCommands();
        return bl;
    }

    public boolean setCustomClasses(String string) {
        boolean bl = true;
        if (string == null) {
            bl = false;
        } else {
            this.customClasses = string;
            log.write("set custom classes: " + this.customClasses);
        }
        return bl;
    }

    public boolean deletePropertyStorage(String string) {
        boolean bl = this.generalCommands.addItem("delpropstorage\t" + string);
        log.write("added deletePropertyStorage: " + bl);
        return bl;
    }

    public boolean deleteManifest(String string) {
        boolean bl = this.generalCommands.addItem("delmanifest\t" + string);
        log.write("added deleteManifest: " + bl + ": " + string);
        return bl;
    }

    public boolean deleteDirTree(String string) {
        boolean bl = this.generalCommands.addItem("deltree\t" + string);
        log.write("added deleteDirTree: " + bl + ": " + string);
        return bl;
    }

    public boolean deleteDirIfEmpty(String string) {
        boolean bl = this.generalCommands.addItem("deldirifempty\t" + string);
        log.write("added deleteDirIfEmpty: " + bl + ": " + string);
        return bl;
    }

    public boolean deleteFile(String string) {
        boolean bl = this.generalCommands.addItem("delfile\t" + string);
        log.write("added deleteFile: " + bl + ": " + string);
        return bl;
    }

    public boolean renameFile(String string, String string2) {
        boolean bl = this.generalCommands.addItem("renfile\t" + string + "\t" + string2);
        log.write("added renameFile: " + bl + ": " + string2);
        return bl;
    }

    public boolean copyFileCommand(String string, String string2) {
        boolean bl = this.generalCommands.addItem("copyfile\t" + string + "\t" + string2);
        log.write("added copyFile: " + bl + ": " + string2);
        return bl;
    }

    public boolean overwriteFileCommand(String string, String string2) {
        boolean bl = this.generalCommands.addItem("overwritefile\t" + string + "\t" + string2);
        log.write("added overwriteFile: " + bl + ": " + string2);
        return bl;
    }

    public boolean removeWindowsService(String string, String string2) {
        boolean bl = this.generalCommands.addItem("delwinservice\t" + string + "\t" + string2);
        log.write("added uninstall service: " + bl + ": " + string);
        return bl;
    }

    public boolean removeWindowsJavaService(String string) {
        String[] arrstring = this.getWindowsJavaServiceArgs(string, "delete");
        String string2 = this.getWindowsJavaServiceExec();
        return this.runThirdPartyApp(string2, arrstring);
    }

    public boolean removeLinuxService(String string) {
        boolean bl = this.generalCommands.addItem("dellinuxservice\t" + string);
        log.write("added uninstall service: " + bl + ": " + string);
        return bl;
    }

    public boolean trackUninstall(String string, String string2) {
        boolean bl = this.generalCommands.addItem("trackUninstall\t" + string + "\t" + string2);
        log.write("added trackUninstall: " + bl);
        return bl;
    }

    public boolean addSubkeyEntry(String string, String string2, String string3) {
        boolean bl = this.windowsCommands.addItem("add\t" + string + "\t" + string2 + "\t" + "String" + "\t" + string3);
        log.write("added subKeyEntry: " + bl + ": " + string + "\\" + string2 + "\\" + string3);
        return bl;
    }

    public boolean replaceDataEntry(String string, String string2, String string3) {
        boolean bl = this.windowsCommands.addItem("replace\t" + string + "\t" + string2 + "\t" + "String" + "\t" + string3);
        log.write("added replaceDataEntry: " + bl + ": " + string + "\\" + string2 + "\\" + string3);
        return bl;
    }

    public boolean deleteKey(String string, String string2) {
        boolean bl = this.windowsCommands.addItem("delete\t" + string + "\t" + string2 + "\t" + "String" + "\t" + "");
        log.write("added deleteSubkeyEntry: " + bl + ": " + string + "\\" + string2);
        return bl;
    }

    public boolean deleteSubkeyEntry(String string, String string2) {
        boolean bl = this.windowsCommands.addItem("delete\t" + string + "\t" + string2 + "\t" + "String" + "\t" + "");
        log.write("added deleteSubkeyEntry: " + bl + ": " + string + "\\" + string2);
        return bl;
    }

    public boolean deleteAttribute(String string, String string2) {
        boolean bl = this.windowsCommands.addItem("deleteattrib\t" + string + "\t" + string2 + "\t" + "String" + "\t" + "");
        log.write("added deleteAttribute: " + bl + ": " + string2 + " from " + string);
        return bl;
    }

    public boolean deleteWindowsMenuItem(String string, String string2, String string3) {
        boolean bl = this.menuCommands.addItem("deleteProgramsMenu\t" + string + "\t" + string2 + "\t" + string3);
        log.write("added deleteWindowsMenuItem: " + bl + ": " + string + "/" + string2 + "/" + string3);
        return bl;
    }

    public boolean deleteWindowsDesktopIcon(String string, String string2, String string3) {
        boolean bl = this.menuCommands.addItem("deleteDesktop\t" + string + "\t" + string2 + "\t" + string3);
        log.write("added deleteWindowsDesktopIcon: " + bl + ": " + string + "/" + string2 + "/" + string3);
        return bl;
    }

    public boolean runThirdPartyApp(String string, String[] arrstring) {
        String string2 = this.formatArguments(arrstring);
        boolean bl = this.generalCommands.addItem(string + "\t" + string2);
        log.write("added run third party app: " + bl + ": " + string + "/" + string2);
        return bl;
    }

    private boolean createGeneralUninstallerCommandFile(String string, String string2) {
        boolean bl = true;
        if (this.generalCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "uninstall");
            log.write("adding general uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath());
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                printWriter.println("title\t" + string2);
                String string3 = this.customClasses;
                if (string3 == null) {
                    string3 = "";
                }
                printWriter.println("customclasses\t" + string3);
                int n = this.generalCommands.getCount();
                log.write("number of general uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    String string4 = this.replaceDirs(this.generalCommands.getItem(i), string);
                    printWriter.println(string4);
                    log.write("    " + string4);
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var7_8) {
                bl = false;
                CustomInstaller.logException("Unable to save general uninstaller commands.", var7_8);
            }
        } else {
            log.write("No general uninstaller commands to save.");
        }
        return bl;
    }

    private boolean saveCustomClasses(String string) {
        boolean bl = true;
        if (this.customClasses != null) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "uninstall");
            File file4 = new File(file2, "uninstall.new");
            log.write("save custom classes to " + file3.getPath());
            if (file3.exists()) {
                try {
                    boolean bl2;
                    FileOutputStream fileOutputStream = new FileOutputStream(file4.getPath(), false);
                    PrintWriter printWriter = new PrintWriter(fileOutputStream);
                    DataInputStream dataInputStream = new DataInputStream(new FileInputStream(file3));
                    String string2 = dataInputStream.readLine();
                    boolean bl3 = bl2 = string2 == null;
                    while (!bl2) {
                        if (string2.startsWith("title")) {
                            printWriter.println(string2);
                            string2 = "customclasses\t" + this.customClasses;
                            printWriter.println(string2);
                            log.write("save  " + string2);
                        } else if (string2.startsWith("customclasses")) {
                            log.write("skip the old customclasses line");
                        } else {
                            printWriter.println(string2);
                        }
                        string2 = dataInputStream.readLine();
                        bl2 = string2 == null;
                    }
                    printWriter.close();
                    fileOutputStream.close();
                    dataInputStream.close();
                    if (file4.exists() && file4.length() >= file3.length()) {
                        file3.delete();
                        file4.renameTo(file3);
                    }
                }
                catch (Exception var7_8) {
                    bl = false;
                    CustomInstaller.logException("Unable to save custom classes.", var7_8);
                }
            } else {
                log.write(file3.getName() + " does not exist.");
                bl = this.createGeneralUninstallerCommandFile(string, "Application");
            }
        } else {
            log.write("No custom classes to add.");
        }
        return bl;
    }

    private boolean appendGeneralCommands(String string) {
        boolean bl = true;
        if (this.generalCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "uninstall");
            log.write("appending general uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath(), true);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.generalCommands.getCount();
                log.write("number of general uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    String string2 = this.replaceDirs(this.generalCommands.getItem(i), string);
                    printWriter.println(string2);
                    log.write("    " + string2);
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var6_7) {
                bl = false;
                CustomInstaller.logException("Unable to append general uninstaller commands.", var6_7);
            }
        } else {
            log.write("No general uninstaller commands to append.");
        }
        return bl;
    }

    private boolean prependGeneralCommands(String string) {
        boolean bl = true;
        if (this.generalCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "uninstall");
            File file4 = new File(file2, "uninstall.new");
            log.write("prepending general uninstaller commands to " + file3.getPath());
            if (file3.exists()) {
                try {
                    boolean bl2;
                    FileOutputStream fileOutputStream = new FileOutputStream(file4.getPath(), false);
                    PrintWriter printWriter = new PrintWriter(fileOutputStream);
                    DataInputStream dataInputStream = new DataInputStream(new FileInputStream(file3));
                    String string2 = dataInputStream.readLine();
                    boolean bl3 = bl2 = string2 == null;
                    while (!bl2) {
                        if (string2.startsWith("title") || string2.startsWith("customclasses")) {
                            printWriter.println(string2);
                            log.write("saving " + string2);
                            string2 = dataInputStream.readLine();
                            bl2 = string2 == null;
                            continue;
                        }
                        bl2 = true;
                    }
                    int n = this.generalCommands.getCount();
                    log.write("number of general uninstaller commands " + String.valueOf(n));
                    for (int i = 0; i < n; ++i) {
                        String string3 = this.replaceDirs(this.generalCommands.getItem(i), string);
                        printWriter.println(string3);
                        log.write("    " + string3);
                    }
                    while (string2 != null) {
                        printWriter.println(string2);
                        string2 = dataInputStream.readLine();
                    }
                    printWriter.close();
                    fileOutputStream.close();
                    dataInputStream.close();
                    if (file4.exists() && file4.length() >= file3.length()) {
                        file3.delete();
                        file4.renameTo(file3);
                    }
                }
                catch (Exception var7_8) {
                    bl = false;
                    CustomInstaller.logException("Unable to prepend general uninstaller commands.", var7_8);
                }
            } else {
                log.write(file3.getName() + " does not exist.");
                bl = this.createGeneralUninstallerCommandFile(string, "Application");
            }
        } else {
            log.write("No general uninstaller commands to prepend.");
        }
        return bl;
    }

    private boolean createWindowsUninstallerCommandFile(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.windowsCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specreg");
            log.write("creating Windows uninstaller command file: " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath());
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.windowsCommands.getCount();
                log.write("number of Windows uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    printWriter.println(this.windowsCommands.getItem(i));
                    log.write("    " + this.windowsCommands.getItem(i));
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var6_7) {
                bl = false;
                CustomInstaller.logException("Unable to save Windows commands to uninstaller.", var6_7);
            }
        } else if (this.windowsCommands.getCount() > 0) {
            log.write("No Windows uninstaller commands to save");
        }
        return bl;
    }

    private boolean appendWindowsCommands(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.windowsCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specreg");
            log.write("appending Windows uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath(), true);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.windowsCommands.getCount();
                log.write("number of Windows uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    printWriter.println(this.windowsCommands.getItem(i));
                    log.write("    " + this.windowsCommands.getItem(i));
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var6_7) {
                bl = false;
                CustomInstaller.logException("Unable to append Windows commands to uninstaller.", var6_7);
            }
        } else if (this.windowsCommands.getCount() > 0) {
            log.write("No Windows uninstaller commands to save");
        }
        return bl;
    }

    private boolean prependWindowsCommands(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.windowsCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specreg");
            File file4 = new File(file2, "specreg.new");
            log.write("prepending Windows uninstaller commands to " + file3.getPath());
            if (file3.exists()) {
                try {
                    FileOutputStream fileOutputStream = new FileOutputStream(file4.getPath(), false);
                    PrintWriter printWriter = new PrintWriter(fileOutputStream);
                    DataInputStream dataInputStream = new DataInputStream(new FileInputStream(file3));
                    int n = this.windowsCommands.getCount();
                    log.write("number of Windows uninstaller commands " + String.valueOf(n));
                    for (int i = 0; i < n; ++i) {
                        printWriter.println(this.windowsCommands.getItem(i));
                        log.write("    " + this.windowsCommands.getItem(i));
                    }
                    String string2 = dataInputStream.readLine();
                    while (string2 != null) {
                        printWriter.println(string2);
                        string2 = dataInputStream.readLine();
                    }
                    printWriter.close();
                    fileOutputStream.close();
                    dataInputStream.close();
                    if (file4.exists() && file4.length() >= file3.length()) {
                        file3.delete();
                        file4.renameTo(file3);
                    }
                }
                catch (Exception var7_8) {
                    bl = false;
                    CustomInstaller.logException("Unable to add Windows uninstaller commands to the beginning of the uninstaller.", var7_8);
                }
            } else {
                log.write(file3.getName() + " does not exist.");
                bl = this.createWindowsUninstallerCommandFile(string);
            }
        } else if (this.windowsCommands.getCount() > 0) {
            log.write("No Windows uninstaller commands to save");
        }
        return bl;
    }

    private boolean createMenuUninstallerCommandFile(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.menuCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specmenu");
            log.write("appending menu uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath());
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.menuCommands.getCount();
                log.write("number of menu uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    this.printMenuCommand(printWriter, this.menuCommands.getItem(i));
                    log.write("    " + this.menuCommands.getItem(i));
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var6_7) {
                bl = false;
                CustomInstaller.logException("Unable to save menu uninstaller commands.", var6_7);
            }
        } else if (this.menuCommands.getCount() > 0) {
            log.write("No menu uninstaller commands to save");
        }
        return bl;
    }

    private boolean appendMenuCommands(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.menuCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specmenu");
            log.write("appending menu uninstaller commands to " + file3.getPath());
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file3.getPath(), true);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                int n = this.menuCommands.getCount();
                log.write("number of menu uninstaller commands " + String.valueOf(n));
                for (int i = 0; i < n; ++i) {
                    this.printMenuCommand(printWriter, this.menuCommands.getItem(i));
                    log.write("    " + this.menuCommands.getItem(i));
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var6_7) {
                bl = false;
                CustomInstaller.logException("Unable to append menu uninstaller commands.", var6_7);
            }
        } else if (this.menuCommands.getCount() > 0) {
            log.write("No menu uninstaller commands to append");
        }
        return bl;
    }

    private boolean prependMenuCommands(String string) {
        boolean bl = true;
        if (OS.isWindows() && this.menuCommands.getCount() > 0) {
            File file = new File(string, "JExpress");
            File file2 = new File(file, "uninstaller");
            file2.mkdirs();
            File file3 = new File(file2, "specmenu");
            File file4 = new File(file2, "specmenu.new");
            log.write("appending menu uninstaller commands to " + file3.getPath());
            if (file3.exists()) {
                try {
                    FileOutputStream fileOutputStream = new FileOutputStream(file4.getPath(), false);
                    PrintWriter printWriter = new PrintWriter(fileOutputStream);
                    DataInputStream dataInputStream = new DataInputStream(new FileInputStream(file3));
                    int n = this.menuCommands.getCount();
                    log.write("number of menu uninstaller commands " + String.valueOf(n));
                    for (int i = 0; i < n; ++i) {
                        this.printMenuCommand(printWriter, this.menuCommands.getItem(i));
                        log.write("    " + this.menuCommands.getItem(i));
                    }
                    String string2 = dataInputStream.readLine();
                    while (string2 != null) {
                        printWriter.println(string2);
                        string2 = dataInputStream.readLine();
                    }
                    printWriter.close();
                    fileOutputStream.close();
                    dataInputStream.close();
                    if (file4.exists() && file4.length() >= file3.length()) {
                        file3.delete();
                        file4.renameTo(file3);
                    }
                }
                catch (Exception var7_8) {
                    bl = false;
                    CustomInstaller.logException("Unable to prepend menu uninstaller commands.", var7_8);
                }
            } else {
                log.write(file3.getName() + " does not exist.");
                bl = this.createMenuUninstallerCommandFile(string);
            }
        } else if (this.menuCommands.getCount() > 0) {
            log.write("No menu uninstaller commands to prepend");
        }
        return bl;
    }

    private void resetUninstallerCommands() {
        this.generalCommands.setStrings(null);
        this.windowsCommands.setStrings(null);
        this.menuCommands.setStrings(null);
    }

    private boolean printMenuCommand(PrintWriter printWriter, String string) {
        boolean bl = true;
        String string2 = "deleteProgramsMenu";
        String string3 = "";
        String string4 = "";
        String string5 = "currentUser";
        int n = 0;
        n = string.indexOf("\t");
        if (n != -1) {
            string2 = string.substring(0, n);
            if (string.length() > n) {
                string = string.substring(n + 1);
                n = string.indexOf("\t");
                if (n != -1) {
                    string3 = string.substring(0, n);
                    if (string.length() > n) {
                        string = string.substring(n + 1);
                        n = string.indexOf("\t");
                        if (n != -1) {
                            string4 = string.substring(0, n);
                            if (string.length() > n) {
                                string5 = string.substring(n + 1);
                            }
                        } else {
                            string4 = string;
                        }
                    }
                }
            }
        }
        if (string4.length() > 0) {
            printWriter.println(string2);
            printWriter.println(string3);
            printWriter.println(string4);
            printWriter.println(string5);
        } else {
            bl = false;
        }
        return bl;
    }

    private String formatArguments(String[] arrstring) {
        String string = "";
        if (arrstring != null) {
            StringArray stringArray = new StringArray();
            stringArray.setStrings(arrstring);
            int n = stringArray.getCount();
            for (int i = 0; i < n; ++i) {
                if (string.length() > 0) {
                    string = string + "\t";
                }
                string = string + stringArray.getItem(i);
            }
        }
        return string;
    }

    private String replaceDirs(String string, String string2) {
        String string3 = string;
        string3 = this.replaceDir(string3, this.javaDir, "[$JavaHomeDir]");
        string3 = this.replaceDir(string3, string2, "[$AppDir]");
        string3 = this.replaceDir(string3, this.homeDir, "[$UserHomeDir]");
        return string3;
    }

    private String replaceDir(String string, String string2, String string3) {
        int n = string2.length();
        String string4 = string;
        int n2 = string4.indexOf(string2);
        while (n2 != -1) {
            string4 = string4.substring(0, n2) + string3 + string4.substring(n2 + n);
            n2 = string4.indexOf(string2);
        }
        return string4;
    }

    private String[] getWindowsJavaServiceArgs(String string, String string2) {
        String string3 = string;
        int n = string3.indexOf(" ");
        while (n > -1) {
            string3 = string3.substring(0, n) + string3.substring(n + 1);
            n = string3.indexOf(" ");
        }
        String[] arrstring = new String[]{string2, string3};
        return arrstring;
    }

    private String getWindowsJavaServiceExec() {
        String string = File.separator;
        String string2 = "winservice";
        String string3 = WindowsCommands.getProcessorArchitecture();
        if (string3.equals("amd64")) {
            string2 = "amd64" + string + "winservice";
        } else if (string3.equals("ia64")) {
            string2 = "ia64" + string + "winservice";
        }
        String string4 = "[$AppDir]" + string + "JExpress" + string + "services";
        String string5 = string4 + string + string2;
        return string5;
    }

    private static void initLog() {
        log = new Log("uninstall");
    }
}
