/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.FileSystem;
import com.denova.runtime.Exec;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsRegistry;
import com.denova.ui.Swinger;
import com.denova.util.PropertyList;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import javax.swing.JLabel;

public class InstallJvmPanel
extends StatusPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants {
    private static final boolean debugging = false;
    private static final String JREKey = "HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Runtime Environment";
    private File directory;
    private boolean canceled;
    private boolean panelFinished = false;
    private boolean silentInstall = false;
    private boolean jvmInTempDir = false;
    private boolean nextButtonEnabled = false;
    private String progressMessage = "";

    public InstallJvmPanel(PropertyList propertyList) {
        super(propertyList);
        boolean bl = this.panelFinished = !this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false);
        if (this.panelFinished) {
            this.progressMessage = Localize.strings().getString("InstallingFiles");
        } else {
            String string = this.getPropertyList().getProperty("jvmName");
            this.progressMessage = Localize.strings().getString("Installing", string);
        }
        this.progressBarLabel.setText(this.progressMessage);
    }

    public synchronized void enter() {
        if (this.panelFinished) {
            this.showNextPanel();
        } else if (!this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false)) {
            this.moveToNextPanel();
        } else {
            JvmSwinger jvmSwinger = new JvmSwinger();
            jvmSwinger.execute();
        }
    }

    public boolean isOk() {
        return this.panelFinished;
    }

    public void userCanceled() {
        this.canceled = true;
        this.log("canceled jvm install");
    }

    public boolean isNextButtonEnabled() {
        return this.nextButtonEnabled;
    }

    public int getPanelProgressShares() {
        int n = 0;
        if (this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false)) {
            ++n;
        }
        return n;
    }

    public int getEstimatedTime() {
        int n = 0;
        if (this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false)) {
            n = 60;
        }
        return n;
    }

    private void moveToNextPanel() {
        this.panelFinished = true;
        this.showNextPanel();
    }

    private boolean setupForInstallFiles() {
        boolean bl = true;
        if (this.getPropertyList() == null) {
            if (!this.silentInstall) {
                InstallerPopups.noteError(Localize.strings().getString("NoProperties"));
            }
            bl = false;
            this.gotError("No properties");
        }
        if (bl) {
            String string = this.getPropertyList().getProperty("applicationDirectory");
            if (string != null) {
                this.directory = new File(string);
            }
            if (this.directory == null) {
                if (CustomInstaller.multipleDirInstall()) {
                    this.directory = new File(".");
                } else {
                    if (!this.silentInstall) {
                        InstallerPopups.noteError(Localize.strings().getString("NoAppDir"));
                    }
                    bl = false;
                    this.gotError("No application directory");
                }
            }
        }
        return bl;
    }

    boolean copyJvmToAppDir() {
        int n;
        String string;
        Object object;
        Object object2;
        File file = null;
        boolean bl = true;
        String string2 = this.getPropertyList().getProperty("applicationDirectory");
        String string3 = this.getPropertyList().getProperty("nativeJvmHomeDir");
        String string4 = this.getPropertyList().getProperty("predefinedJvmInstallDir");
        this.log("about to copy jvm to " + string4);
        if (string4.startsWith("[$AppDir]")) {
            n = string4.indexOf("[$AppDir]");
            if (n >= 0) {
                object = string4.substring(n+="[$AppDir]".length());
                file = new File(string2, (String)object);
            }
        } else if (string4.startsWith("[$ProgFilesDir]") && (n = string4.indexOf("[$ProgFilesDir]")) >= 0) {
            object = string4.substring(n+="[$ProgFilesDir]".length());
            object2 = WindowsDirs.getProgramManagerDirectory();
            file = new File((String)object2, (String)object);
        }
        if (file == null) {
            file = new File(string4);
        }
        this.log("jvm dir name: " + file.getPath());
        try {
            string = file.getCanonicalPath();
        }
        catch (Exception var7_9) {
            string = file.getAbsolutePath();
        }
        this.log("normalized jvm dir name: " + string);
        file = new File(string);
        file.mkdirs();
        this.log("created jvm dir");
        try {
            if (OS.isWindows()) {
                FileSystem.copyDirectory(string3, file);
                this.log("copied Windows jvm");
            } else {
                object = this.getPropertyList().getProperty("jvmSelfExtractor");
                object2 = new File(CustomInstaller.getTempDirectory(), (String)object);
                File file2 = new File(file, (String)object);
                this.log("copying jvm self-extractor to " + file2.getPath());
                FileSystem.copyFile((File)object2, file2);
                this.log("copied jvm self-extractor");
                object2.delete();
                this.log("removed original jvm self-extractor");
                File file3 = new File(file, "results.log");
                String string5 = (String)object + " -o >" + file3.getName();
                this.log("starting to expand jvm");
                Exec.launchCommand(string5, file.getPath());
                this.log("finished expanding jvm");
                file2.delete();
                file3.delete();
                this.log("changing permissions for jvm dir");
                UnixCommands.chmod("-R 0755", file.getPath());
                this.log("changed permissions to 0755 in " + file.getPath());
            }
            if (!(this.newJvmInstallationOk(file) || this.newJvmInstallationOk((File)(object = new File(file, "bin"))))) {
                bl = false;
            }
            if (bl) {
                JRE.setJavaHome(file.getPath(), System.getProperty("java.version"));
                this.getPropertyList().setProperty("nativeJvmHomeDir", file.getPath());
                this.saveNativeSettings(string3);
            }
        }
        catch (Exception var7_10) {
            bl = false;
            this.logException("Unable to install JVM in " + file.getPath(), var7_10);
        }
        return bl;
    }

    private void saveNativeSettings(String string) {
        Object object;
        PropertyList propertyList = new PropertyList();
        String string2 = this.getPropertyList().getProperty("nativeJvmHomeDir", "");
        string2 = string2.replace(File.separatorChar, '/');
        propertyList.setProperty("nativeJvmHomeDir", string2);
        propertyList.setBooleanProperty("nativeJvmInstalled", this.getPropertyList().getBooleanProperty("nativeJvmInstalled", false));
        propertyList.setBooleanProperty("nativeJvmInstalledInTemp", this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false));
        propertyList.setBooleanProperty("configureWinRegistry", this.getPropertyList().getBooleanProperty("configureWinRegistry", true));
        String string3 = string;
        string3 = string3.replace(File.separatorChar, '/');
        propertyList.setProperty("nativeTempJvmDir", string3);
        File file = new File("native.properties");
        try {
            object = new FileOutputStream(file);
            propertyList.save((OutputStream)object, "Native platform settings");
            object.close();
        }
        catch (Exception var6_7) {
            this.log(var6_7.getMessage());
        }
        if (this.isWindows()) {
            if (this.getPropertyList().getBooleanProperty("configureWinRegistry", true)) {
                string2 = string2.replace('/', File.separatorChar);
                object = System.getProperty("java.version", "");
                this.addRegistryEntry((String)object, string2);
                int n = object.lastIndexOf(".");
                if (n > 0) {
                    object = object.substring(0, n);
                    this.addRegistryEntry((String)object, string2);
                }
            } else {
                this.log("configuring registry set to false; not configuring jvm install dir");
            }
        }
    }

    private void addRegistryEntry(String string, String string2) {
        String string3 = "HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Runtime Environment" + File.separator + string;
        if (WindowsRegistry.exists(string3)) {
            this.log("registry key already exists: " + string3);
        } else {
            boolean bl = WindowsRegistry.addKey("HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Runtime Environment", string);
            this.log("added registry key: " + bl + " (" + string3 + ")");
            bl = WindowsRegistry.replaceData(string3, "JavaHome", string2);
            this.log("added JavaHome attribute: " + bl + " (" + string2 + " to " + string3 + ")");
            int n = string.lastIndexOf(".");
            if (n > 0 && n > string.indexOf(".")) {
                String string4 = string.substring(0, n);
                bl = WindowsRegistry.replaceData(string3, "MicroVersion", string4);
                this.log("added MicroVersion attribute: " + bl + " (" + string4 + " to " + string3 + ")");
            } else {
                this.log("no micro version: " + string);
            }
            bl = WindowsRegistry.replaceData(string3, "RuntimeLib", string2 + "bin\\client\\jvm.dll");
            this.log("added RuntimeLib attribute: " + bl + " (" + string2 + " to " + string3 + ")");
        }
    }

    void log(String string) {
        CustomInstaller.log(string);
        Installer.getInstaller().debug(string);
    }

    void logException(String string, Exception exception) {
        this.gotError(string);
        CustomInstaller.logException(string, exception);
    }

    void gotError(String string) {
        this.log(string);
        CustomInstaller.logError(string);
    }

    void monitor(String string) {
        this.log(string);
    }

    public String getName() {
        return "InstallJvmPanel";
    }

    public void reset() {
        this.panelFinished = false;
    }

    boolean newJvmInstallationOk(File file) {
        boolean bl = true;
        this.log("checking if new jvm is ok");
        if (OS.isWindows()) {
            File file2 = new File(file, "jre.exe");
            if (!(file2.exists() || (file2 = new File(file, "jrew.exe")).exists() || (file2 = new File(file, "java.exe")).exists() || (file2 = new File(file, "javaw.exe")).exists())) {
                bl = false;
            }
        } else {
            File file3 = new File(file, "jre");
            if (!(file3.exists() || (file3 = new File(file, "java")).exists())) {
                bl = false;
            }
        }
        this.log(file.getPath() + " is ok: " + bl);
        return bl;
    }

    private class JvmSwinger
    extends Swinger {
        private boolean ok;

        private JvmSwinger() {
        }

        public void swingBefore() {
            InstallJvmPanel.this.updateProgressBarLabel(InstallJvmPanel.this.progressMessage);
            InstallJvmPanel.this.silentInstall = InstallJvmPanel.this.getPropertyList().getBooleanProperty("silentInstall", false);
        }

        public void workInBackground() {
            this.ok = InstallJvmPanel.this.setupForInstallFiles();
            if (this.ok) {
                this.ok = InstallJvmPanel.this.copyJvmToAppDir();
            }
        }

        public void swingAfter() {
            if (this.ok) {
                InstallJvmPanel.this.moveToNextPanel();
            } else {
                InstallJvmPanel.this.nextButtonEnabled = true;
                InstallJvmPanel.this.setNextButtonEnabled(InstallJvmPanel.this.nextButtonEnabled);
                String string = Localize.strings().getString("UnableToGetFiles");
                Installer.getInstaller().logError(string);
                InstallJvmPanel.this.updateProgressBarLabel(string);
            }
        }
    }

}
