/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.FileGroup;
import com.denova.ui.FileGroupsListEditor;
import com.denova.ui.Fonts;
import com.denova.ui.GridBagControl;
import com.denova.ui.ListEditor;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;
import com.denova.util.StringConversions;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;

public class InstallMultipleTypesPanel
extends WizardPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants {
    private List choices;
    private List selectedTypes;
    private List nextTypes;

    public InstallMultipleTypesPanel(PropertyList propertyList) {
        super(propertyList);
        this.addPanel();
    }

    public synchronized void enter() {
        boolean bl = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (bl) {
            String string = this.getPropertyList().getProperty("installType", "");
            CustomInstaller.log("installType " + string);
            if (this.choices == null) {
                this.getPropertyList().setBooleanProperty("multipleFileGroups", false);
                this.getPropertyList().setBooleanProperty("multipleComponents", false);
                CustomInstaller.log("no choices defined; changing to a simple installer type");
            } else if (string == null || string.length() <= 0) {
                Iterator iterator = this.choices.iterator();
                JCheckBox jCheckBox = (JCheckBox)iterator.next();
                this.setPrimaryInstallType(jCheckBox);
            }
            this.showNextPanel();
        }
    }

    public boolean isOk() {
        boolean bl;
        Object object2;
        boolean bl2 = false;
        boolean bl3 = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (!bl3) {
            this.nextTypes.clear();
            this.getPropertyList().setProperty("nextInstallTypes", "");
            this.selectedTypes.clear();
            this.getPropertyList().setProperty("selectedInstallTypes", "");
            bl = false;
            for (Object object2 : this.choices) {
                if (!object2.isSelected()) continue;
                if (!bl) {
                    this.setPrimaryInstallType(object2);
                    this.addSelectedInstallType(object2);
                    bl = true;
                    continue;
                }
                this.addNextInstallType(object2);
                this.addSelectedInstallType(object2);
            }
        }
        bl = this.getPropertyList().getBooleanProperty("multipleFileGroups", false);
        boolean bl4 = this.getPropertyList().getBooleanProperty("multipleComponents", false);
        object2 = this.getPropertyList().getProperty("installType", "");
        bl2 = object2 != null && object2.length() > 0 || !bl && !bl4;
        return bl2;
    }

    public String getName() {
        return "InstallMultipleTypesPanel";
    }

    private void addPanel() {
        this.choices = new Vector();
        this.selectedTypes = new Vector();
        this.nextTypes = new Vector();
        this.setLayout(new BorderLayout());
        if (CustomInstaller.isOpaque()) {
            EmptyBorder emptyBorder = new EmptyBorder(20, 20, 20, 20);
            this.setBorder(emptyBorder);
        }
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        JLabel jLabel = new JLabel(Localize.strings().getString("SelectInstallType"));
        Fonts.setFont(jLabel, Fonts.Big);
        gridBagControl.addCentered(jLabel);
        gridBagControl.endRow();
        GridBagConstraints gridBagConstraints = gridBagControl.getConstraints();
        gridBagConstraints.fill = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        JScrollPane jScrollPane = new JScrollPane();
        jScrollPane.getViewport().add(this.createTypesList());
        Dimension dimension = new Dimension(300, 100);
        jScrollPane.getViewport().setPreferredSize(dimension);
        gridBagControl.endRow(gridBagConstraints, jScrollPane);
        this.add(transparentJPanel);
    }

    private TransparentJPanel createTypesList() {
        Object object;
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.anchor = 17;
        GridBagConstraints gridBagConstraints2 = GridBagControl.getDefaultConstraints();
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.weighty = 1.0;
        gridBagConstraints2.fill = 1;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        if (CustomInstaller.isOpaque()) {
            object = new EmptyBorder(20, 20, 20, 20);
            transparentJPanel.setBorder((Border)object);
        }
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        object = new Item();
        boolean bl = true;
        FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
        fileGroupsListEditor.fromString(this.getPropertyList().getProperty("fileGroupsTypes", ""));
        for (FileGroup fileGroup : fileGroupsListEditor.getItems()) {
            JCheckBox jCheckBox = new JCheckBox(fileGroup.getName(), bl);
            jCheckBox.addItemListener((ItemListener)object);
            JLabel jLabel = new JLabel(fileGroup.getDescription());
            gridBagControl.add(gridBagConstraints, jCheckBox);
            gridBagControl.addBlankCell();
            gridBagControl.endRow(gridBagConstraints2, jLabel);
            this.choices.add(jCheckBox);
            bl = false;
        }
        return transparentJPanel;
    }

    private void setPrimaryInstallType(Object object) {
        JCheckBox jCheckBox = (JCheckBox)object;
        if (jCheckBox.isSelected()) {
            this.getPropertyList().setProperty("installType", jCheckBox.getText());
        }
    }

    private void addNextInstallType(Object object) {
        JCheckBox jCheckBox = (JCheckBox)object;
        if (jCheckBox.isSelected()) {
            this.nextTypes.add(jCheckBox.getText());
            String string = StringConversions.fromList(this.nextTypes);
            this.getPropertyList().setProperty("nextInstallTypes", string);
        }
    }

    private void addSelectedInstallType(Object object) {
        JCheckBox jCheckBox = (JCheckBox)object;
        if (jCheckBox.isSelected()) {
            this.selectedTypes.add(jCheckBox.getText());
            String string = StringConversions.fromList(this.selectedTypes);
            this.getPropertyList().setProperty("selectedInstallTypes", string);
            CustomInstaller.log("installType selected " + jCheckBox.getText());
        }
    }

    private class Item
    implements ItemListener {
        private Item() {
        }

        public void itemStateChanged(ItemEvent itemEvent) {
        }
    }

}
