/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.AutoStartMenusPanel;
import com.denova.JExpress.Installer.BuyLicensePanel;
import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.DirectoryPanel;
import com.denova.JExpress.Installer.FinalPanel;
import com.denova.JExpress.Installer.GetCredentialsPanel;
import com.denova.JExpress.Installer.GetProxyPanel;
import com.denova.JExpress.Installer.InstallFilesPanel;
import com.denova.JExpress.Installer.InstallJvmPanel;
import com.denova.JExpress.Installer.InstallMultipleTypesPanel;
import com.denova.JExpress.Installer.InstallNextComponent;
import com.denova.JExpress.Installer.InstallNextTypePanel;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallSingleTypePanel;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.LaunchAppPanel;
import com.denova.JExpress.Installer.LicensePanel;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.MenuUtilities;
import com.denova.JExpress.Installer.MenusPanel;
import com.denova.JExpress.Installer.NoAskDirPanel;
import com.denova.JExpress.Installer.PasswordPanel;
import com.denova.JExpress.Installer.ReadMePanel;
import com.denova.JExpress.Installer.SaveLicenseInfoPanel;
import com.denova.JExpress.Installer.UninstallPanel;
import com.denova.JExpress.Installer.VerifyLicensePanel;
import com.denova.JExpress.Installer.WelcomePanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.ErrorLog;
import com.denova.io.FileGroup;
import com.denova.io.Log;
import com.denova.runtime.MacOS;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsRegistry;
import com.denova.ui.FileGroupsListEditor;
import com.denova.ui.ListEditor;
import com.denova.ui.Wizard;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;
import java.awt.Color;
import java.io.File;
import java.util.Date;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.JButton;

public class InstallWizard
extends Wizard
implements JExpressConstants,
InstallPropertyNames,
Runnable {
    private static Log log = new Log("installwizard");
    private boolean silentInstall = false;
    private Installer installer;
    private boolean showInstallNowButtonOnDirectoryPanel = true;
    private Color backgroundColor = null;

    InstallWizard(Installer installer) {
        this.installer = installer;
    }

    public void buildWizard() {
        boolean bl = false;
        boolean bl2 = this.getPropertyList().getBooleanProperty("clickFreeInstaller", false);
        if (bl2) {
            this.setIncludeButtons(false);
        }
        this.createPanel();
        this.setDefaultPreviousButtonLabel(Localize.strings().getString("BackButton"));
        this.setDefaultNextButtonLabel(Localize.strings().getString("NextButton"));
        this.setDefaultCancelButtonLabel(Localize.strings().getString("CancelButton"));
        this.setDefaultFinishedButtonLabel(Localize.strings().getString("FinishedButton"));
        if (this.installerReady() && this.okToStart()) {
            if (this.installer.passwordRequired()) {
                this.addPanel(new PasswordPanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customBeforeInstallWizardPanelClass");
            if (this.getPropertyList().getBooleanProperty("showWelcomePanel", true)) {
                this.addPanel(new WelcomePanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterWelcomeWizardPanelClass");
            if (this.installer.fileSpecified("installLicenseFilename") && !bl2) {
                this.addPanel(new LicensePanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterLicenseWizardPanelClass");
            if (this.installer.fileSpecified("installReadmeFilename") && !bl2) {
                this.addPanel(new ReadMePanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterReadMeWizardPanelClass");
            if (this.installer.multipleFileGroups() || this.installer.multipleComponents()) {
                if (this.installer.multipleFileGroups() && this.installer.singleInstallType()) {
                    this.addPanel(new InstallSingleTypePanel(this.getPropertyList()));
                } else {
                    this.addPanel(new InstallMultipleTypesPanel(this.getPropertyList()));
                }
                this.addCustomWizardPanel("customAfterMultipleInstallsWizardPanelClass");
            }
            if (this.installer.isServlet()) {
                this.addMultipleAppDirectoryPanels();
            } else {
                if (!this.getPropertyList().getBooleanProperty("promptForInstallDir", true)) {
                    this.addPanel(new NoAskDirPanel(this.getPropertyList()));
                }
                this.addPanel(new DirectoryPanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterDirectoryWizardPanelClass");
            if (this.checkLicenseDuringInstall() || this.checkLicenseDuringUpdate() || this.checkLicenseDuringApp()) {
                this.addPanel(new GetCredentialsPanel(this.getPropertyList()));
                if (this.checkLicenseDuringInstall()) {
                    this.addPanel(new GetProxyPanel(this.getPropertyList()));
                    this.addPanel(new VerifyLicensePanel(this.getPropertyList()));
                    this.addPanel(new BuyLicensePanel(this.getPropertyList()));
                }
                if (this.checkLicenseDuringUpdate() || this.checkLicenseDuringApp()) {
                    bl = true;
                }
            }
            if (this.getPropertyList().getBooleanProperty("nativeJvmInstalledInTemp", false)) {
                this.addPanel(new InstallJvmPanel(this.getPropertyList()));
            }
            if (this.needToUninstallOldVersion()) {
                // empty if block
            }
            this.addPanel(new InstallFilesPanel(this.getPropertyList()));
            if (this.installer.multipleFileGroups() && this.installer.multipleInstallTypes()) {
                this.addPanel(new InstallNextTypePanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterFilesInstalledWizardPanelClass");
            this.addPanel(new MenusPanel(this.getPropertyList()));
            if (bl) {
                this.addPanel(new SaveLicenseInfoPanel(this.getPropertyList()));
            }
            if (this.needAutoStartMenus()) {
                this.addPanel(new AutoStartMenusPanel(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterMenusWizardPanelClass");
            this.addPanel(new UninstallPanel(this.getPropertyList()));
            if (Installer.getInstaller().isServlet()) {
                this.setEnabledNamedPanel("UninstallPanel", false);
            }
            if (this.installer.multipleComponents()) {
                this.addPanel(new InstallNextComponent(this.getPropertyList()));
            }
            this.addCustomWizardPanel("customAfterInstallWizardPanelClass");
            this.addFinalPanel();
            if (this.backgroundColor != null) {
                this.setBackgroundColor(this.backgroundColor);
            }
            this.setInstallButton();
        } else {
            this.installer.exit();
        }
    }

    public void startWizard() {
        if (this.silentInstall) {
            this.logPanelNames();
            new Thread(this).start();
        } else {
            super.startWizard();
        }
    }

    public void cancel() {
        this.cancel(true);
    }

    public void cancel(boolean bl) {
        boolean bl2 = true;
        boolean bl3 = this.getCancelButton().isEnabled();
        boolean bl4 = this.getPreviousButton().isEnabled();
        boolean bl5 = this.getNextButton().isEnabled();
        if (bl && !this.silentInstall) {
            this.getCancelButton().setEnabled(false);
            this.getPreviousButton().setEnabled(false);
            this.getNextButton().setEnabled(false);
            String string = Localize.strings().getString("Warning");
            String string2 = Localize.strings().getString("StopNow");
            String string3 = Localize.strings().getString("Continue");
            Vector<String> vector = new Vector<String>();
            vector.add(Localize.strings().getString("IncompleteInstall"));
            bl2 = InstallerPopups.ask(string, Localize.strings().getString("WantToStopInstall"), vector, string2, string3, string2);
        }
        if (bl2) {
            this.installer.setInvisible();
            this.installer.log("user canceled");
            super.cancel();
            this.installer.exit();
        } else {
            this.getCancelButton().setEnabled(bl3);
            this.getPreviousButton().setEnabled(bl4);
            this.getNextButton().setEnabled(bl5);
        }
    }

    public void abort() {
        this.installer.log("aborting installer");
        super.abort();
        this.installer.exit();
    }

    public void finish() {
        this.installer.exit();
    }

    public boolean showInstallButtonOnDirectoryPanel() {
        return this.showInstallNowButtonOnDirectoryPanel;
    }

    public void setSilent(boolean bl) {
        log.write("setSilent(" + bl + ")");
        this.silentInstall = bl;
    }

    public boolean getSilent() {
        return this.silentInstall;
    }

    public void run() {
        log.write("silent install");
        this.panelIndex = 0;
        this.mostRecentPanelIndex = 0;
        this.showPanel(this.panelIndex);
        while (this.panelIndex < this.getPanels().size()) {
            OS.sleep(1000);
            int n = this.panelIndex;
            WizardPanel wizardPanel = this.getPanel(n);
            while (!(n != this.panelIndex || wizardPanel.getNextButton().isEnabled())) {
                Thread.yield();
                OS.sleep(100);
            }
            if (n == this.panelIndex) {
                log.write("run (): about to show next panel");
                this.showNext();
            }
            Thread.yield();
        }
        log.write("thread done");
    }

    public String getButtonsPosition() {
        return this.getPropertyList().getProperty("installButtonsPosition", super.getButtonsPosition());
    }

    protected void paintPanel(String string) {
        if (!this.silentInstall) {
            super.paintPanel(string);
        }
    }

    protected void setCustomBackgroundColor(Color color) {
        this.backgroundColor = color;
    }

    protected boolean needToUninstallOldVersion() {
        boolean bl = false;
        if (OS.isWindows()) {
            bl = this.needToUninstallOldWinVersion();
        }
        return bl;
    }

    private boolean needToUninstallOldWinVersion() {
        boolean bl = false;
        if (OS.isSecureWindows()) {
            String string = this.getPropertyList().getProperty("packageName", "");
            String string2 = string.trim();
            if (CustomInstaller.multipleComponents()) {
                string2 = this.getPropertyList().getProperty("installType").trim();
            }
            String string3 = "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall" + File.separator + string2;
            bl = WindowsRegistry.exists(string3);
            log.write("need to uninstall old version: " + bl);
            if (bl) {
                File file;
                String string4 = WindowsRegistry.getStringData(string3, "UninstallString");
                if (string4.endsWith(" -q")) {
                    int n = string4.lastIndexOf(" -q");
                    string4 = string4.substring(0, n);
                }
                if (bl = (file = new File(string4)).exists()) {
                    if (!(string4.indexOf(" ") <= 0 || string4.startsWith("\""))) {
                        string4 = "\"" + string4 + "\"";
                    }
                    this.getPropertyList().setProperty("uninstallCommand", string4 + " " + "-q");
                    log.write("uninstall command: " + string4);
                } else {
                    log.write("uninstaller doesn't exist: " + string4);
                }
            }
        }
        return bl;
    }

    private void addFinalPanel() {
        String string = this.getPropertyList().getProperty("startAppName", "");
        if (!(string.length() <= 0 || this.getPropertyList().getBooleanProperty("userRequestedSilentInstall", false))) {
            this.addPanel(new LaunchAppPanel(this.getPropertyList()));
        } else {
            this.addPanel(new FinalPanel(this.getPropertyList()));
        }
    }

    private boolean checkLicenseDuringInstall() {
        return "QzxQzxCheckInstall".equals("true") || this.getPropertyList().getBooleanProperty("checkLicenseDuringInstall", false);
    }

    private boolean checkLicenseDuringUpdate() {
        return "QzxQzxCheckUpdate".equals("true") || this.getPropertyList().getBooleanProperty("checkLicenseDuringUpdate", false);
    }

    private boolean checkLicenseDuringApp() {
        return "QzxQzxCheckApp".equals("true") || this.getPropertyList().getBooleanProperty("checkLicenseFromYourApp", false);
    }

    private boolean needAutoStartMenus() {
        boolean bl = false;
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        boolean bl2 = false;
        for (String string : propertyList.propertyNamesList()) {
            String string2 = propertyList.getProperty(string);
            if (string2 == null) continue;
            PropertyList propertyList2 = new PropertyList();
            propertyList2.fromString(string2);
            if (!MenuUtilities.menuOk(propertyList2, this.getPropertyList())) continue;
            if (!bl) {
                bl = propertyList2.getBooleanProperty("menuAutoStartup", false);
            }
            if (bl2 || propertyList2.getBooleanProperty("menuInstallAsService", false) || !propertyList2.getBooleanProperty("menuStartAfterInstall", false)) continue;
            bl2 = true;
            this.getPropertyList().setProperty("startAppName", string);
        }
        log.write("menuAutoStartup: " + bl);
        return bl;
    }

    private boolean installerReady() {
        boolean bl;
        block6 : {
            bl = true;
            String string = this.installer.getProperty("customBeforeInstallWizardPanelClass", "");
            if (string.startsWith("com.denova.JExpress.Installer.JExpressCustomClass")) {
                try {
                    Vector<String> vector = new Vector<String>();
                    vector.add("If not, this is an unlicensed copy of this installation software.");
                    vector.add("The installer is only licensed by DeNova for the developer's in-house evaluation, and this notice does not appear with a purchased license.");
                    boolean bl2 = this.getPropertyList().getBooleanProperty("silentInstall", false);
                    this.getPropertyList().setBooleanProperty("silentInstall", false);
                    bl = InstallerPopups.ask(Localize.strings().getString("Warning"), "Did you create this installer?", vector, Localize.strings().getString("No"));
                    if (bl) {
                        Date date = new Date();
                        Long l = new Long(this.getPropertyList().getProperty("secs"));
                        long l2 = l;
                        Date date2 = new Date(l2 + 518400000);
                        boolean bl3 = bl = !date.after(date2);
                    }
                    if (bl) {
                        this.getPropertyList().setBooleanProperty("silentInstall", bl2);
                        this.installer.log("restored silent install to: " + String.valueOf(this.getPropertyList().getBooleanProperty("silentInstall", false)));
                        break block6;
                    }
                    this.installer.fatalError("Exiting. This installer may only be used for in-house evaluation, and for 5 days after it was created.");
                }
                catch (Exception var10_4) {
                    bl = false;
                    this.installer.fatalError("Exiting trial installer. Contact support@denova.com");
                    ErrorLog.getLog().write(var10_4);
                }
            } else {
                bl = true;
            }
        }
        return bl;
    }

    private boolean okToStart() {
        boolean bl = this.packVersionOk();
        if (bl && OS.isMacOsX()) {
            bl = this.macJvmVersionOk();
        }
        return bl;
    }

    private boolean packVersionOk() {
        boolean bl = true;
        String string = System.getProperty("java.version", "");
        if (this.getPropertyList().getBooleanProperty("packJarFile", false) && string.compareTo("1.5") < 0) {
            bl = false;
            String string2 = Localize.strings().getString("Pack200BadJvmVersion");
            this.logError(string2);
            this.logError("Wrong jvm version to unpack jar files; jvm version: " + string);
            this.installer.fatalError(string2);
        }
        return bl;
    }

    private boolean macJvmVersionOk() {
        String string;
        boolean bl = true;
        String string2 = this.getPropertyList().getProperty("jvmRequiredVersion", "");
        String string3 = this.getPropertyList().getProperty("jvmMinVersion", "");
        String string4 = this.getPropertyList().getProperty("jvmMaxVersion", "");
        boolean bl2 = false;
        File file = new File("/System/Library/Frameworks/JavaVM.framework/Versions");
        String[] arrstring = file.list();
        if (arrstring != null) {
            for (int i = 0; !(i >= arrstring.length || bl2); ++i) {
                string = arrstring[i];
                if (!this.macDirIsVersion(string)) continue;
                bl2 = this.macVersionOk(string, string2, string3, string4);
            }
        }
        if (!bl2) {
            bl = false;
            String string5 = MacOS.getJvmVersion(string2, string3, string4);
            string = Localize.strings().getString("UpgradeMacJvm", string5);
            this.logError(string);
            if (string2.length() > 0) {
                this.logError("Required version: " + string2);
            } else {
                this.logError("Min version: " + string3 + " Max version: " + string4);
            }
            this.installer.fatalError(string);
        }
        return bl;
    }

    private boolean macDirIsVersion(String string) {
        boolean bl;
        if (string == null || string.length() < 1) {
            bl = false;
        } else {
            int n = Character.getType(string.charAt(0));
            boolean bl2 = bl = n == 9;
            if (!bl) {
                this.installer.log("Rejecting possible jvm dir: " + string);
            }
        }
        return bl;
    }

    private boolean macVersionOk(String string, String string2, String string3, String string4) {
        boolean bl = string2.length() > 0 ? string.equalsIgnoreCase(string2) : (string4.length() > 0 ? string.compareTo(string3) >= 0 && string.compareTo(string4) <= 0 : string.compareTo(string3) >= 0);
        this.installer.log("version " + string + ": " + bl);
        return bl;
    }

    private void setInstallButton() {
        String string = this.getPropertyList().getProperty("customAfterDirectoryWizardPanelClass", "").trim();
        if (string != null && string.length() > 0 || this.checkLicenseDuringInstall() || this.checkLicenseDuringUpdate() || this.checkLicenseDuringApp()) {
            this.showInstallNowButtonOnDirectoryPanel = false;
        }
    }

    private void addCustomWizardPanel(String string) {
        String string2 = this.installer.getProperty(string, "");
        StringTokenizer stringTokenizer = new StringTokenizer(string2);
        while (stringTokenizer.hasMoreTokens()) {
            String string3 = stringTokenizer.nextToken();
            if (string3.length() <= 0) continue;
            if (string3.endsWith(".class")) {
                int n = string3.length() - ".class".length();
                string3 = string3.substring(0, n);
            }
            if (string3.equalsIgnoreCase("com.denova.JExpress.Installer.JExpressCustomClass")) continue;
            this.addCustomClassPanel(string3);
        }
    }

    private void addCustomClassPanel(String string) {
        try {
            Class class_ = Class.forName(string);
            Object[] arrobject = null;
            Constructor constructor = this.getConstructorWithProps(class_, string);
            if (constructor == null) {
                constructor = this.getConstructorWithPropsAndLog(class_, string);
                if (constructor != null) {
                    arrobject = new Object[]{this.getPropertyList(), ErrorLog.getLog()};
                }
            } else {
                arrobject = new Object[]{this.getPropertyList()};
            }
            if (constructor == null) {
                this.logError("Invalid constructors for " + string);
            } else {
                try {
                    this.addPanel((WizardPanel)constructor.newInstance(arrobject));
                }
                catch (Exception var5_7) {
                    this.logError("Error while adding panel for " + string, var5_7);
                }
            }
        }
        catch (ClassNotFoundException var2_3) {
            this.logError("Unable to find class: " + string, var2_3);
        }
        catch (Exception var2_4) {
            this.logError("Unexpected error loading: " + string, var2_4);
        }
    }

    private Constructor getConstructorWithProps(Class class_, String string) {
        Constructor constructor = null;
        try {
            Class class_2 = Class.forName("com.denova.util.PropertyList");
            Class[] arrclass = new Class[]{class_2};
            constructor = class_.getConstructor(arrclass);
            this.installer.log("Added " + string + " with properties parameter");
        }
        catch (NoSuchMethodException var4_5) {
            this.installer.log("No matching constructor with only properites for " + string);
        }
        catch (Exception var4_6) {
            this.installer.log("Unexpected error getting constructor with properties for  \"" + string + "\"" + " " + var4_6.getMessage());
        }
        return constructor;
    }

    private Constructor getConstructorWithPropsAndLog(Class class_, String string) {
        Constructor constructor = null;
        try {
            Class class_2 = Class.forName("com.denova.util.PropertyList");
            Class class_3 = Class.forName("com.denova.io.Log");
            Class[] arrclass = new Class[]{class_2, class_3};
            constructor = class_.getConstructor(arrclass);
            this.installer.log("Added " + string + " with properties and error log parameters");
        }
        catch (NoSuchMethodException var4_5) {
            this.installer.log("No matching constructor with only properites and error log for " + string);
        }
        catch (Exception var4_6) {
            this.installer.log("Unexpected error getting constructor with properties for  \"" + string + "\"" + " " + var4_6.getMessage());
        }
        return constructor;
    }

    private void addMultipleAppDirectoryPanels() {
        FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
        fileGroupsListEditor.fromString(this.getPropertyList().getProperty("fileGroupsTypes", ""));
        for (FileGroup fileGroup : fileGroupsListEditor.getItems()) {
            if (!this.getPropertyList().getBooleanProperty("promptForInstallDir", true)) {
                this.addPanel(new NoAskDirPanel(this.getPropertyList(), fileGroup.getName(), fileGroup.getDescription()));
            }
            this.addPanel(new DirectoryPanel(this.getPropertyList(), fileGroup.getName(), fileGroup.getDescription()));
        }
    }

    private PropertyList getPropertyList() {
        return this.installer.getPropertyList();
    }

    private void logError(String string) {
        ErrorLog.getLog().write(string);
    }

    private void logError(Exception exception) {
        ErrorLog.getLog().write(exception.toString());
    }

    private void logError(String string, Exception exception) {
        ErrorLog.getLog().write(string);
        ErrorLog.getLog().write(exception);
    }
}
