/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.TextPanel;
import com.denova.io.Log;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.util.PropertyList;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.JCheckBox;

public class LicensePanel
extends TextPanel {
    private static final Log log = new Log("licensepanel");
    private JCheckBox agreeCheckBox;

    public LicensePanel(PropertyList propertyList) {
        super(propertyList, propertyList.getProperty("installLicenseFilename"));
    }

    public boolean isOk() {
        boolean bl = this.agreed();
        boolean bl2 = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (bl2) {
            bl = true;
            log.write("silent install");
        } else {
            log.write("ok: " + bl);
        }
        return bl;
    }

    public boolean isNextButtonEnabled() {
        boolean bl = super.isNextButtonEnabled() && this.agreed();
        log.write("isNextButtonEnabled: " + bl);
        return bl;
    }

    public void setNextButtonEnabled(boolean bl) {
        super.setNextButtonEnabled(bl && this.agreed());
    }

    public String getName() {
        return "LicensePanel";
    }

    protected TransparentJPanel getPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        GridBagConstraints gridBagConstraints = gridBagControl.getConstraints();
        gridBagConstraints.fill = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagControl.endRow(gridBagConstraints, super.getPanel());
        String string = Localize.strings().getString("AgreeButton");
        this.agreeCheckBox = new JCheckBox(string, false);
        this.agreeCheckBox.setIconTextGap(this.agreeCheckBox.getIconTextGap() * 2);
        this.agreeCheckBox.setEnabled(false);
        ItemStateListener itemStateListener = new ItemStateListener();
        this.agreeCheckBox.addItemListener(itemStateListener);
        gridBagControl.endRow(this.agreeCheckBox);
        log.write("agree: " + this.agreed());
        return transparentJPanel;
    }

    protected void showText() {
        super.showText();
        this.agreeCheckBox.setEnabled(true);
        if (!this.agreeCheckBox.isSelected()) {
            this.agreeCheckBox.requestFocusInWindow();
        }
    }

    protected void quitAfterFailure() {
        this.log("got error; showing last active panel");
        this.showLastActivePanel();
    }

    private boolean agreed() {
        return this.agreeCheckBox.isSelected();
    }

    private class ItemStateListener
    implements ItemListener {
        private ItemStateListener() {
        }

        public void itemStateChanged(ItemEvent itemEvent) {
            Object object = itemEvent.getSource();
            if (object == LicensePanel.this.agreeCheckBox) {
                LicensePanel.this.setNextButtonEnabled(LicensePanel.this.agreed());
            }
        }
    }

}
