/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.FileGroup;
import com.denova.io.JarFile;
import com.denova.io.Log;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsJavaApp;
import com.denova.ui.FileGroupsListEditor;
import com.denova.ui.ListEditor;
import com.denova.util.PropertyList;
import com.denova.util.StringConversions;
import java.io.File;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

public class MenuUtilities
implements JExpressConstants,
InstallerConstants,
InstallPropertyNames {
    public static final char BackSlash = '\\';
    public static final char ForwardSlash = '/';
    private static Installer installer = Installer.getInstaller();
    private static Log log;

    public static void setLog() {
        log = new Log("menus");
    }

    public static boolean menuOk(PropertyList propertyList, PropertyList propertyList2) {
        boolean bl = true;
        String string = propertyList.getProperty("longName", "").trim();
        String string2 = propertyList.getProperty("shortName", "").trim();
        String string3 = string;
        if (string3.length() <= 0) {
            string3 = string2;
        }
        boolean bl2 = propertyList.getBooleanProperty("windowsMenu", string.trim().length() > 0);
        boolean bl3 = propertyList.getBooleanProperty("macMenu", string.trim().length() > 0);
        boolean bl4 = propertyList.getBooleanProperty("unixMenu", string2.trim().length() > 0);
        if (OS.isWindows()) {
            if (bl2 && string.length() > 0) {
                bl = true;
            } else {
                bl = false;
                MenuUtilities.logMessage(string3 + " is not to be installed on Windows");
            }
        } else if (OS.isMac()) {
            if (bl3) {
                if (string.length() > 0) {
                    if (string2.length() <= 0) {
                        string2 = string.replace(' ', '.').toLowerCase();
                        propertyList.setProperty("shortName", string2);
                        MenuUtilities.logMessage("Added a short name for menu named: " + string);
                    }
                } else {
                    string = string2.replace(' ', '.');
                    propertyList.setProperty("longName", string);
                    MenuUtilities.logMessage("Added a long name for menu named: " + string2);
                }
                string3 = string;
                bl = true;
            } else {
                bl = false;
                MenuUtilities.logMessage(string3 + " is not to be installed on Mac");
            }
        } else if (OS.isUnix()) {
            if (bl4) {
                if (string2.length() <= 0) {
                    string2 = string.replace(' ', '.').toLowerCase();
                }
                bl = true;
            } else {
                bl = false;
                MenuUtilities.logMessage(string3 + " is not to be installed on unix");
            }
        } else {
            bl = false;
            MenuUtilities.logMessage(string + " is not been set to install on any OS.");
        }
        if (bl && (CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents()) || CustomInstaller.multipleDirInstall()) {
            String string4 = propertyList.getProperty("associatedInstallType", "").trim();
            bl = MenuUtilities.multiMenuOk(string3, string4, propertyList2);
        }
        return bl;
    }

    public static String getShortName(String string) {
        String string2 = string;
        if (string != null) {
            string2 = string2.replace(' ', '.');
            string2 = string2.replace('\"', '.');
            string2 = string2.replace('\'', ',');
            string2 = string2.replace('!', '.');
            string2 = string2.replace('(', '.');
            string2 = string2.replace(')', '.');
            string2 = string2.replace('@', '.');
            string2 = string2.replace('#', '.');
            string2 = string2.replace('$', '.');
            string2 = string2.replace('%', '.');
            string2 = string2.replace('&', '.');
            string2 = string2.replace('\\', '.');
            string2 = string2.replace('/', '.');
            string2 = string2.replace('*', '.');
            string2 = string2.replace('+', '.');
            string2 = string2.replace('=', '.');
            string2 = string2.replace('>', '.');
            string2 = string2.replace('<', '.');
            string2 = string2.replace('{', '.');
            string2 = string2.replace('}', '.');
            string2 = string2.replace('[', '.');
            string2 = string2.replace(']', '.');
        }
        return string2;
    }

    public static String getIconFilename(String string) {
        String string2 = null;
        String string3 = installer.getProperty("applicationDirectory", "");
        if (string != null && string.length() > 0) {
            string = string.replace('/', File.separatorChar);
            string = string.replace('\\', File.separatorChar);
            File file = new File(string);
            File file2 = new File(string3, "JExpress");
            File file3 = new File(file2, file.getName());
            string2 = file3.getPath();
            MenuUtilities.logMessage("Path to local icon basename: " + string2);
        } else {
            string2 = "";
            MenuUtilities.logMessage("No icon file specified for menu");
        }
        return string2;
    }

    public static String getIconFilename(String string, String string2) {
        String string3 = "";
        String string4 = installer.getProperty("applicationDirectory", "");
        if (string != null && string.length() > 0) {
            File file;
            File file2;
            File file3;
            String string5 = "." + string2;
            if (!string.endsWith(string5)) {
                string = string + string5;
            }
            if (!((file = new File(file3 = new File(string4, "JExpress"), (file2 = new File("JExpress", string)).getName())).exists() && file.length() != 0)) {
                MenuUtilities.extractIconFile(file2, file3);
            }
            if (file.exists()) {
                string3 = file.getPath();
            } else {
                MenuUtilities.logMessage("Unable to extract icon file: " + file2.getName());
                string3 = "";
            }
        } else {
            string3 = "";
        }
        MenuUtilities.logMessage("full icon filename: " + string3);
        return string3;
    }

    public static String getWindowsIconFilename(String string) {
        String string2 = MenuUtilities.getIconFilename(string, "ico");
        if (string2 == null || string2.length() <= 0) {
            string2 = MenuUtilities.getIconFilename(string, "png");
        }
        return string2;
    }

    public static String getKdeIconFilename(String string) {
        String string2 = MenuUtilities.getIconFilename(string, "png");
        if (string2 == null || string2.length() <= 0) {
            string2 = MenuUtilities.getIconFilename(string, "xpm");
        }
        return string2;
    }

    public static File getJavaAppTemplate(boolean bl) {
        File file = null;
        try {
            file = bl ? WindowsJavaApp.getAdminFile() : WindowsJavaApp.getRegularFile();
            if (file == null) {
                MenuUtilities.logMessage("unable to get java app template");
            } else {
                MenuUtilities.logMessage("java app template: " + file);
            }
        }
        catch (Exception var2_2) {
            log.write(var2_2);
        }
        return file;
    }

    public static String removeBlanks(String string) {
        String string2 = string;
        int n = string2.indexOf(" ");
        while (n > -1) {
            string2 = string2.substring(0, n) + string2.substring(n + 1);
            n = string2.indexOf(" ");
        }
        return string2;
    }

    public static String changeBlanks2Periods(String string) {
        String string2 = string;
        int n = string2.indexOf(" ");
        while (n > -1) {
            string2 = string2.substring(0, n) + "." + string2.substring(n + 1);
            n = string2.indexOf(" ");
        }
        return string2;
    }

    private static boolean extractIconFile(File file, File file2) {
        boolean bl = true;
        try {
            JarFile jarFile = null;
            String string = installer.getProperty("safePackageName") + "Jex" + "." + "jar";
            File file3 = new File(file2.getParent());
            try {
                jarFile = new JarFile(file3, string);
                jarFile.unarchiveFileToDirectory(file.getName(), file2);
                jarFile.close();
                jarFile = null;
                MenuUtilities.logMessage(file.getName() + " extracted from " + string + " to " + file2);
            }
            catch (Exception var6_7) {
                log.write(var6_7);
                if (installer.getResourceAsFile(file.getName(), file2.getPath())) {
                    MenuUtilities.logMessage(file.getName() + " extracted from resources to " + file2);
                }
                String string2 = "Unable to extract " + file.getName() + " from " + string;
                MenuUtilities.logMessage(string2);
                bl = false;
            }
            if (jarFile != null) {
                try {
                    jarFile.close();
                }
                catch (Exception var6_8) {
                    log.write(var6_8);
                }
            }
        }
        catch (Exception var3_4) {
            log.write(var3_4);
        }
        return bl;
    }

    public static void logMessage(String string) {
        if (log != null) {
            log.write(string);
        }
    }

    public static Log getLog() {
        return log;
    }

    private static boolean multiMenuOk(String string, String string2, PropertyList propertyList) {
        boolean bl = false;
        if (string2.length() > 0) {
            MenuUtilities.logMessage(string + " is associated with " + string2);
            if (CustomInstaller.multipleFileGroups() && CustomInstaller.singleInstallType()) {
                String string3 = propertyList.getProperty("installType", "").trim();
                bl = string3.equals(string2);
                if (!bl) {
                    MenuUtilities.logMessage(string + " is not associated with the install type: " + string3);
                }
            } else if (CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents()) {
                String string4 = propertyList.getProperty("selectedInstallTypes", "");
                List list = StringConversions.toList(string4);
                bl = list.contains(string2);
                if (!bl) {
                    MenuUtilities.logMessage(string + " is not associated with any of the selected install types");
                }
            } else if (CustomInstaller.multipleDirInstall()) {
                FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
                fileGroupsListEditor.fromString(propertyList.getProperty("fileGroupsTypes", ""));
                Iterator iterator = fileGroupsListEditor.getItems().iterator();
                while (iterator.hasNext() && !bl) {
                    FileGroup fileGroup = (FileGroup)iterator.next();
                    bl = string2.equals(fileGroup.getName());
                    if (!bl) continue;
                    String string5 = propertyList.getProperty("applicationDirectory" + fileGroup.getName(), "");
                    propertyList.setProperty("applicationDirectory", string5);
                    MenuUtilities.logMessage("menu's directory name: " + string5);
                }
                if (!bl) {
                    MenuUtilities.logMessage(string + " is not associated with known target directory. It is associated with: " + string2);
                }
            }
        } else {
            bl = true;
            MenuUtilities.logMessage(string + " is not associated with any component so it's always installed");
        }
        return bl;
    }
}
