/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.VerifyDirectory;
import com.denova.io.Log;
import com.denova.ui.Swinger;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;

public class NoAskDirPanel
extends WizardPanel
implements InstallPropertyNames {
    private String component = null;
    private static Log log = new Log("noaskdir.log");

    public NoAskDirPanel(PropertyList propertyList) {
        super(propertyList);
        this.component = "";
    }

    public NoAskDirPanel(PropertyList propertyList, String string, String string2) {
        super(propertyList);
        this.component = string;
    }

    public synchronized void enter() {
        if (this.getPropertyList().getBooleanProperty("silentInstall", false) && this.getPropertyList().getProperty("applicationDirectory") != null) {
            this.showNextPanel();
        } else {
            DirSwinger dirSwinger = new DirSwinger();
            dirSwinger.execute();
        }
    }

    public int getEstimatedTime() {
        return 30;
    }

    public String getName() {
        String string = "NoAskDirPanel";
        if (this.component != null && CustomInstaller.multipleDirInstall()) {
            string = string + this.component;
        }
        return string;
    }

    public void reset() {
        super.reset();
        if (CustomInstaller.multipleDirInstall()) {
            this.getPropertyList().removeProperty("applicationDirectory" + this.component);
        } else {
            this.getPropertyList().removeProperty("applicationDirectory");
        }
        this.getPropertyList().removeProperty("oldApplicationDirectory");
    }

    private class DirSwinger
    extends Swinger {
        private DirSwinger() {
        }

        public void workInBackground() {
            boolean bl = false;
            try {
                if (CustomInstaller.multipleComponents()) {
                    NoAskDirPanel.this.component = NoAskDirPanel.this.getPropertyList().getProperty("installType", "");
                    log.write("multiple component: " + NoAskDirPanel.this.component);
                }
                VerifyDirectory.setSilentOverwrte(true);
                String string = VerifyDirectory.getDefaultInstallationDirectory(NoAskDirPanel.this.component, NoAskDirPanel.this.getPropertyList());
                if (string == null) {
                    log.write("unable to get default installation directory");
                } else {
                    bl = VerifyDirectory.isOk(string, NoAskDirPanel.this.component, NoAskDirPanel.this.getPropertyList());
                    if (bl) {
                        log.write("set installation directory: " + string);
                        String string2 = "DirectoryPanel";
                        if (CustomInstaller.multipleDirInstall() && NoAskDirPanel.this.component != null) {
                            string2 = string2 + NoAskDirPanel.this.component;
                        }
                        NoAskDirPanel.this.setEnabledNamedPanel(string2, false);
                        log.write("disabled: " + string2);
                    } else {
                        log.write("unable to get preset installation directory");
                    }
                }
                if (!bl && NoAskDirPanel.this.getPropertyList().getBooleanProperty("abortIfErrorWithDefaultInstallDir", false)) {
                    log.write("aborting install");
                    NoAskDirPanel.this.showLastActivePanel();
                }
            }
            catch (Exception var2_3) {
                CustomInstaller.logException("Fatal error", var2_3);
                log.write("unexpected error");
            }
        }

        public void swingAfter() {
            NoAskDirPanel.this.showNextPanel();
        }
    }

}
