/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.LineEndingInputFilter;
import com.denova.io.Log;
import com.denova.lang.TimeSharer;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.ui.GridBagControl;
import com.denova.ui.SwingWorker;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.border.Border;

public class TextPanel
extends WizardPanel
implements InstallPropertyNames,
JExpressConstants {
    private static final String Loading = "loading";
    private static final String Displaying = "displaying";
    private static final boolean debugging = false;
    private static final long MaxSilentLoadingTime = 1;
    private static final String LoadingString = Localize.strings().getString("LoadingFile");
    private static Log log = new Log("textpanel");
    protected String filename;
    protected StringBuffer text;
    protected boolean waitingForFile = true;
    protected boolean gotFile = false;
    protected boolean textShown = false;
    protected boolean stoppedWaiting = false;
    protected boolean isHtml = false;
    protected boolean active = false;
    protected JEditorPane textPane = null;
    protected JScrollPane textScrollPane = null;
    protected Color backgroundColor;
    private Color foregroundColor;
    private Thread waitThread;
    private boolean startedRun = false;

    public TextPanel(PropertyList propertyList, String string) {
        super(propertyList);
        this.filename = this.trimFilename(string);
        this.foregroundColor = CustomInstaller.getProgressBarColor();
        this.backgroundColor = CustomInstaller.getBackgroundColor();
        this.add(this.getPanel());
        this.loadFile();
    }

    public synchronized void enter() {
        boolean bl = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (bl) {
            this.gotFile = true;
            this.log("silent install; skipping " + this.getName());
            this.showNextPanel();
        } else {
            this.active = true;
            if (this.waitingForFile) {
                this.log("waiting for file to be loaded");
            } else {
                this.log("already stopped waiting");
                this.stopWaiting();
            }
        }
    }

    public synchronized void leave() {
        this.active = false;
    }

    public boolean isNextButtonEnabled() {
        return this.textShown;
    }

    public void setNextButtonEnabled(boolean bl) {
        if (this.active) {
            super.setNextButtonEnabled(bl);
            this.setDefaultButton(NextButton);
        }
    }

    protected void setTextFilename(String string) {
        this.log("Setting filename to " + string);
        if (this.filename == null) {
            log.write(new Throwable());
        }
        this.filename = this.trimFilename(string);
    }

    protected void setBackgroundColor(Color color) {
        this.backgroundColor = color;
        if (this.textPane != null && this.backgroundColor != null) {
            this.textPane.setBackground(this.backgroundColor);
            this.log("set background color");
        }
    }

    protected void setForegroundColor(Color color) {
        this.foregroundColor = color;
        if (this.textPane != null && this.foregroundColor != null) {
            this.textPane.setForeground(this.foregroundColor);
        }
    }

    protected void loadFile() {
        new LoadFile(this).start();
    }

    protected void reportLoadFileFailed() {
        String string = "Unable to load file " + this.filename;
        this.log(string);
        if (!this.getPropertyList().getBooleanProperty("silentInstall", false)) {
            UserNotices userNotices = new UserNotices();
            userNotices.noteError(string, "OK");
        }
    }

    protected void quitAfterFailure() {
        this.log("skipping to next panel");
        this.showNextPanel();
    }

    protected TransparentJPanel getPanel() {
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder());
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        this.backgroundColor = transparentJPanel.getBackground();
        this.textPane = new JEditorPane();
        this.textPane.setEditable(false);
        this.textPane.setBorder(UiLayoutUtilities.getMarginBorder(5));
        this.textPane.setForeground(this.foregroundColor);
        this.textPane.setBackground(this.backgroundColor);
        if (OS.isMac() && JRE.getJavaVersion().startsWith("1.4")) {
            this.textPane.setText(LoadingString);
        }
        this.textScrollPane = new JScrollPane(this.textPane);
        this.textScrollPane.setVerticalScrollBarPolicy(20);
        this.textScrollPane.setHorizontalScrollBarPolicy(30);
        GridBagConstraints gridBagConstraints = gridBagControl.getConstraints();
        gridBagConstraints.fill = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagControl.endRow(gridBagConstraints, this.textScrollPane);
        return transparentJPanel;
    }

    protected StringBuffer getText() {
        return this.text;
    }

    protected Color getBackgroundColor() {
        return this.backgroundColor;
    }

    protected Color getForegroundColor() {
        return this.foregroundColor;
    }

    protected void showText() {
        this.showText(this.text.toString(), this.isHtml);
    }

    protected void showText(String string) {
        this.showText(string, false);
    }

    protected synchronized void showText(String string, boolean bl) {
        if (string != null) {
            this.log("Showing text: " + string);
            try {
                String string2 = bl ? "text/html" : "text/plain";
                this.log("content type: " + string2);
                this.textPane.setContentType(string2);
                this.log("updating text");
                this.textPane.setText(string.toString());
                this.textPane.setCaretPosition(0);
                this.textShown = true;
                this.log("text shown");
            }
            catch (Exception var3_4) {
                Installer.getInstaller().logException((Object)this, "Unexpected exception displaying text", var3_4);
            }
        } else {
            this.log("Attempted to show null text");
            log.write(new Throwable());
        }
    }

    protected void log(String string) {
        log.write(string);
        this.debug(string);
    }

    protected void log(Throwable throwable) {
        log.write(throwable);
        throwable.printStackTrace();
        this.debug(throwable.getMessage());
    }

    private void debug(String string) {
    }

    private synchronized void stopWaiting() {
        TextSwingWorker textSwingWorker = new TextSwingWorker();
        textSwingWorker.execute();
    }

    private String getLocalizedName() {
        String string = this.filename;
        try {
            if (this.filename == null) {
                this.log("filename not defined");
                throw new FileNotFoundException("null");
            }
            if (this.filename.length() <= 0) {
                this.log("file not found: filename");
                throw new FileNotFoundException(this.filename);
            }
            string = this.filename + "." + Installer.getInstaller().getLanguage();
        }
        catch (Exception var2_2) {
            string = this.filename;
            String string2 = "Unable to get localized file for " + this.filename;
            this.log(string2);
            Installer.getInstaller().logException((Object)this, string2, var2_2);
        }
        return string;
    }

    private boolean readFile(InputStream inputStream, String string) {
        boolean bl = false;
        try {
            int n = 0;
            InputStream inputStream2 = null;
            boolean bl2 = this.isHtml = string.endsWith(".html") || string.endsWith(".htm");
            if (this.isHtml) {
                this.log("reading html file");
                inputStream2 = inputStream;
            } else {
                this.log("reading text file");
                inputStream2 = new LineEndingInputFilter(string, inputStream);
            }
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream2));
            this.text = new StringBuffer();
            this.log("instantiated text");
            String string2 = bufferedReader.readLine();
            while (string2 != null) {
                if (!(n <= 1000 || OS.isMac())) {
                    n = 0;
                    TimeSharer.yield();
                }
                ++n;
                if (!(string2.trim().length() > 0 || this.isHtml)) {
                    string2 = " ";
                    this.log("added blank space to line");
                }
                this.text.append(string2 + System.getProperty("line.separator"));
                this.log(string2);
                string2 = bufferedReader.readLine();
            }
            bl = true;
            bufferedReader.close();
            if (inputStream2 != inputStream) {
                inputStream2.close();
            }
            this.log("finished reading file");
        }
        catch (Exception var4_5) {
            bl = false;
            String string3 = "Unable to load file: " + this.filename;
            this.log(string3);
            Installer.getInstaller().logException((Object)this, string3, var4_5);
        }
        return bl;
    }

    private String trimFilename(String string) {
        int n = string.lastIndexOf(92);
        if (n < 0) {
            n = string.lastIndexOf(47);
        }
        if (n >= 0) {
            string = string.substring(n + 1);
        }
        return string;
    }

    private class TextSwingWorker
    extends SwingWorker {
        private TextSwingWorker() {
        }

        public Object doInBackground() {
            if (!TextPanel.this.stoppedWaiting) {
                TextPanel.this.stoppedWaiting = true;
            }
            return new Object();
        }

        public void done() {
            if (TextPanel.this.gotFile) {
                TextPanel.this.showText();
                TextPanel.this.setNextButtonEnabled(TextPanel.this.gotFile);
            } else {
                TextPanel.this.reportLoadFileFailed();
                TextPanel.this.quitAfterFailure();
            }
        }
    }

    private class LoadFile
    extends Thread {
        private TextPanel textPanel;

        private LoadFile(TextPanel textPanel2) {
            this.textPanel = textPanel2;
        }

        public void run() {
            TextPanel.this.log("getting file");
            TextPanel.this.waitingForFile = true;
            try {
                String string = TextPanel.this.filename;
                String string2 = TextPanel.this.getLocalizedName();
                File file = new File(string2);
                InputStream inputStream = null;
                try {
                    TextPanel.this.log("trying localized filename " + string2);
                    inputStream = Installer.getInstaller().getResourceAsStream(file.getName());
                }
                catch (Exception var5_7) {
                    TextPanel.this.log(var5_7);
                }
                if (inputStream == null) {
                    TextPanel.this.log("trying default filename " + TextPanel.this.filename);
                    file = new File(TextPanel.this.filename);
                    inputStream = Installer.getInstaller().getResourceAsStream(file.getName());
                }
                if (inputStream == null) {
                    throw new FileNotFoundException(TextPanel.this.filename);
                }
                TextPanel.this.gotFile = TextPanel.this.readFile(inputStream, string);
                TextPanel.this.log("gotFile after readFile() " + TextPanel.this.gotFile);
                inputStream.close();
                if (TextPanel.this.active) {
                    TextPanel.this.log("finished waiting for file");
                    TextPanel.this.stopWaiting();
                }
            }
            catch (Exception var1_2) {
                String string = "Unable to load file: " + TextPanel.this.filename;
                TextPanel.this.log(string);
                Installer.getInstaller().logException((Object)this, string, var1_2);
            }
            TextPanel.this.waitingForFile = false;
        }
    }

}
