/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.ui.Fonts;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JLabel;
import javax.swing.border.Border;

public class WelcomePanel
extends WizardPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants {
    private TransparentJPanel borderPanel;
    private JLabel installingLabel;
    private JLabel packageName;
    private String packageString;
    private String authorString;
    private String packageCopyrightString;
    private String webSiteString;
    private GridBagConstraints centeredLabelConstraints;

    public WelcomePanel(PropertyList propertyList) {
        super(propertyList);
        this.addPanel();
    }

    public synchronized void enter() {
        boolean bl = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (bl) {
            this.showNextPanel();
        } else if (this.getPropertyList().getBooleanProperty("clickFreeInstaller", false)) {
            int n = 2000;
            Timer timer = new Timer();
            timer.schedule((TimerTask)new ExitTimer(), n);
        }
    }

    public String getName() {
        String string = "WelcomePanel";
        if (this.trialCopy()) {
            string = "TrialWelcomePanel";
        }
        return string;
    }

    private void addPanel() {
        this.centeredLabelConstraints = GridBagControl.getDefaultConstraints();
        this.centeredLabelConstraints.anchor = 10;
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder());
        this.borderPanel = new TransparentJPanel();
        this.borderPanel.setLayout(new BorderLayout());
        this.authorString = this.getPropertyList().getProperty("author", "");
        this.packageCopyrightString = this.getPropertyList().getProperty("packageCopyright", "");
        this.webSiteString = this.getPropertyList().getProperty("webSite", "");
        if (this.authorString.length() > 0 || this.packageCopyrightString.length() > 0 || this.webSiteString.length() > 0) {
            this.borderPanel.add((Component)this.aboutPanel(), "North");
            this.borderPanel.add((Component)this.productPanel(), "Center");
        } else {
            this.borderPanel.add((Component)this.aboutPanel(), "Center");
        }
        this.add(this.borderPanel);
        String string = this.trialCopy() ? "Installing trial " : "Installing full ";
        string = string + this.packageString;
        if (this.packageCopyrightString.length() > 0) {
            string = string + ", " + this.packageCopyrightString;
        }
        if (this.webSiteString.length() > 0) {
            string = string + ", " + this.webSiteString;
        }
        CustomInstaller.log(string);
    }

    private TransparentJPanel aboutPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        gridBagControl.endRow();
        this.installingLabel = new JLabel(Localize.strings().getString("AboutToInstall"));
        Fonts.setFont(this.installingLabel, Fonts.Big);
        gridBagControl.addCentered(this.installingLabel);
        this.packageString = this.getPropertyList().getProperty("packageName", "");
        String string = this.getPropertyList().getProperty("packageVersion", "");
        if (string != null && string.length() > 0) {
            this.packageString = this.packageString + " " + string;
        }
        this.packageName = new JLabel(this.packageString);
        Fonts.setFont(this.packageName, Fonts.Big);
        gridBagControl.addCentered(this.packageName);
        CustomInstaller.log("Installing " + this.packageString);
        return transparentJPanel;
    }

    private TransparentJPanel productPanel() {
        JLabel jLabel;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        gridBagControl.addVerticalSpace();
        if (this.authorString.length() > 0) {
            int n = this.authorString.indexOf("\\n");
            if (n < 0) {
                JLabel jLabel2 = new JLabel(this.authorString);
                Fonts.setFont(jLabel2, Fonts.Bold);
                gridBagControl.addCentered(jLabel2);
            } else {
                JLabel jLabel3 = new JLabel(this.authorString.substring(0, n));
                Fonts.setFont(jLabel3, Fonts.Bold);
                gridBagControl.addCentered(jLabel3);
                JLabel jLabel4 = new JLabel(this.authorString.substring(n + "\\n".length()));
                Fonts.setFont(jLabel4, Fonts.Bold);
                gridBagControl.addCentered(jLabel4);
            }
        }
        if (this.packageCopyrightString.length() > 0) {
            jLabel = new JLabel(this.packageCopyrightString);
            Fonts.setFont(jLabel, Fonts.Bold);
            gridBagControl.addCentered(jLabel);
        }
        if (this.webSiteString.length() > 0) {
            jLabel = new JLabel(this.webSiteString);
            Fonts.setFont(jLabel, Fonts.Bold);
            gridBagControl.addCentered(jLabel);
        }
        gridBagControl.addVerticalSpace();
        return transparentJPanel;
    }

    private boolean trialCopy() {
        PropertyList propertyList = this.getPropertyList();
        boolean bl = propertyList == null ? true : propertyList.getBooleanProperty("TrialCopy", false);
        return bl;
    }

    private class ExitTimer
    extends TimerTask {
        private ExitTimer() {
        }

        public synchronized void run() {
            WelcomePanel.this.showNextPanel();
        }
    }

}
