/*
 * Decompiled with CFR 0_101.
 */
package com.denova.copycheq;

import com.denova.io.Log;
import com.denova.net.WebFile;
import com.denova.runtime.OS;
import com.eaio.uuid.UUIDGen;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;
import java.util.Iterator;
import org.json.JSONObject;

public class CopyCheqAPI {
    private static final String APIVersion = "1.1";
    public static final String IsActiveAction = "is_active";
    public static final String StartAction = "start";
    public static final String StopAction = "stop";
    public static final String ExpirationAction = "get_expiration";
    private static final String Host = "http://denova.com";
    private static final String APIUrl = "/copycheq/api/";
    private static final String ActionsKey = "actions";
    private static final String APIVersionKey = "api_version";
    private static final String AccountNameKey = "account";
    private static final String ProductNameKey = "product_name";
    private static final String ProductVersionKey = "product_version";
    private static final String LicenseNameKey = "license_name";
    private static final String RightNameKey = "right_name";
    private static final String PrimaryContactKey = "primary_contact";
    private static final String IdCodeKey = "id_code";
    private static final String LoginNameKey = "login_name";
    private static final String MachineKey = "machine";
    private static final String OsKey = "os_name_and_version";
    private static final String ExtraKey = "extra";
    private static final String TimeKey = "time";
    private static final String ActionLabel = "action";
    private static final String OkLabel = "ok";
    private static final String MessageLabel = "message";
    private static final String DateLabel = "date";
    private static final String EqualsSign = "=";
    private static final String NextKey = "&";
    private static final String StandardizedWebError = "Error connecting to license server.";
    private static final String InvalidForm = "Invalid form.";
    private static final Log verifyLog = new Log("ccapi.log");
    private String accountName = null;
    private String productName = null;
    private String licenseName = null;
    private String rightName = null;
    private String productVersion = null;
    private String primaryContactEmail = null;
    private String idCode = null;
    private String loginName = null;
    private String machine = null;
    private String os = null;
    private JSONObject extraData = null;
    private String proxyType = null;
    private String proxyHost = null;
    private int proxyPort = -1;
    private String proxyUsername = "";
    private String proxyPassword = "";
    private boolean httpsProxy = false;
    private boolean socksProxy = false;
    private int maxMinutesToWait = 0;
    private String errorMessage = null;
    private String expirationDateString = null;
    private String webError = null;
    private String rawServerResults = null;

    public boolean isLicenseActive() {
        return this.queryServer("is_active");
    }

    public String getExpiration() {
        this.expirationDateString = null;
        this.queryServer("get_expiration");
        CopyCheqAPI.log("expiration date: " + this.expirationDateString);
        return this.expirationDateString;
    }

    public boolean startRunning() {
        return this.queryServer("start");
    }

    public boolean stopRunning() {
        return this.queryServer("stop");
    }

    public String getLastErrorMessage() {
        return this.errorMessage;
    }

    public String getLastWebError() {
        return this.webError;
    }

    public String getAPIVersion() {
        return "1.1";
    }

    public void setAccountName(String string) {
        this.accountName = string;
    }

    public void setProductName(String string) {
        this.productName = string;
    }

    public void setLicenseName(String string) {
        this.licenseName = string;
    }

    public void setLicenseRight(String string) {
        this.rightName = string;
    }

    public void setProductVersion(String string) {
        if (string != null && string.length() > 0) {
            this.productVersion = string;
        }
    }

    public void setExtraData(String string, String string2) {
        if (this.extraData == null) {
            this.extraData = new JSONObject();
        }
        try {
            this.extraData.put(string, string2);
        }
        catch (Exception var3_3) {
            CopyCheqAPI.log(var3_3);
        }
    }

    public void setPrimaryContact(String string) {
        this.primaryContactEmail = string;
    }

    public void setIdCode(String string) {
        this.idCode = string;
    }

    public String getProxyType() {
        return this.proxyType;
    }

    public void setProxyType(String string) {
        this.proxyType = string;
    }

    public void setProxyHost(String string) {
        this.proxyHost = string;
    }

    public String getProxyHost() {
        return this.proxyHost;
    }

    public void setProxyPort(int n) {
        this.proxyPort = n;
    }

    public int getProxyPort() {
        return this.proxyPort;
    }

    public void setProxyUsername(String string) {
        this.proxyUsername = string;
    }

    public void setProxyPassword(String string) {
        this.proxyPassword = string;
    }

    public void setMaxMinutesToWait(int n) {
        this.maxMinutesToWait = n;
    }

    public static String getConnectionError() {
        return "Error connecting to license server.";
    }

    private boolean queryServer(String string) {
        boolean bl = true;
        try {
            CopyCheqAPI.log("accountName: " + this.accountName);
            CopyCheqAPI.log("productName: " + this.productName);
            CopyCheqAPI.log("licenseName: " + this.licenseName);
            CopyCheqAPI.log("rightName: " + this.rightName);
            CopyCheqAPI.log("primaryContactEmail: " + this.primaryContactEmail);
            if (this.proxyHost != null && this.proxyHost.length() > 0) {
                CopyCheqAPI.log("proxy host: " + this.proxyHost);
                CopyCheqAPI.log("proxy port: " + this.proxyPort);
                CopyCheqAPI.log("set proxy user name " + this.proxyUsername);
            }
            if (this.isJavaVersionOk() && (bl = this.sendAction(string))) {
                if (this.rawServerResults == null || this.rawServerResults.length() <= 0) {
                    bl = false;
                    if (this.webError != null && this.webError.equals("Request redirected")) {
                        this.errorMessage = this.webError;
                    }
                } else {
                    bl = this.parseServerResults(string);
                }
            }
        }
        catch (Exception var3_3) {
            bl = false;
            this.errorMessage = "Unexpected error while conneting to server about " + string;
            CopyCheqAPI.log(var3_3);
        }
        return bl;
    }

    private boolean sendAction(String string) {
        boolean bl = true;
        String string2 = this.getBasicUrl() + "&" + "actions" + "=" + string;
        CopyCheqAPI.log("url: " + string2);
        try {
            URL uRL = new URL(string2);
            WebFile webFile = new WebFile();
            webFile.setLogErrors(false);
            this.setTimeOut(webFile);
            this.setUpProxy(webFile);
            CopyCheqAPI.log("getting " + uRL.toString());
            webFile.setHttpMethod("POST");
            CopyCheqAPI.log("set http method: POST");
            webFile.getPage(uRL.toString());
            CopyCheqAPI.log("got page");
            int n = webFile.getHttpReturnCode();
            CopyCheqAPI.log("result code: " + n);
            bl = webFile.isOk();
            CopyCheqAPI.log("web page ok: " + bl);
            if (bl) {
                this.rawServerResults = this.getBodyText(webFile.getHtmlPage());
                CopyCheqAPI.log("raw server results: " + this.rawServerResults);
            } else {
                this.webError = this.getWebError(webFile.getStatus());
                this.errorMessage = "Error connecting to license server.";
                CopyCheqAPI.log("error message: " + this.webError);
            }
        }
        catch (MalformedURLException var4_5) {
            bl = false;
            this.errorMessage = "Malformed url" + string2;
            CopyCheqAPI.log(var4_5);
        }
        catch (Exception var4_6) {
            bl = false;
            this.errorMessage = "Unexpected error while connecting to server.";
            CopyCheqAPI.log(var4_6);
        }
        return bl;
    }

    private String getBodyText(String string) {
        String string2 = "";
        if (string == null) {
            CopyCheqAPI.log("no body text");
        } else {
            int n = string.toLowerCase().indexOf("<body>");
            if (n >= 0) {
                String string3 = string.substring(n + "<body>".length());
                n = string3.toLowerCase().lastIndexOf("</body>");
                if (n >= 0) {
                    string2 = string3.substring(0, n).trim();
                }
            }
        }
        return string2;
    }

    private boolean parseServerResults(String string) {
        boolean bl = true;
        try {
            JSONObject jSONObject = new JSONObject(this.rawServerResults);
            Iterator iterator = jSONObject.keys();
            while (iterator.hasNext() && bl) {
                String string2 = (String)iterator.next();
                CopyCheqAPI.log("parsing " + string2 + " results");
                try {
                    JSONObject jSONObject2 = (JSONObject)jSONObject.get(string2);
                    bl = jSONObject2.getBoolean("ok");
                    if (bl) {
                        CopyCheqAPI.log(string2 + " ok: " + bl);
                        if (!jSONObject2.has("date")) continue;
                        this.expirationDateString = jSONObject2.getString("date");
                        CopyCheqAPI.log(string2 + " expiration date: " + this.expirationDateString);
                        continue;
                    }
                    if (jSONObject2.has("message")) {
                        this.errorMessage = (String)jSONObject2.get("message");
                        CopyCheqAPI.log(string2 + " error message: " + this.errorMessage);
                        continue;
                    }
                    this.errorMessage = "Unknown error";
                    CopyCheqAPI.log(string2 + " " + this.errorMessage);
                }
                catch (Exception var6_8) {
                    bl = false;
                    CopyCheqAPI.log(var6_8);
                }
            }
        }
        catch (Exception var3_4) {
            bl = false;
            CopyCheqAPI.log(var3_4);
        }
        if (!bl) {
            if (this.errorMessage == null || this.errorMessage.length() <= 0) {
                this.errorMessage = "Unknown error";
            } else if (this.errorMessage.equals("Invalid form.")) {
                this.errorMessage = "The User ID must be an email address.";
            }
        }
        return bl;
    }

    private String getWebError(String string) {
        int n;
        String string2 = string;
        CopyCheqAPI.log("full status: " + string2);
        int n2 = string2.indexOf(": ");
        if (n2 >= 0 && (n = string2.substring(n2 + ": ".length()).length()) > 0) {
            string2 = string2.substring(n2 + ": ".length());
        }
        CopyCheqAPI.log("final error message: " + string2);
        return string2;
    }

    private String getBasicUrl() {
        String string = "";
        try {
            Date date = new Date();
            String string2 = String.valueOf(date.getTime());
            string = "http://denova.com/copycheq/api/?api_version=1.1&account=" + this.accountName + "&" + "product_name" + "=" + this.productName + "&" + "license_name" + "=" + this.licenseName + "&" + "right_name" + "=" + this.rightName + "&" + "primary_contact" + "=" + this.primaryContactEmail + "&" + "id_code" + "=" + this.idCode + "=" + "&" + "time" + "=" + string2;
            this.machine = this.getMachineId();
            if (this.machine != null && this.machine.length() > 0) {
                string = string + "&";
                string = string + "machine";
                string = string + "=";
                string = string + this.machine;
            }
            this.os = this.getOs();
            if (this.os != null && this.os.length() > 0) {
                string = string + "&";
                string = string + "os_name_and_version";
                string = string + "=";
                string = string + this.os;
            }
            this.loginName = this.getEndUserLoginName();
            if (this.loginName != null && this.loginName.length() > 0) {
                string = string + "&";
                string = string + "login_name";
                string = string + "=";
                string = string + this.loginName;
            }
            if (this.productVersion != null && this.productVersion.length() > 0) {
                string = string + "&";
                string = string + "product_version";
                string = string + "=";
                string = string + this.productVersion;
            }
            if (this.extraData != null) {
                string = string + "&";
                string = string + "extra";
                string = string + "=";
                string = string + this.extraData.toString();
            }
            CopyCheqAPI.log("basic url string: " + string);
        }
        catch (Exception var3_3) {
            CopyCheqAPI.log(var3_3);
        }
        return string;
    }

    private void setTimeOut(WebFile webFile) {
        if (this.maxMinutesToWait > 0) {
            webFile.setMaxWait((long)this.maxMinutesToWait * 1000 * 60);
            CopyCheqAPI.log("Max mins to wait for file to download: " + this.maxMinutesToWait);
        } else {
            CopyCheqAPI.log("Max mins to wait not set");
        }
    }

    private void setUpProxy(WebFile webFile) {
        boolean bl = false;
        if (this.proxyHost != null && this.proxyHost.length() > 0) {
            if ("socks".equalsIgnoreCase(this.proxyType)) {
                this.socksProxy = true;
                webFile.setSocksProxy();
                CopyCheqAPI.log("socks proxy: " + this.socksProxy);
            } else {
                this.socksProxy = false;
                webFile.setHttpProxy(this.httpsProxy);
                CopyCheqAPI.log("https proxy: " + this.httpsProxy);
            }
            webFile.setProxyHost(this.proxyHost);
            CopyCheqAPI.log("proxy host: " + this.proxyHost);
            if (this.proxyPort == -1) {
                this.proxyPort = this.httpsProxy ? 443 : (this.socksProxy ? 1080 : 80);
            }
            webFile.setProxyPort(this.proxyPort);
            CopyCheqAPI.log("proxy port: " + this.proxyPort);
            if (this.proxyUsername != null && this.proxyUsername.length() > 0) {
                webFile.setProxyUsername(this.proxyUsername);
                CopyCheqAPI.log("set proxy user name: " + this.proxyUsername);
            }
            if (this.proxyPassword != null && this.proxyPassword.length() > 0) {
                webFile.setProxyPassword(this.proxyPassword);
                CopyCheqAPI.log("set proxy password");
            }
        }
    }

    private String getMachineId() {
        String string = null;
        try {
            string = UUIDGen.getMACAddress();
            CopyCheqAPI.log("got machine");
        }
        catch (Exception var2_2) {
            CopyCheqAPI.log(var2_2);
        }
        return string;
    }

    private String getOs() {
        String string = null;
        try {
            string = OS.getOsName();
            if (string.length() > 0) {
                string = string + " ";
                string = string + OS.getVersion();
            }
            CopyCheqAPI.log("got os: " + string);
        }
        catch (Exception var2_2) {
            CopyCheqAPI.log(var2_2);
        }
        return string;
    }

    private String getEndUserLoginName() {
        String string = null;
        try {
            string = System.getProperty("user.name");
            CopyCheqAPI.log("got end user");
        }
        catch (Exception var2_2) {
            CopyCheqAPI.log(var2_2);
        }
        return string;
    }

    private boolean isJavaVersionOk() {
        boolean bl = true;
        String string = System.getProperty("java.version", "");
        if (string.length() > "1.5".length()) {
            string = string.substring(0, "1.5".length());
        }
        bl = string.compareTo("1.5") >= 0;
        CopyCheqAPI.log("java version ok: " + bl);
        return bl;
    }

    private static void log(String string) {
        if (verifyLog != null) {
            verifyLog.write(string);
        }
    }

    private static void log(Exception exception) {
        if (verifyLog != null) {
            verifyLog.write(exception);
        }
    }
}
