/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.LineEndingInputFilter;
import com.denova.io.Log;
import com.denova.lang.LangUtilities;
import com.denova.lang.TimeSharer;
import com.denova.runtime.OS;
import com.denova.ui.TextDisplayable;
import com.denova.ui.UiLayoutUtilities;
import com.denova.util.DataFinder;
import java.awt.Component;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.util.StringTokenizer;
import java.util.zip.CRC32;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import javax.swing.JLabel;
import javax.swing.JProgressBar;

public class FileSystem {
    static boolean debugging = false;
    static Log fileSystemLog = null;
    static JProgressBar progressBar;
    static JLabel progressStatus;
    static String hostUrl;
    static TextDisplayable textDisplay;

    public static String findFileInPath(String string) {
        String string2 = "";
        String string3 = OS.getSystemPath();
        if (string3 != null && string3.length() > 0) {
            StringTokenizer stringTokenizer = new StringTokenizer(string3, File.pathSeparator);
            while (stringTokenizer.hasMoreTokens() && string2.length() <= 0) {
                String string4 = stringTokenizer.nextToken();
                File file = new File(string4, string);
                if (!file.exists() || file.isDirectory()) continue;
                string2 = file.getPath();
            }
        }
        return string2;
    }

    public static boolean removeFile(String string) {
        boolean bl;
        try {
            File file = new File(string);
            bl = file.delete();
        }
        catch (Exception var2_2) {
            bl = false;
        }
        return bl;
    }

    public static boolean removeDirectory(String string) {
        boolean bl = false;
        if (string != null) {
            bl = FileSystem.removeDirectory(new File(string));
        }
        return bl;
    }

    public static boolean removeDirectory(File file) {
        boolean bl = true;
        if (file.isDirectory() && !FileSystem.isRootDirectory(file)) {
            bl = FileSystem.removeDirectoryContents(file);
            if (file.exists()) {
                bl = file.delete();
            }
        }
        return bl;
    }

    public static boolean removeDirectoryContents(String string) {
        boolean bl = false;
        if (string != null) {
            bl = FileSystem.removeDirectoryContents(new File(string));
        }
        return bl;
    }

    public static boolean removeDirectoryContents(File file) {
        boolean bl = false;
        if (file.isDirectory() && !FileSystem.isRootDirectory(file) && (bl = FileSystem.removeFiles(file))) {
            bl = FileSystem.removeSubdirectories(file);
        }
        return bl;
    }

    public static void copyFile(String string, String string2) throws Exception {
        FileSystem.copyFile(new File(string), new File(string2));
    }

    public static void copyFile(File file, String string) throws Exception {
        FileSystem.copyFile(file, new File(string));
    }

    public static void copyFile(String string, File file) throws Exception {
        FileSystem.copyFile(new File(string), file);
    }

    public static void copyFile(File file, File file2) throws Exception {
        File file3 = new File(file2.getPath());
        if (file3.isDirectory()) {
            file3 = new File(file3, file.getName());
        }
        if (file3.getPath().equals(file.getPath())) {
            FileSystem.log("Unable to copy " + file3.getPath() + " to itself");
        } else {
            FileOutputStream fileOutputStream = new FileOutputStream(file3);
            FileSystem.copyFileToStream(file, (OutputStream)fileOutputStream);
            fileOutputStream.close();
        }
    }

    public static void copyFileToStream(String string, OutputStream outputStream) throws Exception {
        FileSystem.copyFileToStream(new File(string), outputStream);
    }

    public static void copyFileToStream(File file, OutputStream outputStream) throws Exception {
        FileInputStream fileInputStream = new FileInputStream(file);
        try {
            FileSystem.copyStreams(fileInputStream, outputStream);
        }
        catch (Exception var3_3) {
            // empty catch block
        }
        if (fileInputStream != null) {
            fileInputStream.close();
        }
    }

    public static void copyStreamToFile(InputStream inputStream, String string) throws Exception {
        FileSystem.copyStreamToFile(inputStream, new File(string));
    }

    public static void copyStreamToFile(InputStream inputStream, File file) throws Exception {
        FileOutputStream fileOutputStream = new FileOutputStream(file);
        FileSystem.copyStreams(inputStream, fileOutputStream);
        fileOutputStream.close();
    }

    public static void copyFileToZipStream(String string, ZipOutputStream zipOutputStream) throws Exception {
        File file = new File(string);
        FileSystem.copyFileToZipStream(file, file.getPath(), zipOutputStream);
    }

    public static void copyFileToZipStream(File file, String string, ZipOutputStream zipOutputStream) throws Exception {
        File file2 = null;
        FileSystem.copyFileToZipStream(file, string, file2, zipOutputStream);
    }

    public static void copyFileToZipStream(File file, String string, File file2, ZipOutputStream zipOutputStream) throws Exception {
        if (file.isDirectory()) {
            File file3 = file;
            String[] arrstring = file3.list();
            for (int i = 0; i < arrstring.length; ++i) {
                String string2 = arrstring[i];
                File file4 = new File(file3, string2);
                String string3 = FileSystem.getRelativePathname(file2, file4);
                FileSystem.copyFileToZipStream(file4, string3, file2, zipOutputStream);
            }
        } else if (file.isFile() && file.canRead()) {
            FileInputStream fileInputStream = new FileInputStream(file);
            try {
                String string4 = string.replace(File.separatorChar, '/');
                FileSystem.debug("com.denova.io.FileSystem.copyFileToZipStream: zipping " + file.getPath() + " to " + string4);
                ZipEntry zipEntry = new ZipEntry(string4);
                zipEntry.setSize(file.length());
                zipOutputStream.putNextEntry(zipEntry);
                FileSystem.copyStreams(fileInputStream, zipOutputStream);
                zipOutputStream.closeEntry();
            }
            catch (Exception var5_8) {
                FileSystem.debug("unexpected exception copyFileToZipStream: " + file.getPath());
            }
            if (fileInputStream != null) {
                fileInputStream.close();
            }
        } else {
            FileSystem.debug("com.denova.io.FileSystem.copyFileToZipStream: unable to read " + file.getPath());
        }
    }

    public static void appendFile(File file, File file2) throws Exception {
        if (file2.isDirectory()) {
            file2 = new File(file2.getPath(), file.getName());
        }
        if (file2.getPath().equals(file.getPath())) {
            FileSystem.log("Unable to append " + file2.getPath() + " to itself");
        } else {
            FileOutputStream fileOutputStream = new FileOutputStream(file2.getPath(), true);
            FileSystem.copyFileToStream(file, (OutputStream)fileOutputStream);
            fileOutputStream.close();
        }
    }

    public static void createEmptyFile(File file) throws Exception {
        if (!file.isDirectory()) {
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            fileOutputStream.close();
        }
    }

    public static String getRelativePathname(File file, File file2) throws Exception {
        String string = file2.getPath();
        if (file != null) {
            String string2 = file.getPath();
            string = file2.getPath();
            if (string.startsWith(string2)) {
                string = string.substring(string2.length());
            }
            if (string.startsWith(File.separator)) {
                string = string.substring(File.separator.length());
            }
        }
        FileSystem.debug("com.denova.io.FileSystem.getRelativePathname:" + string + " is from " + file + " and " + file2);
        return string;
    }

    public static void copyDirectory(String string, String string2) throws Exception {
        FileSystem.copyDirectory(new File(string), new File(string2));
    }

    public static void copyDirectory(File file, String string) throws Exception {
        FileSystem.copyDirectory(file, new File(string));
    }

    public static void copyDirectory(String string, File file) throws Exception {
        FileSystem.copyDirectory(new File(string), file);
    }

    public static void copyDirectory(File file, File file2) throws Exception {
        if (file.exists() && file.isDirectory() && file2.exists()) {
            String[] arrstring = file.list();
            for (int i = 0; i < arrstring.length; ++i) {
                File file3 = new File(file, arrstring[i]);
                File file4 = new File(file2, arrstring[i]);
                if (file3.isDirectory()) {
                    if ((!file4.exists() || !file4.isDirectory()) && !file4.mkdirs()) continue;
                    FileSystem.copyDirectory(file3, file4);
                    continue;
                }
                FileSystem.copyFile(file3.getPath(), file4.getPath());
            }
        }
    }

    public static void copyStreams(InputStream inputStream, OutputStream outputStream) throws Exception {
        byte[] arrby = new byte[50000];
        int n = FileSystem.read(inputStream, arrby);
        while (n > 0) {
            FileSystem.setProgressBar(n);
            outputStream.write(arrby, 0, n);
            n = FileSystem.read(inputStream, arrby);
            TimeSharer.yield();
        }
        FileSystem.setProgressBar(100);
        FileSystem.setProgressStatus("100%");
    }

    public static void copyStreams(InputStream inputStream, OutputStream outputStream, long l) throws Exception {
        byte[] arrby = new byte[50000];
        int n = (int)l;
        int n2 = n;
        if (n2 > 50000) {
            n2 = 50000;
        }
        int n3 = FileSystem.read(inputStream, arrby, n2);
        while (n3 > 0) {
            FileSystem.setProgressBar(n3);
            outputStream.write(arrby, 0, n3);
            n2 = n-=n3;
            if (n2 > 50000) {
                n2 = 50000;
            }
            n3 = FileSystem.read(inputStream, arrby, n2);
            TimeSharer.yield();
        }
        FileSystem.setProgressBar(100);
        FileSystem.setProgressStatus("100%");
    }

    public static boolean getResourceAsFile(String string) throws Exception {
        return FileSystem.getResourceAsFile(string, null);
    }

    public static boolean getResourceAsFile(String string, String string2) throws Exception {
        Object object;
        boolean bl = false;
        String string3 = string2;
        if (string3 == null) {
            object = new File(string);
            if (object.exists()) {
                bl = true;
                FileSystem.log("found " + string);
            } else {
                string3 = string;
            }
        }
        if (!bl) {
            object = FileSystem.getResourceAsStream(string);
            File file = new File(string3);
            if (file.isDirectory()) {
                file = new File(string3, string);
            }
            boolean bl2 = bl = object != null && FileSystem.getFile(file.getPath(), (InputStream)object);
            if (object != null) {
                object.close();
            }
        }
        return bl;
    }

    public static InputStream getResourceAsStream(String string) {
        FileSystem.log("searching for " + string + " via DataFinder");
        InputStream inputStream = DataFinder.getStream(string);
        if (inputStream == null) {
            FileSystem.log("searching for " + string + " via LangUtilities");
            inputStream = LangUtilities.getResourceAsStream(string);
        }
        if (inputStream == null) {
            FileSystem.log(LangUtilities.getLastException());
        }
        return inputStream;
    }

    public static URL getResource(String string) {
        URL uRL = LangUtilities.getResource(string);
        if (uRL == null) {
            FileSystem.log(LangUtilities.getLastException());
        }
        return uRL;
    }

    public static boolean getFile(String string) throws Exception {
        boolean bl = false;
        InputStream inputStream = null;
        inputStream = FileSystem.getFileStream(string);
        if (inputStream != null) {
            bl = FileSystem.getFile(string, inputStream);
            inputStream.close();
        }
        return bl;
    }

    public static boolean getFile(String string, InputStream inputStream) throws Exception {
        FileOutputStream fileOutputStream;
        boolean bl = false;
        if (inputStream != null) {
            byte[] arrby = new byte[50000];
            FileSystem.debug("Saving input stream as " + string);
            fileOutputStream = new FileOutputStream(string);
            int n = inputStream.read(arrby);
            while (n > 0) {
                FileSystem.setProgressBar(n);
                fileOutputStream.write(arrby, 0, n);
                n = inputStream.read(arrby);
                TimeSharer.yield();
            }
        } else {
            throw new NullPointerException();
        }
        fileOutputStream.close();
        inputStream.close();
        bl = true;
        return bl;
    }

    public static InputStream getFileStream(String string) throws Exception {
        boolean bl = false;
        int n = 1;
        InputStream inputStream = null;
        while (!bl) {
            try {
                InputStream inputStream2 = FileSystem.getResourceAsStream(string);
                if (inputStream2 != null) {
                    inputStream = new LineEndingInputFilter(string, inputStream2);
                    bl = true;
                }
            }
            catch (Exception var5_5) {
                FileSystem.log("getFileStream: File not found: " + string, var5_5);
            }
            if (!(hostUrl == null || hostUrl.length() <= 0 || inputStream != null && bl)) {
                String string2;
                try {
                    inputStream = FileSystem.getFileStreamFromUrl(string);
                    bl = true;
                }
                catch (FileNotFoundException var5_6) {
                    FileSystem.log(var5_6);
                    try {
                        inputStream = FileSystem.getResourceAsStream(string);
                    }
                    catch (Exception var6_10) {
                        FileSystem.log("getFileStream: Resource not found: " + string, var6_10);
                    }
                    bl = true;
                }
                catch (UnknownHostException var5_7) {
                    string2 = "getFileStream: Host not found: " + hostUrl;
                    FileSystem.logError(string2);
                    bl = true;
                }
                catch (Exception var5_8) {
                    String string3;
                    string2 = "getFileStream: filename: " + string + ", host url: " + hostUrl;
                    FileSystem.log(string2, var5_8);
                    if (n < 5) {
                        ++n;
                        string3 = "Trying again to get " + string;
                        string3 = string3 + ": " + var5_8;
                        FileSystem.logError(string3);
                    }
                    bl = true;
                    string3 = "Unable to load " + string;
                    string3 = string3 + ": " + var5_8;
                    FileSystem.logError(string3);
                    throw var5_8;
                }
            }
            TimeSharer.yield();
        }
        return inputStream;
    }

    public static int read(InputStream inputStream) throws IOException {
        int n = inputStream.available() > 0 ? inputStream.read() : -1;
        return n;
    }

    public static int read(InputStream inputStream, byte[] arrby) throws IOException {
        int n = inputStream.read(arrby);
        return n;
    }

    public static int read(InputStream inputStream, byte[] arrby, int n) throws IOException {
        int n2 = inputStream.read(arrby, 0, n);
        return n2;
    }

    public static boolean isRootDirectory(String string) {
        boolean bl = true;
        try {
            bl = File.separator.equals(string) || OS.isWindows() && string.endsWith(":\\");
        }
        catch (Exception var2_2) {
            bl = true;
        }
        return bl;
    }

    public static boolean isRootDirectory(File file) {
        return FileSystem.isRootDirectory(file.getPath());
    }

    public static long getCrc(File file) throws Exception {
        long l;
        FileSystem.log("computing crc for " + file.getPath());
        CRC32 cRC32 = new CRC32();
        FileInputStream fileInputStream = new FileInputStream(file);
        byte[] arrby = new byte[50000];
        long l2 = l = file.length();
        int n = l2 > 50000 ? 50000 : (int)l2;
        FileSystem.log("file size: " + l);
        int n2 = FileSystem.read(fileInputStream, arrby, n);
        while (n2 > 0) {
            cRC32.update(arrby, 0, n2);
            if (l > 0) {
                int n3 = (int)((l - l2) * 100 / l);
                FileSystem.setProgressBar(n3);
                FileSystem.setProgressStatus(String.valueOf(n3));
            }
            n = (l2-=(long)n2) > 50000 ? 50000 : (int)l2;
            n2 = FileSystem.read(fileInputStream, arrby, n);
            TimeSharer.yield();
        }
        FileSystem.setProgressBar(100);
        FileSystem.setProgressStatus("100%");
        if (fileInputStream != null) {
            fileInputStream.close();
        }
        return cRC32.getValue();
    }

    public static void setHostUrl(String string) {
        hostUrl = string;
    }

    public static void setProgressBar(JProgressBar jProgressBar) {
        progressBar = jProgressBar;
    }

    public static JProgressBar getProgressBar() {
        return progressBar;
    }

    public static void setProgressStatus(JLabel jLabel) {
        progressStatus = jLabel;
    }

    public static JLabel getProgressStatus() {
        return progressStatus;
    }

    public static boolean isDirWriteProtected(String string) {
        boolean bl = false;
        File file = new File(string, "__jextest.zos");
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file.getPath());
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            printWriter.println("ok");
            printWriter.close();
            fileOutputStream.close();
            bl = !file.exists();
            file.delete();
        }
        catch (Exception var3_4) {
            bl = true;
            FileSystem.log(string + " is write protected?", var3_4);
        }
        return bl;
    }

    private static InputStream getFileStreamFromUrl(String string) throws Exception {
        LineEndingInputFilter lineEndingInputFilter = null;
        if (hostUrl != null && hostUrl.length() > 0) {
            URL uRL = new URL(hostUrl);
            URL uRL2 = new URL(uRL, string);
            FileSystem.log("Getting file stream from url " + uRL2);
            URLConnection uRLConnection = uRL2.openConnection();
            uRLConnection.connect();
            InputStream inputStream = uRLConnection.getInputStream();
            lineEndingInputFilter = new LineEndingInputFilter(inputStream, false);
        }
        return lineEndingInputFilter;
    }

    private static boolean removeFiles(File file) {
        boolean bl = true;
        String[] arrstring = file.list();
        for (int i = 0; i < arrstring.length; ++i) {
            File file2 = new File(file, arrstring[i]);
            if (file2.isDirectory() || file2.delete()) continue;
            bl = false;
            FileSystem.log("unable to delete file: " + file2.getPath());
        }
        return bl;
    }

    public static boolean removeSubdirectories(File file) {
        boolean bl = true;
        String[] arrstring = file.list();
        if (arrstring != null) {
            for (int i = 0; i < arrstring.length; ++i) {
                File file2;
                if (arrstring[i].equals(".") || arrstring[i].equals("..") || !(file2 = new File(file, arrstring[i])).isDirectory()) continue;
                if (FileSystem.removeDirectory(file2.getAbsolutePath())) {
                    if (textDisplay == null) continue;
                    textDisplay.displayProgress(1);
                    continue;
                }
                bl = false;
                FileSystem.log("unable to delete dir: " + file2.getPath());
            }
        }
        return bl;
    }

    static void setProgressBar(int n) {
        if (progressBar != null) {
            UiLayoutUtilities.update((Component)progressBar, n);
        }
        if (textDisplay != null) {
            textDisplay.displayProgress(n);
        }
    }

    static void setProgressStatus(String string) {
        if (progressStatus != null) {
            UiLayoutUtilities.update((Component)progressStatus, (Object)string);
        }
    }

    static void log(String string) {
        FileSystem.startLogging();
        fileSystemLog.write(string);
        FileSystem.debug(string);
    }

    static void log(Exception exception) {
        FileSystem.startLogging();
        fileSystemLog.write(exception);
        if (debugging) {
            exception.printStackTrace();
        }
    }

    static void log(String string, Exception exception) {
        FileSystem.log(string);
        FileSystem.log(exception);
    }

    static void logError(String string) {
        FileSystem.startLogging();
        fileSystemLog.write(string);
        FileSystem.debug(string);
    }

    static void startLogging() {
        if (fileSystemLog == null) {
            fileSystemLog = new Log("filesystem");
        }
    }

    private static void debug(String string) {
        if (debugging) {
            System.out.println(string);
        }
    }

    public static void setTextDisplay(TextDisplayable textDisplayable) {
        textDisplay = textDisplayable;
    }

    public static TextDisplayable getTextDisplay() {
        return textDisplay;
    }
}
