/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.Log;
import com.denova.lang.TimeSharer;
import com.denova.runtime.OS;
import com.denova.runtime.UnixCommands;
import com.denova.ui.TextDisplayable;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Date;
import java.util.List;
import java.util.Vector;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;
import org.apache.tools.tar.TarEntry;
import org.apache.tools.tar.TarInputStream;
import org.apache.tools.tar.TarOutputStream;

public class GZipper {
    private static final int BUFFER_SIZE = 8192;
    private static final Log gzipLog = new Log("gzipper.log");
    private List files = new Vector();
    private TextDisplayable textDisplay = null;
    private String textExtensions = null;
    private boolean setLastModifiedDate = false;
    private boolean modeFlag = false;
    private boolean overwrite = true;
    private String baseDir = null;
    private int totalFiles = 0;
    private long uncompressedTotalFilesize = 0;
    private boolean debugging = false;

    public GZipper() {
        this.logMsg("debugging " + this.debugging);
    }

    public void setBaseDirectory(File file) {
        this.setBaseDirectory(file.getPath());
    }

    public void setBaseDirectory(String string) {
        this.baseDir = string;
        if (!this.baseDir.endsWith(File.separator)) {
            this.baseDir = this.baseDir + File.separator;
        }
    }

    public void archiveDirectory(File file, File file2, boolean bl) throws Exception {
        this.archiveDirectory(file.getPath(), file2.getPath(), bl);
    }

    public void archiveDirectory(String string, String string2, boolean bl) throws Exception {
        this.logMsg("archiveDirectory: " + string);
        File file = new File(string);
        String[] arrstring = file.list();
        Vector<String> vector = new Vector<String>();
        for (int i = 0; i < arrstring.length; ++i) {
            TimeSharer.yield();
            String string3 = arrstring[i];
            File file2 = new File(file, string3);
            vector.add(file2.getPath());
        }
        if (vector.size() > 0) {
            this.setBaseDirectory(string);
            this.archiveFiles(vector, string2, bl);
        }
    }

    public void archiveFiles(List list, String string, boolean bl) throws Exception {
        this.archiveFiles(list, new File(string), bl);
    }

    public void archiveFiles(List list, File file, boolean bl) throws Exception {
        this.logMsg("archiveFiles");
        TarOutputStream tarOutputStream = null;
        try {
            tarOutputStream = new TarOutputStream(new GZIPOutputStream(new BufferedOutputStream(new FileOutputStream(file))));
            tarOutputStream.setDebug(this.debugging);
            tarOutputStream.setLongFileMode(2);
            this.tarFiles(list, tarOutputStream, bl);
        }
        catch (Exception var5_6) {
            String string = "Problem creating TAR: " + var5_6.getMessage();
            this.logMsg(string);
            this.log(var5_6);
            throw new Exception(string, var5_6);
        }
        finally {
            try {
                tarOutputStream.close();
            }
            catch (Exception var8_9) {}
        }
    }

    public void unarchiveAllFiles(String string, File file) throws Exception {
        this.logMsg("opening: " + string);
        FileInputStream fileInputStream = new FileInputStream(string);
        TarInputStream tarInputStream = null;
        try {
            tarInputStream = new TarInputStream(new GZIPInputStream(new BufferedInputStream(fileInputStream)));
            this.logMsg("Expanding: " + string + " into " + file.getPath());
            TarEntry tarEntry = null;
            boolean bl = true;
            while ((tarEntry = tarInputStream.getNextEntry()) != null) {
                bl = false;
                this.untarFile(tarEntry, file, tarInputStream);
            }
            if (bl) {
                throw new Exception("archive '" + string + "' is empty");
            }
            this.logMsg("expand complete");
        }
        finally {
            try {
                tarInputStream.close();
            }
            catch (Exception var5_6) {}
        }
        this.logMsg("unarchiveAllFiles to: " + file.getPath());
    }

    public long getTotalFilesizes() {
        this.logMsg("total uncompressed file size for all files: " + new Long(this.uncompressedTotalFilesize).toString());
        return this.uncompressedTotalFilesize;
    }

    public int getCount() {
        this.logMsg("file count: " + String.valueOf(this.totalFiles));
        return this.totalFiles;
    }

    public void setTextDisplay(TextDisplayable textDisplayable) {
        this.textDisplay = textDisplayable;
        this.logMsg("set textDisplay in gzipper");
    }

    public void setTextExtensions(String string) {
        this.textExtensions = string;
        this.logMsg("set text extensions: " + this.textExtensions);
    }

    public void setModifiedDate(boolean bl) {
        this.setLastModifiedDate = bl;
    }

    public void setModeFlag(boolean bl) {
        this.modeFlag = bl;
    }

    private void untarFile(TarEntry tarEntry, File file, TarInputStream tarInputStream) throws IOException {
        String string = tarEntry.getName();
        if (string != null) {
            string = string.replace((CharSequence)"/", (CharSequence)File.separator);
            if ((string = string.replace((CharSequence)"\\", (CharSequence)File.separator)).length() > 0 && string.charAt(0) == File.separatorChar) {
                this.logMsg("stripped absolute path spec from " + string);
                string = string.substring(1);
            }
        }
        File file2 = new File(file, string);
        try {
            Object object;
            if (!this.overwrite && file2.exists() && file2.lastModified() >= tarEntry.getModTime().getTime()) {
                this.logMsg("Skipping " + file2.getPath() + " as it is up-to-date");
                return;
            }
            this.logMsg("expanding " + string + " to " + file2.getPath());
            File file3 = file2.getParentFile();
            if (file3 != null) {
                file3.mkdirs();
            }
            if (tarEntry.isDirectory()) {
                file2.mkdirs();
            } else {
                object = new byte[8192];
                int n = 0;
                FileOutputStream fileOutputStream = null;
                try {
                    fileOutputStream = new FileOutputStream(file2);
                    while ((n = tarInputStream.read((byte[])object)) >= 0) {
                        fileOutputStream.write((byte[])object, 0, n);
                        if (this.textDisplay == null) continue;
                        this.textDisplay.displayProgress(n);
                    }
                    fileOutputStream.close();
                    fileOutputStream = null;
                }
                finally {
                    try {
                        fileOutputStream.close();
                    }
                    catch (Exception var10_11) {}
                }
            }
            if (OS.isUnix() && this.modeFlag) {
                new String();
                object = String.valueOf(tarEntry.getMode());
                UnixCommands.chmod((String)object, file2.getPath());
                this.logMsg(string + "'s mode: " + (String)object);
            }
            if (this.setLastModifiedDate) {
                file2.setLastModified(tarEntry.getModTime().getTime());
            }
        }
        catch (FileNotFoundException var6_7) {
            this.logMsg("Unable to expand to file " + file2.getPath());
            this.log(var6_7);
        }
    }

    private void tarFiles(List list, TarOutputStream tarOutputStream, boolean bl) throws Exception {
        for (int i = 0; i < list.size(); ++i) {
            String string = (String)list.get(i);
            File file = new File(string);
            this.tarFile(file, tarOutputStream, bl);
            if (!file.isDirectory()) continue;
            String[] arrstring = file.list();
            Vector<String> vector = new Vector<String>();
            for (int j = 0; j < arrstring.length; ++j) {
                String string2 = arrstring[j];
                File file2 = new File(file, string2);
                vector.add(file2.getPath());
            }
            if (vector.size() <= 0) continue;
            this.tarFiles(vector, tarOutputStream, bl);
        }
    }

    private void tarFile(File file, TarOutputStream tarOutputStream, boolean bl) throws Exception {
        String string = file.getPath();
        if (this.baseDir != null) {
            string = string.substring(this.baseDir.length());
        }
        string = string.replace((CharSequence)File.separator, (CharSequence)"/");
        if (file.isDirectory() && !string.endsWith("/")) {
            string = string + "/";
        }
        TarEntry tarEntry = new TarEntry(string);
        tarEntry.setModTime(file.lastModified());
        if (OS.isUnix() && bl) {
            int n = UnixCommands.getPermissions(file.getPath());
            if (n > -1) {
                tarEntry.setMode(n);
                this.logMsg("   set mode for " + string + ": " + n);
            }
        } else {
            String string2 = file.getName();
            if (!file.isDirectory() && (string2.endsWith(".bin") || string2.endsWith(".sh") || string2.indexOf(".") < 0)) {
                tarEntry.setMode(33261);
                this.logMsg("   set mode to executable for " + string);
            }
        }
        if (!file.isDirectory()) {
            if (file.length() > 0x1FFFFFFFFL) {
                throw new Exception("Resource: " + file + " larger than " + 0x1FFFFFFFFL + " bytes.");
            }
            tarEntry.setSize(file.length());
            this.uncompressedTotalFilesize+=file.length();
            ++this.totalFiles;
        }
        InputStream inputStream = null;
        try {
            tarOutputStream.putNextEntry(tarEntry);
            if (!file.isDirectory()) {
                inputStream = new BufferedInputStream(new FileInputStream(file));
                byte[] arrby = new byte[8192];
                int n = 0;
                do {
                    tarOutputStream.write(arrby, 0, n);
                } while ((n = inputStream.read(arrby, 0, arrby.length)) != -1);
            }
            tarOutputStream.closeEntry();
            this.logMsg("   " + string + ": " + new Date(file.lastModified()).toString());
        }
        finally {
            try {
                inputStream.close();
            }
            catch (Exception var7_10) {}
        }
    }

    private void logMsg(String string) {
        gzipLog.write(string);
        if (this.debugging) {
            System.out.println(string);
        }
    }

    private void log(String string) {
        this.logMsg(string);
        if (this.textDisplay != null) {
            this.textDisplay.displayText(string);
        }
    }

    private void log(Exception exception) {
        gzipLog.write(exception);
    }
}
