/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.FixZipBugInputFilter;
import com.denova.io.Log;
import java.io.IOException;
import java.io.InputStream;
import java.util.StringTokenizer;

public class LineEndingInputFilter
extends InputStream {
    private static final int LF = 10;
    private static final int CR = 13;
    private static String textExtensions;
    private static Log log;
    private InputStream source;
    private boolean isText;
    private byte[] eol;
    private boolean eolPending;
    private int eolIndex;

    public LineEndingInputFilter(InputStream inputStream) {
        this(inputStream, true);
    }

    public LineEndingInputFilter(String string, InputStream inputStream) {
        this(string, inputStream, true);
    }

    public LineEndingInputFilter(String string, InputStream inputStream, boolean bl) {
        this(inputStream, bl);
        if (textExtensions == null) {
            log.write("no text extensions defined");
        } else {
            log.write("text extensions defined: " + textExtensions);
            StringTokenizer stringTokenizer = new StringTokenizer(textExtensions);
            while (stringTokenizer.hasMoreTokens() && !this.isText) {
                this.isText = string.endsWith("." + stringTokenizer.nextToken());
            }
        }
        log.write(string + " is text file: " + this.isText);
    }

    public LineEndingInputFilter(InputStream inputStream, boolean bl) {
        if (bl) {
            this.source = new FixZipBugInputFilter(inputStream);
            log.write("fix zip bug");
        } else {
            this.source = inputStream;
        }
        this.eol = System.getProperty("line.separator").getBytes();
        this.isText = false;
    }

    public int available() throws IOException {
        int n = this.source.available();
        if (this.isText && this.eolPending) {
            n+=this.eol.length - this.eolIndex;
        }
        return n;
    }

    public int read() throws IOException {
        int n = this.isText && this.eolPending ? this.nextEolByte() : this.nextByte();
        return n;
    }

    public int read(byte[] arrby) throws IOException {
        return this.read(arrby, 0, arrby.length);
    }

    public int read(byte[] arrby, int n, int n2) throws IOException {
        int n3;
        if (this.isText) {
            n3 = 0;
            while (this.available() > 0 && n3 < n2) {
                arrby[n] = (byte)this.read();
                ++n3;
                ++n;
            }
            if (n3 <= 0 && this.available() <= 0) {
                n3 = -1;
            }
        } else {
            n3 = this.source.read(arrby, n, n2);
        }
        return n3;
    }

    public long skip(long l) throws IOException {
        int n = 0;
        while (l > 0) {
            this.read();
            ++n;
            --l;
        }
        return n;
    }

    public void close() throws IOException {
        this.source.close();
    }

    public synchronized void mark(int n) {
        this.source.mark(n);
    }

    public synchronized void reset() throws IOException {
        this.source.reset();
    }

    public boolean markSupported() {
        return this.source.markSupported();
    }

    int nextByte() throws IOException {
        int n = this.source.read();
        if (this.isText && n != -1) {
            if ((n&=255) == 13) {
                n = this.source.read();
            }
            if (n == 10) {
                n = this.startEol();
            }
        }
        return n;
    }

    int startEol() {
        this.eolPending = true;
        this.eolIndex = 0;
        return this.nextEolByte();
    }

    int nextEolByte() {
        byte by = this.eol[this.eolIndex];
        ++this.eolIndex;
        if (this.eolIndex >= this.eol.length) {
            this.eolPending = false;
        }
        return by;
    }

    public static void setTextExtensions(String string) {
        StringTokenizer stringTokenizer = new StringTokenizer(string, " \t\r\n.*");
        while (stringTokenizer.hasMoreTokens()) {
            if (textExtensions == null || textExtensions.length() <= 0) {
                textExtensions = stringTokenizer.nextToken();
                continue;
            }
            textExtensions = textExtensions + " " + stringTokenizer.nextToken();
        }
        log.write("text extensions: " + textExtensions);
    }

    public static String getTextExtensions() {
        return textExtensions;
    }

    public void setIsText(boolean bl) {
        this.isText = bl;
    }

    public boolean getIsText() {
        return this.isText;
    }

    static {
        log = new Log("endings.log");
    }
}
