/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.Log;
import com.denova.runtime.OS;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.WindowsCommands;
import java.io.File;
import java.util.List;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.Vector;

public class TempDirs {
    private Log log = new Log("tempdirs");
    private Stack createdDirs = new Stack();

    public TempDirs(String string) {
        this(new File(string));
    }

    public TempDirs(File file) {
        this.logMessage("making any missing subdirectories: " + file);
        String string = file.getPath();
        StringTokenizer stringTokenizer = new StringTokenizer(string, File.separator);
        if (stringTokenizer.hasMoreTokens()) {
            String string2 = stringTokenizer.nextToken();
            File file2 = new File(this.getDirPrefix(string) + string2);
            this.logMessage("initial subdir: " + file2.getPath());
            if (!file2.exists()) {
                this.makeDir(file2);
            }
            while (stringTokenizer.hasMoreTokens()) {
                string2 = stringTokenizer.nextToken();
                if ((file2 = new File(file2, string2)).exists()) {
                    this.logMessage("exists: " + file2.getPath());
                    continue;
                }
                this.makeDir(file2);
            }
        }
    }

    public TempDirs(File file, String string) {
        this(file.getAbsolutePath(), string);
    }

    public TempDirs(String string, String string2) {
        this(string);
        for (String string3 : this.createdDirs) {
            if (OS.isUnix()) {
                UnixCommands.chmod(string3, string2);
                continue;
            }
            File file = new File(string3);
            if (!OS.isWindows()) continue;
            Vector<String> vector = new Vector<String>();
            boolean bl = false;
            boolean bl2 = file.isDirectory();
            boolean bl3 = true;
            String string4 = string2;
            if (string4.length() > 3) {
                string4 = string4.substring(1);
            }
            for (int i = 0; i < string4.length() && bl3; ++i) {
                try {
                    int n = Integer.valueOf(string4.substring(i, i));
                    if (n <= 5) continue;
                    bl = true;
                    continue;
                }
                catch (Exception var12_13) {
                    bl3 = false;
                }
            }
            if (bl3) {
                if (bl) {
                    vector.add("-r");
                } else {
                    vector.add("+r");
                }
                if (bl2) {
                    vector.add("/s");
                    vector.add("/d");
                }
            }
            if (vector.size() <= 0) continue;
            WindowsCommands.changePermissions(string3, vector);
        }
    }

    public List getCreatedDirs() {
        return this.createdDirs;
    }

    public void delete() {
        while (!this.createdDirs.empty()) {
            String string = (String)this.createdDirs.pop();
            File file = new File(string);
            if (file.exists()) {
                if (file.isDirectory()) {
                    file.delete();
                    continue;
                }
                this.logMessage(string + " is not a directory");
                continue;
            }
            this.logMessage(string + " does not exist");
        }
    }

    private String getDirPrefix(String string) {
        String string2 = "";
        if (string.startsWith(File.separator)) {
            string2 = File.separator;
        }
        return string2;
    }

    private void makeDir(File file) {
        file.mkdir();
        this.createdDirs.push(file.getPath());
        this.logMessage("created: " + file.getPath());
    }

    private void logMessage(String string) {
        this.log.write(string);
    }
}
