/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.lang.TimeSharer;
import com.denova.ui.TextDisplayable;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

public class Zipper {
    static Hashtable zipFileCache = new Hashtable();
    static List badZipFileCache = new Vector();
    static Log zipLog;
    static List files;
    static TextDisplayable textDisplay;

    public static void unzipFiles(String string) throws Exception {
        Zipper.unzipFilesToDirectory(string, System.getProperty("user.dir"));
    }

    public static void unzipFilesToDirectory(String string, File file) throws Exception {
        Zipper.unzipFilesToDirectory(string, file.getPath());
    }

    public static void unzipFilesToDirectory(String string, String string2) throws Exception {
        FileInputStream fileInputStream = new FileInputStream(string);
        try {
            Zipper.unzipFilesToDirectory(fileInputStream, string2);
        }
        catch (Exception var3_3) {
            // empty catch block
        }
        if (fileInputStream != null) {
            fileInputStream.close();
        }
    }

    public static void unzipFilesToDirectory(InputStream inputStream, String string) throws Exception {
        Zipper.unzipFilesToDirectory(new ZipInputStream(inputStream), string);
        inputStream.close();
    }

    public static void unzipFilesToDirectory(ZipInputStream zipInputStream, String string) throws Exception {
        ZipEntry zipEntry = zipInputStream.getNextEntry();
        while (zipEntry != null) {
            String string2 = zipEntry.getName().replace('/', File.separatorChar);
            Zipper.log("Unzipping " + string2);
            File file = new File(string, string2);
            if (file.getParent() != null) {
                Zipper.makeDirs(file.getParent());
            }
            if (!file.isDirectory()) {
                Zipper.addToCleanupFiles(file);
                FileOutputStream fileOutputStream = new FileOutputStream(file);
                byte[] arrby = new byte[50000];
                int n = zipInputStream.read(arrby, 0, 50000);
                while (n >= 0) {
                    fileOutputStream.write(arrby, 0, n);
                    if (zipInputStream.available() > 0) {
                        n = zipInputStream.read(arrby, 0, 50000);
                        continue;
                    }
                    n = 0;
                }
                fileOutputStream.close();
            }
            zipInputStream.closeEntry();
            zipEntry = zipInputStream.getNextEntry();
            TimeSharer.yield();
        }
        zipInputStream.close();
    }

    public static void zipFilesFromDirectory(String string, File file) throws Exception {
        Zipper.zipFilesFromDirectory(string, file.getPath());
    }

    public static void zipFilesFromDirectory(String string, String string2) throws Exception {
        Zipper.zipFilesFromDirectory(new FileOutputStream(string), string2);
    }

    public static void zipFilesFromDirectory(OutputStream outputStream, String string) throws Exception {
        Zipper.zipFilesFromDirectory(new ZipOutputStream(outputStream), string);
        outputStream.close();
    }

    public static void zipFilesFromDirectory(ZipOutputStream zipOutputStream, String string) throws Exception {
        Zipper.zipFilesFromDirectory(zipOutputStream, string, true);
    }

    public static void zipFilesFromDirectory(ZipOutputStream zipOutputStream, String string, boolean bl) throws Exception {
        File file = new File(string);
        String[] arrstring = file.list();
        for (int i = 0; i < arrstring.length; ++i) {
            String string2 = arrstring[i];
            File file2 = new File(file, string2);
            FileSystem.copyFileToZipStream(file2, string2, file, zipOutputStream);
        }
        if (bl) {
            zipOutputStream.close();
        }
    }

    public static void setTextDisplay(TextDisplayable textDisplayable) {
        textDisplay = textDisplayable;
    }

    public static TextDisplayable getTextDisplay() {
        return textDisplay;
    }

    static void makeDirs(String string) {
        File file = new File(string);
        if (!file.exists()) {
            Zipper.addToCleanupFiles(file);
            String string2 = file.getParent();
            if (string2 != null) {
                Zipper.makeDirs(string2);
            }
            file.mkdir();
        }
    }

    public static ZipFile getZipFile(String string) {
        ZipFile zipFile = null;
        try {
            File file;
            zipFile = (ZipFile)zipFileCache.get(string);
            if (zipFile == null && (file = new File(string)).exists()) {
                zipFile = new ZipFile(string);
            }
            if (zipFile != null) {
                zipFileCache.put(string, zipFile);
            } else {
                Zipper.logBadZipFile(string);
            }
        }
        catch (Exception var2_3) {
            Zipper.logBadZipFile(string);
            Zipper.log(var2_3);
        }
        return zipFile;
    }

    public static ZipEntry getZipEntry(ZipFile zipFile, String string) {
        ZipEntry zipEntry = null;
        try {
            if (zipFile != null) {
                zipEntry = zipFile.getEntry(string);
                if (zipEntry == null) {
                    String string2 = string.replace(File.separatorChar, '/');
                    zipEntry = zipFile.getEntry(string2);
                }
                if (zipEntry == null) {
                    Zipper.log("Unable to get entry from archive: " + string + " from " + zipFile.getName());
                }
            }
        }
        catch (Exception var3_4) {
            String string3 = "Error getting entry from archive: " + string + " from " + zipFile.getName();
            Zipper.log(string3);
            Zipper.log(var3_4);
        }
        return zipEntry;
    }

    static void logBadZipFile(String string) {
        if (!badZipFileCache.contains(string)) {
            badZipFileCache.add(string);
            Zipper.log("Unable to open zip file: " + string);
        }
    }

    public static void addToCleanupFiles(String string) {
        File file = new File(string);
        Zipper.addToCleanupFiles(file);
    }

    public static void addToCleanupFiles(File file) {
        if (files == null) {
            files = new Vector();
        }
        files.add(file);
    }

    public static void cleanupFiles() {
        if (files != null) {
            for (File file : files) {
                file.delete();
                TimeSharer.yield();
            }
            files = new Vector();
        }
    }

    private static void log(String string) {
        Zipper.startLog();
        zipLog.write(string);
        if (textDisplay != null) {
            textDisplay.displayText(string);
        }
    }

    private static void log(Exception exception) {
        Zipper.startLog();
        zipLog.write(exception);
    }

    private static void startLog() {
        if (zipLog == null) {
            File file = TempFiles.getDefaultDirectory();
            zipLog = file != null ? new Log(file.toString(), "zipper") : new Log("zipper");
        }
    }

    static {
        files = new Vector();
    }
}
