/*
 * Decompiled with CFR 0_101.
 */
package com.denova.net;

import com.denova.io.Log;
import com.denova.net.WebFile;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Proxy;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.scheme.SchemeSocketFactory;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;

private static class WebFile.ProxySocketFactory
implements SchemeSocketFactory {
    private Log socketLog = new Log("webproxy");

    private WebFile.ProxySocketFactory() {
    }

    public Socket createSocket(HttpParams httpParams) throws IOException {
        this.log("creating a socket for the proxy");
        if (httpParams == null) {
            this.log("HTTP parameters may not be null when creating a socket");
            throw new IllegalArgumentException("HTTP parameters may not be null");
        }
        String string = (String)httpParams.getParameter("custom.proxy.host");
        Integer n = (Integer)httpParams.getParameter("custom.proxy.port");
        Proxy.Type type = (Proxy.Type)httpParams.getParameter("custom.proxy.type");
        this.log("proxy type: " + (Object)type);
        this.log("proxy host: " + string);
        this.log("proxy port: " + n);
        InetSocketAddress inetSocketAddress = new InetSocketAddress(string, (int)n);
        Proxy proxy = new Proxy(type, inetSocketAddress);
        this.log("proxy type: " + proxy.type().toString());
        this.log("proxy address: " + proxy.address().toString());
        this.log("about to return socket for the proxy");
        return new Socket(proxy);
    }

    public Socket connectSocket(Socket socket, InetSocketAddress inetSocketAddress, InetSocketAddress inetSocketAddress2, HttpParams httpParams) throws IOException, UnknownHostException, ConnectTimeoutException {
        this.log("connecting a socket for the proxy");
        if (inetSocketAddress == null) {
            this.log("HTTP parameters may not be null when creating a socket");
            throw new IllegalArgumentException("Remote address may not be null");
        }
        if (httpParams == null) {
            this.log("HTTP parameters may not be null when creating a socket");
            throw new IllegalArgumentException("HTTP parameters may not be null");
        }
        InetSocketAddress inetSocketAddress3 = InetSocketAddress.createUnresolved(inetSocketAddress.getHostName(), inetSocketAddress.getPort());
        Socket socket2 = null;
        try {
            int n;
            if (socket != null) {
                this.log("predefined socket: " + socket.toString());
                socket2 = socket;
            } else {
                this.log("creating a socket");
                socket2 = this.createSocket(httpParams);
                this.log("new socket: " + socket2.toString());
            }
            if (inetSocketAddress2 != null) {
                this.log("setting up to reuse local address: " + inetSocketAddress2.toString());
                socket2.setReuseAddress(HttpConnectionParams.getSoReuseaddr(httpParams));
                this.log("binding to local address");
                socket2.bind(inetSocketAddress2);
            }
            if ((n = HttpConnectionParams.getConnectionTimeout(httpParams)) == 0) {
                n = 7000;
            }
            try {
                this.log("connecting to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " with timeout: " + n);
                socket2.connect(inetSocketAddress3, n);
            }
            catch (SocketTimeoutException var8_10) {
                this.log("connect to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " timed out");
                this.logException(var8_10);
                throw new ConnectTimeoutException("Connect to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " timed out");
            }
            this.log("returning connected socket for the proxy");
        }
        catch (Exception var7_8) {
            this.logException(var7_8);
        }
        catch (Throwable var7_9) {
            this.logThrowable(var7_9);
        }
        return socket2;
    }

    public final boolean isSecure(Socket socket) throws IllegalArgumentException {
        if (socket == null) {
            throw new IllegalArgumentException("Socket may not be null.");
        }
        if (socket.isClosed()) {
            throw new IllegalArgumentException("Socket is closed.");
        }
        return false;
    }

    private void log(String string) {
        string = string.replace('\r', ' ');
        string = string.replace('\n', ' ');
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(string);
        this.socketLog.write(stringBuffer.toString());
    }

    private void logException(Exception exception) {
        this.socketLog.write(exception);
    }

    private void logThrowable(Throwable throwable) {
        this.socketLog.write(throwable);
    }
}
