/*
 * Decompiled with CFR 0_101.
 */
package com.denova.net;

import com.denova.io.ErrorLog;
import com.denova.io.Log;
import com.denova.net.WebFileProgress;
import com.denova.util.PropertyList;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.InetSocketAddress;
import java.net.MalformedURLException;
import java.net.Proxy;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.UnknownHostException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.http.Consts;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.RequestLine;
import org.apache.http.StatusLine;
import org.apache.http.auth.AuthScheme;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.scheme.SchemeSocketFactory;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.auth.BasicScheme;
import org.apache.http.impl.client.BasicAuthCache;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.util.EntityUtils;

public class WebFile {
    public static final String UserAgent = "DeNova/2.1";
    public static final String OkStatus = "Ok";
    public static final String HTTPGetMethod = "GET";
    public static final String HTTPPostMethod = "POST";
    private static final int HTTPSocket = 80;
    private static final int HTTPSSocket = 443;
    private static final int SocksSocket = 1080;
    private static final long OneSecond = 1000;
    private static final long DefaultMaxWait = 300000;
    private static final int MinOkReturnCode = 200;
    private static final int MaxOkReturnCode = 299;
    private static final int BadRequest = 400;
    private static final int AuthRequired = 407;
    private static final String TempFilename = "qzhttpqz";
    private static final String HttpProxyPrefix = "http.";
    private static final String HttpsProxyPrefix = "https.";
    private static final String SocksProxyPrefix = "socks";
    private static final String ProxyHostAttribute = "proxyHost";
    private static final String ProxyPortAttribute = "proxyPort";
    private static final String ProxyUserAttribute = "proxyUser";
    private static final String ProxyPasswordAttribute = "proxyPassword";
    private static final String SocksProxyUserAttribute = "java.net.socks.username";
    private static final String SocksProxyPasswordAttribute = "java.net.socks.password";
    private static final boolean debug = false;
    private static final String TimedOutStatus = "Timed out";
    private static final int PermanentlyMovedCode = 301;
    private static final int TemporarilyMovedCode = 302;
    private boolean logErrors = true;
    private String status;
    private int httpReturnCode;
    private String httpReturnCodeDescription;
    private long maxWait;
    private String urlString;
    private URL url;
    private String htmlPage;
    private File htmlFile;
    private String webPageUsername;
    private String webPagePassword;
    private String host = null;
    private int port = -1;
    private String proxyHost = null;
    private int proxyPort = -1;
    private String proxyUsername;
    private String proxyPassword;
    private boolean proxyActive = false;
    private boolean httpsProxy = false;
    private boolean socksProxy = false;
    private String httpMethod = "GET";
    private Log webPageLog;
    private WebFileProgress webFileProgress;

    public WebFile() {
        this.init();
        this.log("instantiated WebFile");
    }

    public void setHttpProxy() {
        this.setHttpProxy(false);
    }

    public void setHttpProxy(boolean bl) {
        this.httpsProxy = bl;
        this.socksProxy = false;
        this.proxyActive = true;
    }

    public void setSocksProxy() {
        this.socksProxy = true;
        this.httpsProxy = false;
        this.proxyActive = true;
    }

    public String getProxyType() {
        String string = "direct";
        if (this.proxyActive) {
            string = this.socksProxy ? "socks" : (this.httpsProxy ? "https" : "http");
        }
        this.log("proxy type: " + string);
        return string;
    }

    public void setProxyHost(String string) {
        this.proxyHost = string;
        this.log("proxy host: " + this.proxyHost);
        this.proxyActive = this.proxyHost != null && this.proxyHost.length() > 0;
        this.log("proxy active: " + this.proxyActive);
    }

    public String getProxyHost() {
        return this.proxyHost;
    }

    public void setProxyPort(int n) {
        this.proxyPort = n;
        this.log("proxy port: " + this.proxyPort);
    }

    public int getProxyPort() {
        return this.proxyPort;
    }

    public void setProxyUsername(String string) {
        this.proxyUsername = string;
        this.log("set proxy user name");
    }

    public String getProxyUsername() {
        return this.proxyUsername;
    }

    public void setProxyPassword(String string) {
        this.proxyPassword = string;
        this.log("set proxy password");
    }

    public String getProxyPassword() {
        return this.proxyPassword;
    }

    public void setUsername(String string) {
        this.webPageUsername = string;
        this.log("set web page user name");
    }

    public String getUsername() {
        return this.webPageUsername;
    }

    public void setPassword(String string) {
        this.webPagePassword = string;
        this.log("set web page password");
    }

    public String getPassword() {
        return this.webPagePassword;
    }

    public void setLogErrors(boolean bl) {
        this.logErrors = bl;
        this.log("logErrors: " + this.logErrors);
    }

    public void getPage(String string) {
        this.setUrlString(string);
        if (!this.executeRequest() && this.isProxySet()) {
            this.setUrlString(string);
            this.retryRequestWithOtherProxy();
        }
    }

    public void getFile(String string, String string2) {
        this.getFile(string, new File(string2));
    }

    public void getFile(String string, File file) {
        this.log("getting file from " + string);
        this.htmlFile = file;
        this.log("              to " + file.getPath());
        this.setUrlString(string);
        if (!this.executeRequest() && this.isProxySet()) {
            this.setUrlString(string);
            this.retryRequestWithOtherProxy();
        }
    }

    public String getHtmlPage() {
        return this.htmlPage.trim();
    }

    public boolean isOk() {
        boolean bl = this.httpReturnCodeOk() && "Ok".equals(this.status);
        this.log("isOk: " + bl);
        return bl;
    }

    public boolean httpReturnCodeOk() {
        boolean bl = this.httpReturnCode >= 200 && this.httpReturnCode <= 299;
        this.log("httpReturnCodeOk: " + bl);
        return bl;
    }

    public int getHttpReturnCode() {
        return this.httpReturnCode;
    }

    public String getStatus() {
        return this.status;
    }

    public void setUrlString(String string) {
        this.urlString = new String(string);
        this.log("url: " + this.urlString);
    }

    public void setHttpMethod(String string) {
        this.httpMethod = string;
        this.log("method: " + this.httpMethod);
    }

    public void setMaxWait(long l) {
        this.maxWait = l;
        this.log("set max wait: " + this.maxWait);
    }

    public void setWebFileProgress(WebFileProgress webFileProgress) {
        this.webFileProgress = webFileProgress;
    }

    private WebFileProgress getWebFileProgress() {
        return this.webFileProgress;
    }

    private void logSystemProperties() {
        PropertyList propertyList = new PropertyList(System.getProperties());
        Iterator iterator = propertyList.propertyNamesList().iterator();
        this.log("system properties:");
        while (iterator.hasNext()) {
            String string = (String)iterator.next();
            String string2 = System.getProperty(string);
            this.log("system. getProperty ( " + string + " ) is " + string2);
        }
    }

    private boolean isProxySet() {
        return this.proxyActive;
    }

    private void init() {
        this.webPageLog = new Log("webfile");
        this.logSystemProperties();
        if (this.webPageLog.logFileExists()) {
            Logger.getLogger("org.apache.http.wire").setLevel(Level.FINEST);
            Logger.getLogger("org.apache.http.headers").setLevel(Level.FINEST);
            System.setProperty("org.apache.commons.logging.Log", "org.apache.commons.logging.impl.SimpleLog");
            System.setProperty("org.apache.commons.logging.simplelog.showdatetime", "true");
            System.setProperty("org.apache.commons.logging.simplelog.log.httpclient.wire", "debug");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http", "debug");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http.headers", "debug");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http.wire", "debug");
        } else {
            Logger.getLogger("org.apache.http.wire").setLevel(Level.OFF);
            Logger.getLogger("org.apache.http.headers").setLevel(Level.OFF);
            System.setProperty("org.apache.commons.logging.Log", "org.apache.commons.logging.impl.SimpleLog");
            System.setProperty("org.apache.commons.logging.simplelog.showdatetime", "false");
            System.setProperty("org.apache.commons.logging.simplelog.log.httpclient.wire", "fatal");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http", "fatal");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http.headers", "fatal");
            System.setProperty("org.apache.commons.logging.simplelog.log.org.apache.http.wire", "fatal");
        }
        this.resetPage();
        this.setUrlString("");
    }

    private void resetPage() {
        this.status = "Ok";
        this.maxWait = 300000;
        this.url = null;
        this.httpMethod = "GET";
        this.httpReturnCode = 0;
        this.httpReturnCodeDescription = "";
        this.htmlPage = "";
        this.htmlFile = null;
        if (this.webFileProgress != null) {
            this.webFileProgress.setDone(false);
        }
    }

    private boolean executeRequest() {
        boolean bl = false;
        DefaultHttpClient defaultHttpClient = new DefaultHttpClient();
        defaultHttpClient.getParams().setParameter("http.useragent", "DeNova/2.1");
        try {
            Object object;
            Header[] arrheader;
            Object object2;
            HttpResponse httpResponse;
            String string = this.getParameters();
            URL uRL = this.makeUrl(this.urlString);
            this.host = uRL.getHost();
            this.port = uRL.getPort();
            String string2 = uRL.getProtocol();
            int n = 80;
            if (this.isProxySet()) {
                this.setupProxy(defaultHttpClient, string2, n);
            } else if ("https".equalsIgnoreCase(uRL.getProtocol())) {
                n = 443;
                object = SSLSocketFactory.getSystemSocketFactory();
                object2 = new Scheme(uRL.getProtocol().toLowerCase(), n, (SchemeSocketFactory)object);
                defaultHttpClient.getConnectionManager().getSchemeRegistry().register((Scheme)object2);
            }
            object = new HttpHost(this.host, this.port, string2);
            this.setupWebPageAuth(defaultHttpClient, (HttpHost)object);
            if ("POST".equalsIgnoreCase(this.httpMethod)) {
                object2 = new HttpPost(uRL.getPath());
                if (string.length() > 0) {
                    this.log("encoding parameters");
                    arrheader = new Header[]();
                    String[] arrstring = string.split("\\&");
                    for (int i = 0; i < arrstring.length; ++i) {
                        String[] arrstring2 = arrstring[i].split("=");
                        if (arrstring2.length <= 1) continue;
                        arrheader.add(new BasicNameValuePair(arrstring2[0], arrstring2[1]));
                    }
                    object2.setEntity(new UrlEncodedFormEntity((Iterable<? extends NameValuePair>)arrheader, Consts.UTF_8));
                }
                this.log("executing POST request: " + object2.getRequestLine() + " at " + object);
                if (this.isProxySet()) {
                    this.log("via " + this.getProxyType() + " proxy");
                }
                httpResponse = defaultHttpClient.execute((HttpHost)object, (HttpRequest)object2);
            } else {
                object2 = new HttpGet(uRL.getPath());
                this.log("executing GET request: " + object2.getRequestLine() + " at " + object);
                if (this.isProxySet()) {
                    this.log("via " + this.getProxyType() + " proxy");
                }
                httpResponse = defaultHttpClient.execute((HttpHost)object, (HttpRequest)object2);
            }
            this.setResults(httpResponse);
            object2 = httpResponse.getEntity();
            this.log("---------- Headers ----------");
            arrheader = httpResponse.getAllHeaders();
            for (int i = 0; i < arrheader.length; ++i) {
                this.log(arrheader[i].getName() + ": " + arrheader[i].getValue());
            }
            this.log("---------- Body ----------");
            if (object2 != null) {
                String string3 = EntityUtils.getContentMimeType((HttpEntity)object2);
                long l = object2.getContentLength();
                this.log("Entity content length: " + l);
                if (this.htmlFile == null) {
                    if (string3 != null && this.contentIsHTML(string3) || this.contentIsText(string3)) {
                        this.htmlPage = EntityUtils.toString((HttpEntity)object2);
                        this.log(this.htmlPage);
                    } else {
                        this.log("unable to display content type: " + string3);
                        try {
                            this.log(EntityUtils.toString((HttpEntity)object2));
                        }
                        catch (Exception var14_19) {}
                    }
                } else {
                    this.htmlPage = "";
                    this.log("content type: " + string3);
                    this.log("content length: " + l);
                    this.receiveFile((HttpEntity)object2);
                }
                EntityUtils.consume((HttpEntity)object2);
                if (this.webFileProgress != null) {
                    this.webFileProgress.setTotalBytes(l);
                    this.webFileProgress.setDone(true);
                }
            }
            this.log("---------- End ----------");
            bl = this.isOk();
        }
        catch (Exception var4_4) {
            bl = false;
            this.log(var4_4);
        }
        catch (Throwable var4_5) {
            bl = false;
            this.log(var4_5);
        }
        finally {
            defaultHttpClient.getConnectionManager().shutdown();
        }
        this.log("got request: " + bl);
        return bl;
    }

    private void receiveFile(HttpEntity httpEntity) {
        FileOutputStream fileOutputStream = null;
        try {
            fileOutputStream = new FileOutputStream(this.htmlFile);
            httpEntity.writeTo(fileOutputStream);
        }
        catch (Exception var3_4) {
            this.htmlFile = null;
            this.log(var3_4);
        }
        finally {
            if (fileOutputStream != null) {
                try {
                    fileOutputStream.close();
                }
                catch (Exception var3_5) {}
            }
        }
        if (this.htmlFile.exists()) {
            this.log(this.htmlFile.getName() + " length: " + this.htmlFile.length());
        } else {
            this.log("unable to get " + this.htmlFile.getPath());
        }
    }

    private void setResults(HttpResponse httpResponse) {
        this.log("--------- Status ----------");
        this.httpReturnCode = httpResponse.getStatusLine().getStatusCode();
        this.httpReturnCodeDescription = httpResponse.getStatusLine().getReasonPhrase();
        this.status = this.httpReturnCodeOk() ? "Ok" : this.httpReturnCodeDescription;
        this.log("result code: " + this.httpReturnCode);
        this.log("result description: " + this.httpReturnCodeDescription);
        this.log(httpResponse.getStatusLine().toString());
    }

    private void setupProxy(DefaultHttpClient defaultHttpClient, String string, int n) {
        String string2 = this.getProxyHost();
        int n2 = this.getProxyPort();
        this.log("using " + this.getProxyType() + " proxy");
        if (this.proxyUsername != null && this.proxyUsername.length() > 0 && this.proxyPassword != null && this.proxyPassword.length() > 0) {
            this.log("  with credentials");
            defaultHttpClient.getCredentialsProvider().setCredentials(new AuthScope(this.getProxyHost(), this.getProxyPort()), new UsernamePasswordCredentials(this.proxyUsername, this.proxyPassword));
        }
        this.log("  proxy host: " + string2);
        this.log("  proxy port: " + n2);
        this.log("  scheme: " + string);
        this.log("  scheme port: " + n);
        if (this.socksProxy) {
            defaultHttpClient.getParams().setParameter("custom.proxy.host", string2);
            defaultHttpClient.getParams().setParameter("custom.proxy.port", n2);
            defaultHttpClient.getParams().setParameter("custom.proxy.type", (Object)Proxy.Type.SOCKS);
            defaultHttpClient.getConnectionManager().getSchemeRegistry().register(new Scheme(string, n, new ProxySocketFactory()));
        } else {
            HttpHost httpHost = new HttpHost(string2, n2);
            defaultHttpClient.getParams().setParameter("http.route.default-proxy", httpHost);
        }
    }

    private void setupWebPageAuth(DefaultHttpClient defaultHttpClient, HttpHost httpHost) {
        if (this.webPageUsername != null && this.webPageUsername.length() > 0 && this.webPagePassword != null && this.webPagePassword.length() > 0) {
            defaultHttpClient.getCredentialsProvider().setCredentials(new AuthScope(httpHost.getHostName(), httpHost.getPort()), new UsernamePasswordCredentials(this.webPageUsername, this.webPagePassword));
            BasicAuthCache basicAuthCache = new BasicAuthCache();
            BasicScheme basicScheme = new BasicScheme();
            basicAuthCache.put(httpHost, basicScheme);
            BasicHttpContext basicHttpContext = new BasicHttpContext();
            basicHttpContext.setAttribute("http.auth.auth-cache", basicAuthCache);
        }
    }

    private String getParameters() {
        int n;
        String string = "";
        if ("POST".equalsIgnoreCase(this.httpMethod) && (n = this.urlString.indexOf("?")) >= 0) {
            string = this.urlString.substring(n + 1);
            this.setUrlString(this.urlString.substring(0, n));
        }
        return string;
    }

    private boolean retryRequestWithOtherProxy() {
        if (this.socksProxy) {
            this.log("trying again with http proxy");
            this.setHttpProxy();
        } else {
            this.log("trying again with socks proxy");
            this.setSocksProxy();
        }
        return this.executeRequest();
    }

    private URL makeUrl(String string) {
        URL uRL;
        try {
            uRL = new URL(string);
            if (this.webFileProgress != null) {
                this.webFileProgress.setUrl(uRL);
            }
        }
        catch (MalformedURLException var3_3) {
            try {
                uRL = new URL("file", "", string);
                if (this.webFileProgress != null) {
                    this.webFileProgress.setUrl(uRL);
                }
            }
            catch (MalformedURLException var4_4) {
                this.log("Bad url \"" + string + "\"", var3_3);
                uRL = null;
            }
        }
        return uRL;
    }

    private boolean contentIsHTML(String string) {
        String string2 = string.toLowerCase();
        boolean bl = string2.startsWith("www/source") || string2.startsWith("text/html");
        this.log("content is html: " + bl);
        return bl;
    }

    private boolean contentIsText(String string) {
        String string2 = string.toLowerCase();
        boolean bl = string2.startsWith("www/source") || string2.startsWith("text/html") || string2.startsWith("text/plain");
        this.log("content is text: " + bl);
        return bl;
    }

    private String logMessage(String string) {
        string = string.replace('\r', ' ');
        string = string.replace('\n', ' ');
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(string);
        return stringBuffer.toString();
    }

    private void log(Log log, String string) {
        String string2 = this.logMessage(string);
        log.write(string2);
    }

    private void log(String string) {
        String string2 = this.logMessage(string);
        this.webPageLog.write(string2);
    }

    private void log(Exception exception) {
        this.log("Exception", exception);
    }

    private void log(Throwable throwable) {
        this.log("Throwable", throwable);
    }

    private void log(String string, Throwable throwable) {
        StringBuffer stringBuffer = new StringBuffer(string);
        stringBuffer.append(": ");
        stringBuffer.append(throwable);
        this.log(stringBuffer.toString());
        this.webPageLog.write(throwable);
        System.err.println(stringBuffer.toString());
    }

    private void logError(String string) {
        if (this.logErrors && ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(this.logMessage(string));
        } else {
            this.log("Error: " + string);
        }
    }

    private void logError(Exception exception) {
        if (this.logErrors && ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(exception);
        } else {
            this.log(exception);
        }
    }

    private void logError(Throwable throwable) {
        if (this.logErrors && ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(throwable);
        } else {
            this.log(throwable);
        }
    }

    private void logError(String string, Exception exception) {
        this.logError(string);
        this.logError(exception);
    }

    private static class ProxySocketFactory
    implements SchemeSocketFactory {
        private Log socketLog = new Log("webproxy");

        private ProxySocketFactory() {
        }

        public Socket createSocket(HttpParams httpParams) throws IOException {
            this.log("creating a socket for the proxy");
            if (httpParams == null) {
                this.log("HTTP parameters may not be null when creating a socket");
                throw new IllegalArgumentException("HTTP parameters may not be null");
            }
            String string = (String)httpParams.getParameter("custom.proxy.host");
            Integer n = (Integer)httpParams.getParameter("custom.proxy.port");
            Proxy.Type type = (Proxy.Type)httpParams.getParameter("custom.proxy.type");
            this.log("proxy type: " + (Object)type);
            this.log("proxy host: " + string);
            this.log("proxy port: " + n);
            InetSocketAddress inetSocketAddress = new InetSocketAddress(string, (int)n);
            Proxy proxy = new Proxy(type, inetSocketAddress);
            this.log("proxy type: " + proxy.type().toString());
            this.log("proxy address: " + proxy.address().toString());
            this.log("about to return socket for the proxy");
            return new Socket(proxy);
        }

        public Socket connectSocket(Socket socket, InetSocketAddress inetSocketAddress, InetSocketAddress inetSocketAddress2, HttpParams httpParams) throws IOException, UnknownHostException, ConnectTimeoutException {
            this.log("connecting a socket for the proxy");
            if (inetSocketAddress == null) {
                this.log("HTTP parameters may not be null when creating a socket");
                throw new IllegalArgumentException("Remote address may not be null");
            }
            if (httpParams == null) {
                this.log("HTTP parameters may not be null when creating a socket");
                throw new IllegalArgumentException("HTTP parameters may not be null");
            }
            InetSocketAddress inetSocketAddress3 = InetSocketAddress.createUnresolved(inetSocketAddress.getHostName(), inetSocketAddress.getPort());
            Socket socket2 = null;
            try {
                int n;
                if (socket != null) {
                    this.log("predefined socket: " + socket.toString());
                    socket2 = socket;
                } else {
                    this.log("creating a socket");
                    socket2 = this.createSocket(httpParams);
                    this.log("new socket: " + socket2.toString());
                }
                if (inetSocketAddress2 != null) {
                    this.log("setting up to reuse local address: " + inetSocketAddress2.toString());
                    socket2.setReuseAddress(HttpConnectionParams.getSoReuseaddr(httpParams));
                    this.log("binding to local address");
                    socket2.bind(inetSocketAddress2);
                }
                if ((n = HttpConnectionParams.getConnectionTimeout(httpParams)) == 0) {
                    n = 7000;
                }
                try {
                    this.log("connecting to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " with timeout: " + n);
                    socket2.connect(inetSocketAddress3, n);
                }
                catch (SocketTimeoutException var8_10) {
                    this.log("connect to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " timed out");
                    this.logException(var8_10);
                    throw new ConnectTimeoutException("Connect to " + inetSocketAddress.getHostName() + ":" + inetSocketAddress.getPort() + " timed out");
                }
                this.log("returning connected socket for the proxy");
            }
            catch (Exception var7_8) {
                this.logException(var7_8);
            }
            catch (Throwable var7_9) {
                this.logThrowable(var7_9);
            }
            return socket2;
        }

        public final boolean isSecure(Socket socket) throws IllegalArgumentException {
            if (socket == null) {
                throw new IllegalArgumentException("Socket may not be null.");
            }
            if (socket.isClosed()) {
                throw new IllegalArgumentException("Socket is closed.");
            }
            return false;
        }

        private void log(String string) {
            string = string.replace('\r', ' ');
            string = string.replace('\n', ' ');
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append(string);
            this.socketLog.write(stringBuffer.toString());
        }

        private void logException(Exception exception) {
            this.socketLog.write(exception);
        }

        private void logThrowable(Throwable throwable) {
            this.socketLog.write(throwable);
        }
    }

}
