/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.runtime.Exec;
import com.denova.runtime.OS;
import java.io.File;

public class JRE {
    private static final String Quote = "\"";
    private static final String Dot = ".";
    private static final String Space = " ";
    private static final String JavaCommand = "java";
    private static final boolean debugging = false;
    private static Log jreLog = null;
    private static String javaHome = null;
    private static String javaVersion = null;
    private static String classpathSwitch = "-cp";

    public static String getClasspathSwitch() {
        return classpathSwitch;
    }

    public static void setClasspathSwitch(String string) {
        classpathSwitch = string;
        JRE.log("set classpath switch: " + classpathSwitch);
    }

    public static String getActiveJavaHome() {
        String string = System.getProperty("java.home", "");
        File file = new File(string);
        try {
            string = file.getCanonicalPath();
        }
        catch (Exception var2_2) {
            string = file.getAbsolutePath();
        }
        if (!string.endsWith(File.separator)) {
            string = string + File.separator;
        }
        return string;
    }

    public static String getJavaHome() {
        if (javaHome == null || javaHome.length() <= 0) {
            javaHome = JRE.getActiveJavaHome();
            javaVersion = System.getProperty("java.version", "");
            JRE.log("javaHome: " + javaHome);
            JRE.log("javaVersion: " + javaVersion);
        }
        return javaHome;
    }

    public static String getJavaVersion() {
        if (javaVersion == null || javaVersion.length() <= 0) {
            javaVersion = System.getProperty("java.version", "");
            JRE.log("javaVersion: " + javaVersion);
        }
        return javaVersion;
    }

    public static void setJavaHome(String string) {
        File file = new File(string);
        if (file.exists() && file.isDirectory()) {
            javaHome = string;
            if (!javaHome.endsWith(File.separator)) {
                javaHome = javaHome + File.separator;
            }
            javaVersion = "";
        }
    }

    public static void setJavaHome(String string, String string2) {
        File file = new File(string);
        if (file.exists() && file.isDirectory()) {
            javaHome = string;
            javaVersion = string2;
            if (!javaHome.endsWith(File.separator)) {
                javaHome = javaHome + File.separator;
            }
        }
    }

    public static boolean is32Bit() {
        String string = System.getProperty("os.arch", "");
        return string.indexOf("32") >= 0;
    }

    public static boolean is64Bit() {
        String string = System.getProperty("os.arch", "");
        return string.indexOf("64") >= 0;
    }

    public static String getNativeExecutable(String string) {
        return JRE.getNativeExecutable(string, false);
    }

    public static String getNativeExecutable(String string, boolean bl) {
        String string2;
        File file;
        String string3 = string;
        JRE.log("getting native executable for: " + string);
        if (string3 == null || string3.length() <= 0 || string3.equalsIgnoreCase("jre")) {
            string3 = "java";
            JRE.log("set base name: " + string3);
        }
        String string4 = JRE.getNativeExecBaseName(string3);
        if (OS.isWindows() && !bl && (file = new File(string2 = string4 + "w.exe")).exists()) {
            string4 = string4 + "w";
        }
        if (OS.isWindows() && !string4.endsWith(".exe")) {
            string4 = string4 + ".exe";
        }
        return string4;
    }

    public static String getNativeExecBaseName(String string) {
        File file;
        String string2;
        String string3;
        String string4 = string;
        if (string4 == null || string4.length() <= 0 || string4.equalsIgnoreCase("jre")) {
            string4 = "java";
            JRE.log("using default exec base name: " + string4);
        }
        if (!(file = new File(string2 = JRE.getJavaHome() + "bin" + File.separator + string4)).exists()) {
            JRE.log("executable doesn't exist: " + file.getPath());
            string3 = string2 + ".exe";
            file = new File(string3);
        }
        if (!file.exists()) {
            JRE.log("executable doesn't exist: " + file.getPath());
            string3 = string2 + ".bin";
            file = new File(string3);
        }
        if (!file.exists()) {
            JRE.log("executable doesn't exist: " + file.getPath());
            string2 = "";
        }
        return string2;
    }

    public static String getCommandPrefix(String string) {
        return JRE.getCommandPrefix(string, null);
    }

    public static String getCommandPrefix(String string, String string2) {
        return JRE.getCommandPrefix(string, string2, false);
    }

    public static String getCommandPrefix(String string, String string2, boolean bl) {
        String string3 = null;
        return JRE.getCommandPrefix(string, string2, string3, bl);
    }

    public static String getCommandPrefix(String string, String string2, String string3, boolean bl) {
        String string4 = string2;
        String string5 = string3;
        String string6 = JRE.getNativeExecutable(string, bl);
        JRE.log("executable: " + string6);
        String string7 = Exec.quoteArg(string6);
        if (string5 != null && string5.length() > 0) {
            string7 = string7 + " ";
            string7 = string7 + string5.trim();
        }
        string7 = string7 + " ";
        string7 = string7 + JRE.getClasspathSwitch();
        string7 = string7 + " ";
        if (string4 != null && string4.length() > 0) {
            string7 = string7 + JRE.getQuotedClasspath(string4);
        }
        string7 = string7 + " ";
        JRE.log("command prefix: " + string7);
        return string7;
    }

    public static void execJRE(String string, String string2, String string3, File file, boolean bl) throws Exception {
        JRE.log("Classname: " + string);
        if (string2 != null) {
            JRE.log("Local classpath: " + string2);
        }
        String string4 = JRE.getCommandPrefix("java", string2, string3, bl) + string;
        JRE.log("Command: " + string4);
        if (file == null) {
            Exec.startAppWithoutWaiting(string4);
        } else {
            JRE.log("Directory: " + file.getPath());
            String string5 = JRE.adjustJreClasspath(string4, file.getPath(), true);
            JRE.log("Command after classpath adjustment: " + string5);
            Exec.startAppWithoutWaiting(string5);
        }
    }

    public static void execJRE(String string, String string2, String string3, String string4, String string5, File file, boolean bl) throws Exception {
        JRE.log("Classname: " + string3);
        if (string4 != null) {
            JRE.log("Local classpath: " + string4);
        }
        if (OS.isMacOsX()) {
            string5 = JRE.addMacParams(string, string2, string5);
        }
        String string6 = JRE.getCommandPrefix("java", string4, string5, bl) + string3;
        JRE.log("Command: " + string6);
        if (file == null) {
            Exec.startAppWithoutWaiting(string6);
        } else {
            JRE.log("Directory: " + file.getPath());
            String string7 = JRE.adjustJreClasspath(string6, file.getPath(), true);
            JRE.log("Command after classpath adjustment: " + string7);
            Exec.startAppWithoutWaiting(string7);
        }
    }

    public static int execApp(String string, String string2, String string3, String string4, String string5, File file, boolean bl) throws Exception {
        int n;
        JRE.log("Main class + args: " + string3);
        if (string4 != null) {
            JRE.log("Local classpath: " + string4);
        }
        if (OS.isMacOsX()) {
            string5 = JRE.addMacParams(string, string2, string5);
        }
        String string6 = JRE.getCommandPrefix("java", string4, string5, bl) + string3;
        JRE.log("Command: " + string6);
        if (file == null) {
            n = Exec.execCommand(string6);
        } else {
            JRE.log("Directory: " + file.getPath());
            String string7 = JRE.adjustJreClasspath(string6, file.getPath(), true);
            JRE.log("Command after classpath adjustment: " + string7);
            n = Exec.execCommand(string7);
        }
        return n;
    }

    public static String getClasspath(String string) {
        String string2 = "";
        try {
            String[] arrstring = Exec.getCommandAsStringArray(string);
            if (arrstring != null && arrstring.length > 0) {
                int n;
                boolean bl = false;
                for (n = 0; !(n >= arrstring.length || bl); ++n) {
                    if (!arrstring[n].equals(JRE.getClasspathSwitch())) continue;
                    bl = true;
                }
                if (bl && n < arrstring.length) {
                    string2 = arrstring[n];
                }
            }
        }
        catch (Exception var2_3) {
            JRE.log(var2_3);
        }
        JRE.log("getClasspath() = " + string2);
        return string2;
    }

    public static String adjustJreClasspath(String string, String string2, boolean bl) {
        String string3 = "";
        String[] arrstring = null;
        String string4 = string;
        JRE.log("command before adjustment: " + Exec.quoteArg(string4));
        try {
            arrstring = Exec.getCommandAsStringArray(string4);
            if (arrstring != null && arrstring.length > 0) {
                int n = 0;
                string3 = arrstring[n];
                File file = new File(string3);
                if (file != null) {
                    string3 = file.getName().toLowerCase();
                    if (string3.startsWith("java")) {
                        string4 = JRE.adjustJreClasspath(arrstring, string3, string2, bl);
                    }
                } else {
                    string3 = "";
                }
            }
        }
        catch (Exception var6_7) {
            JRE.log(var6_7);
        }
        JRE.log("command after adjustment: " + Exec.quoteArg(string4));
        return string4;
    }

    public static String adjustJreClasspath(String[] arrstring, String string, String string2, boolean bl) {
        int n;
        String string3;
        String string4 = "";
        String string5 = "";
        String string6 = "";
        String string7 = "";
        boolean bl2 = string.startsWith("java");
        boolean bl3 = false;
        for (n = 0; !(n >= arrstring.length || bl3); ++n) {
            if (arrstring[n].equals(JRE.getClasspathSwitch())) {
                bl3 = true;
                JRE.log("index of classpath switch (" + JRE.getClasspathSwitch() + "): " + n);
            }
            if (!((string3 = arrstring[n]).indexOf(" ") == -1 || string3.startsWith("\"") || string3.endsWith("\""))) {
                string3 = "\"" + string3 + "\"";
            }
            string5 = string5 + string3;
            string5 = string5 + " ";
        }
        if (n < arrstring.length) {
            if (bl3) {
                string7 = arrstring[n];
                JRE.log("initial classpath: " + string7);
                ++n;
            }
            while (n < arrstring.length) {
                string6 = string6 + " ";
                string6 = string6 + arrstring[n];
                ++n;
            }
        }
        string5 = string5.trim();
        string6 = string6.trim();
        JRE.log("initial prefix: " + string5);
        JRE.log("initial remainder: " + string6);
        if (bl) {
            string7 = JRE.changeDotsToCurrentDirectory(string7, string2);
        }
        if (OS.isWindows()) {
            string3 = JRE.getWindowsClasspath(string7);
            if (string3.length() > 0) {
                string7 = string3;
            }
        } else {
            string7 = Exec.quoteArg(string7);
        }
        string4 = JRE.convertOnlyFileSeparators(string5 + " " + string7 + " " + string6);
        string4 = JRE.adjustEscapedCharacters(string5 + " " + string7 + " " + string6);
        return string4;
    }

    private static String getWindowsClasspath(String string) {
        String string2;
        String string3 = "";
        int n = 0;
        int n2 = string.indexOf(File.pathSeparatorChar);
        while (n2 != -1 && n >= 0 && n < string.length() && n2 < string.length()) {
            string2 = JRE.getWinShortName(string.substring(n, n2));
            string3 = string3.length() > 0 ? string3 + File.pathSeparator + string2 : string2;
            n = n2 + 1;
            if (n < string.length()) {
                n2 = string.indexOf(File.pathSeparatorChar, n);
                continue;
            }
            n2 = -1;
        }
        if (n > 0 && n < string.length()) {
            string2 = JRE.getWinShortName(string.substring(n));
            string3 = string3.length() > 0 ? string3 + File.pathSeparator + string2 : string2;
        }
        return string3;
    }

    public static String convertOnlyFileSeparators(String string) {
        String string2 = string;
        StringBuffer stringBuffer = new StringBuffer();
        JRE.log("command before convertOnlyFileSeparators: " + Exec.quoteArg(string2));
        for (int i = 0; i < string2.length(); ++i) {
            if (string2.charAt(i) == '\\') {
                if (i + 1 < string2.length()) {
                    char c = string2.charAt(i + 1);
                    if (c == '/' || c == ':') {
                        stringBuffer.append(string2.charAt(++i));
                        continue;
                    }
                    stringBuffer.append(File.separatorChar);
                    continue;
                }
                stringBuffer.append(File.separatorChar);
                continue;
            }
            if (string2.charAt(i) == '/') {
                stringBuffer.append(File.separatorChar);
                continue;
            }
            if (string2.charAt(i) == ':') {
                stringBuffer.append(File.pathSeparatorChar);
                continue;
            }
            if (string2.charAt(i) == ';') {
                stringBuffer.append(File.pathSeparatorChar);
                continue;
            }
            stringBuffer.append(string2.charAt(i));
        }
        if (stringBuffer.length() > 0) {
            string2 = stringBuffer.toString();
        }
        JRE.log("command after convertOnlyFileSeparators: " + Exec.quoteArg(string2));
        return string2;
    }

    public static String adjustEscapedCharacters(String string) {
        String string2 = string;
        StringBuffer stringBuffer = new StringBuffer();
        JRE.log("command before adjustEscapedCharacters: " + Exec.quoteArg(string2));
        for (int i = 0; i < string2.length(); ++i) {
            if (string2.charAt(i) == '\\') {
                if (i + 1 < string2.length() && string2.charAt(i + 1) == '/') {
                    ++i;
                }
                stringBuffer.append(string2.charAt(i));
                continue;
            }
            stringBuffer.append(string2.charAt(i));
        }
        if (stringBuffer.length() > 0) {
            string2 = stringBuffer.toString();
        }
        JRE.log("command after adjustEscapedCharacters: " + Exec.quoteArg(string2));
        return string2;
    }

    public static String changeDotsToCurrentDirectory(String string, String string2) {
        String string3 = string2;
        String string4 = string;
        String string5 = "";
        JRE.log("changeDotsToCurrentDirectory before: " + Exec.quoteArg(string4));
        JRE.log("currentDirectory: " + string3);
        if (string5 == null || string5.length() < 0) {
            string5 = string4;
        } else {
            string4 = JRE.stripClasspathQuotes(string4);
            int n = string4.indexOf(File.pathSeparator);
            while (n != -1) {
                String string6 = JRE.stripClasspathQuotes(string4.substring(0, n));
                if (string6.startsWith(".")) {
                    string6 = string3 + string6.substring(1);
                }
                if (string5.length() > 0) {
                    string5 = string5 + File.pathSeparator;
                }
                string5 = string5 + string6;
                if (n + 1 < string4.length()) {
                    string4 = string4.substring(n + 1);
                    n = string4.indexOf(File.pathSeparator);
                    continue;
                }
                n = -1;
            }
            if ((string4 = JRE.stripClasspathQuotes(string4)).startsWith(".")) {
                string4 = string3 + string4.substring(1);
            }
            if (string5.length() > 0) {
                string5 = string5 + File.pathSeparator;
            }
            string5 = string5 + string4;
        }
        string5 = JRE.getQuotedClasspath(string5);
        JRE.log("changeDotsToCurrentDirectory after: " + Exec.quoteArg(string5));
        return string5;
    }

    public static String getQuotedClasspath(String string) {
        String string2 = string;
        String string3 = "";
        if (string2 == null || string2.length() < 0) {
            string3 = string;
        } else if (OS.isUnix()) {
            string3 = string2.startsWith("\"") && string2.endsWith("\"") ? string2 : (string2.indexOf(" ") >= 0 ? "\"" + string2 + "\"" : string2);
        } else {
            string2 = JRE.stripClasspathQuotes(string2);
            int n = string2.indexOf(File.pathSeparator);
            while (n != -1) {
                String string4 = string2.substring(0, n);
                string4 = Exec.quoteArg(string4);
                if (string3.length() > 0) {
                    string3 = string3 + File.pathSeparator;
                }
                string3 = string3 + string4;
                if (n + 1 < string2.length()) {
                    string2 = string2.substring(n + 1);
                    n = string2.indexOf(File.pathSeparator);
                    continue;
                }
                n = -1;
            }
            string2 = Exec.quoteArg(string2);
            if (string3.length() > 0) {
                string3 = string3 + File.pathSeparator;
            }
            string3 = string3 + string2;
        }
        JRE.log("quoted classpath: " + string3);
        return string3;
    }

    public static String stripClasspathQuotes(String string) {
        String string2 = string;
        if (string2.startsWith("\"") && string2.endsWith("\"")) {
            int n = string2.lastIndexOf("\"");
            string2 = string2.substring(1, n);
        }
        return string2;
    }

    private static String getWinShortName(String string) {
        int n;
        String string2 = string;
        if (string2.length() > 0 && !string2.startsWith(".") && string2.startsWith("\"") && string2.endsWith("\"") && (n = string2.length() - 1) < string2.length() && n >= 0) {
            string2 = string2.substring(1, n);
        }
        string2 = Exec.quoteArg(string2);
        return string2;
    }

    public static String addMacParams(String string, String string2, String string3) {
        String string4 = string3;
        if (string4 != null) {
            string4 = string4.trim();
        }
        if ((string != null && string.length() > 0 || string2 != null && string2.length() > 0) && string4 == null) {
            string4 = "";
        }
        if (string != null && string.length() > 0) {
            if (string4.length() > 0) {
                string4 = string4 + " ";
            }
            boolean bl = false;
            if (!(string.indexOf(" ") == -1 || string.startsWith("\""))) {
                string4 = string4 + "\"";
                bl = true;
            }
            string4 = string4 + "-Xdock:name=";
            string4 = string4 + string;
            if (bl) {
                string4 = string4 + "\"";
            }
            JRE.log("added dock's name: " + string4);
        }
        if (string2 != null && string2.length() > 0) {
            File file;
            if (!string2.endsWith(".icns")) {
                string2 = string2 + ".icns";
            }
            if ((file = new File(string2)).exists()) {
                if (string4.length() > 0) {
                    string4 = string4 + " ";
                }
                boolean bl = false;
                if (!(string2.indexOf(" ") < 0 || string2.startsWith("\""))) {
                    string4 = string4 + "\"";
                    bl = true;
                }
                string4 = string4 + "-Xdock:icon=";
                string4 = string4 + string2;
                if (bl) {
                    string4 = string4 + "\"";
                }
                JRE.log("added dock's icon");
            } else {
                JRE.log("icon file doesn't exist: " + string2);
            }
        }
        JRE.log("mac's params: " + string4);
        return string4;
    }

    static void log(String string) {
        String string2 = "JRE: " + string;
        JRE.startLogging();
        jreLog.write(string2);
        JRE.debug(string2);
    }

    static void log(Exception exception) {
        JRE.startLogging();
        jreLog.write(exception);
    }

    static void startLogging() {
        if (jreLog == null) {
            jreLog = new Log("jre");
        }
    }

    static void debug(String string) {
    }
}
