/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.runtime.Exec;
import com.denova.runtime.UnixCommands;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;

public class LinuxServices {
    private static final Log log = new Log("linux");
    private static String distroName = null;

    public boolean installService(String string, String string2) {
        boolean bl = false;
        File file = new File(string2);
        String string3 = "/etc/init.d/" + file.getName();
        File file2 = new File(string3);
        try {
            if (this.isDebianStyleDistro()) {
                file2.delete();
                log.write("begin writing shell script in " + string3);
                FileOutputStream fileOutputStream = new FileOutputStream(string3);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                printWriter.println("#!/bin/sh");
                printWriter.println("cd " + file.getParent());
                printWriter.println("sh " + Exec.quoteArg(file.getName()));
                printWriter.close();
                fileOutputStream.close();
                log.write("end shell script");
                UnixCommands.chmod("+x", file2.getPath());
                String string4 = "update-rc.d -f " + file.getName() + " start 80 2 3 4 5 . stop 30 0 1 6 .";
                log.write("command: " + string4);
                Exec.runCommand(string4);
                bl = true;
            } else if (this.isRedHatStyleDistro()) {
                file2.delete();
                log.write("begin writing shell script in " + string3);
                FileOutputStream fileOutputStream = new FileOutputStream(string3);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                printWriter.println("#!/bin/sh");
                printWriter.println("# chkconfig: 2345 80 30");
                printWriter.println("# description: " + string);
                printWriter.println("cd " + file.getParent());
                printWriter.println("sh " + Exec.quoteArg(file.getName()));
                printWriter.close();
                fileOutputStream.close();
                log.write("end shell script");
                UnixCommands.chmod("+x", file2.getPath());
                String string5 = "chkconfig " + file.getName() + " --add";
                log.write("command: " + string5);
                Exec.runCommand(string5);
                bl = true;
            }
        }
        catch (Exception var7_9) {
            log.write(var7_9);
        }
        return bl;
    }

    public boolean removeService(String string) {
        boolean bl = false;
        File file = new File(string);
        String string2 = "/etc/init.d/" + file.getName();
        try {
            File file2 = new File(string2);
            if (this.isDebianStyleDistro()) {
                String string3 = "update-rc.d -f " + file.getName() + " remove";
                Exec.runCommand(string3);
                log.write("command: " + string3);
                file2.delete();
                bl = true;
            } else if (this.isRedHatStyleDistro()) {
                String string4 = "chkconfig --delete " + file.getName();
                Exec.runCommand(string4);
                log.write("command: " + string4);
                file2.delete();
                bl = true;
            }
        }
        catch (Exception var5_6) {
            log.write(var5_6);
        }
        return bl;
    }

    public boolean isDebianStyleDistro() {
        String string = this.getDistroName().toLowerCase();
        return string.startsWith("debian") || string.startsWith("ubuntu") || string.startsWith("knoppix") || string.startsWith("linux mint") || string.startsWith("backtrack") || string.startsWith("kubuntu") || string.startsWith("xubuntu") || string.startsWith("lubuntu");
    }

    public boolean isRedHatStyleDistro() {
        String string = this.getDistroName().toLowerCase();
        return string.startsWith("redhat") || string.startsWith("red hat") || string.startsWith("fedora") || string.startsWith("centos") || string.startsWith("backtrack") || string.startsWith("oracle") || string.startsWith("mandriva") || string.startsWith("pclinuxos") || string.startsWith("suse") || string.startsWith("opensuse") || string.startsWith("mageia");
    }

    public boolean isBsdStyleDistro() {
        String string = this.getDistroName().toLowerCase();
        return string.startsWith("bsd") || string.startsWith("freebsd") || string.startsWith("slackware") || string.startsWith("arch linux") || string.startsWith("gentoo");
    }

    public boolean supportServices() {
        return this.isDebianStyleDistro() || this.isRedHatStyleDistro();
    }

    public String getDistroName() {
        if (distroName == null) {
            try {
                File file = new File("/etc/issue");
                if (file.exists()) {
                    int n;
                    FileInputStream fileInputStream = new FileInputStream(file);
                    InputStreamReader inputStreamReader = new InputStreamReader(fileInputStream);
                    BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                    boolean bl = false;
                    String string = bufferedReader.readLine();
                    if (string != null && (n = (LinuxServices.distroName = string.trim()).indexOf(10)) > 0) {
                        distroName = distroName.substring(0, n);
                    }
                    bufferedReader.close();
                    inputStreamReader.close();
                    fileInputStream.close();
                    log.write("distro name: " + distroName);
                } else {
                    log.write("unable to find /etc/issue");
                }
            }
            catch (Exception var1_2) {
                log.write(var1_2);
            }
        }
        return distroName;
    }
}
