/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.io.MakeDirs;
import com.denova.io.TempFiles;
import com.denova.lang.LangUtilities;
import com.denova.runtime.CommandMap;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.UnixMenu;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.List;
import java.util.Locale;
import java.util.Vector;

public class MacOS {
    public static final String MacAppDir = "/Applications";
    public static final String MacOSLogFilename = "maccmds";
    public static final String LaunchScriptExtension = ".command";
    public static final String MacAppDirExtension = ".app";
    public static final String MacAppPackage = "$APP_PACKAGE/";
    public static final String MacAppVariable = "$APP_PACKAGE/..";
    public static final String ContentsDirName = "Contents";
    public static final String MacOsDirName = "MacOS";
    public static final String ResourcesDirName = "Resources";
    public static final String JavaDirName = "Java";
    public static final String InfoPropertyFilename = "Info.plist";
    public static final String PackageIconFilename = "mac-installer.icns";
    public static final String InfoJavaTemplateFilename = "InfoJavaTemplate.plist";
    public static final String InfoAppTemplateFilename = "InfoAppTemplate.plist";
    public static final String PackageInfoFilename = "PkgInfo";
    public static final String ClasspathTemplate = "<key>ClassPath</key>";
    public static final String SplashFileTemplate = "<key>SplashFile</key>";
    public static final String KeyTemplate = "<key>";
    public static final String EndKeyTemplate = "</key>";
    public static final String ArrayTemplate = "<array>";
    public static final String EndArrayTemplate = "</array>";
    public static final String StringTemplate = "<string>";
    public static final String EndStringTemplate = "</string>";
    public static final String DictTemplate = "<dict>";
    public static final String EndDictTemplate = "</dict>";
    public static final String StringIndent = "            ";
    public static final String PlatformName = "MacOsX";
    public static final String JavaVersionsDir = "/System/Library/Frameworks/JavaVM.framework/Versions";
    private static final boolean debugging = false;
    private static final String DesktopSubidrectory = "Desktop";
    private static final String BlankString = "";
    private static UnixMenu unixMenu;
    private static Log log;
    private static final String DefaultJavaIconFilename = "JavaApp.icns";
    private static final String JavaApplicationStubFilename = "JavaApplicationStub";
    private static final String JavaAppStubFilename = "JavaAppStub";
    private static final String StartJavaAppExec = "JavaApp.bin";
    private static final String JavaAppScript = "JavaApp.command";
    private static final String JavaAdminAppScript = "JavaAdminApp.command";
    private static final String JavaAdminBin = "JavaAdmin.bin";
    private static final String LanguageProjectExtension = ".lproj";
    private static final String DefaultFrameworkDir = "/System/Library/Frameworks/JavaVM.framework/Resources/MacOS";
    private static final String JavaAppStubTemplate = "JEX_JavaAppStub";
    private static final String LaunchScriptTemplate = "JEX_LaunchScript";
    private static final String MenuIconNameTemplate = "JEX_MenuIconName";
    private static final String MenuLongNameTemplate = "JEX_MenuLongName";
    private static final String PackageVersionTemplate = "JEX_PackageVersion";
    private static final String PackageCopyrightTemplate = "JEX_PackageCopyright";
    private static final String InstalledByTemplate = "JEX_InstalledBy";
    private static final String JvmVersionTemplate = "JEX_JvmVersion";
    private static final String WorkingDirTemplate = "JEX_WorkingDir";
    private static final String MenuExecutableFileTemplate = "JEX_MenuExecutableFile";
    private static final String MenuCommandLineArgumentsTemplate = "JEX_MenuCommandLineArguments";
    private static final String MenuSplashFileTemplate = "JEX_SplashFile";
    private static final String InstallJvmParametersTemplate = "JEX_InstallJvmParameters";
    private static final String LibrarySubdirectory = "Library";
    private static final String PreferencesSubdirectory = "Preferences";
    private static final String LoginWindowFilename = "loginwindow.plist";
    private List createdDirs = null;
    private String installDir = "";
    private String workingDir = "";
    private String launchDirName = "";
    private String submenu = "";
    private String longName = "";
    private String shortName = "";
    private String executableFile = "";
    private String commandLineArguments = "";
    private String iconFilename = "";
    private String splashFile = "";
    private boolean runAsAdmin = false;
    private boolean allUsers = false;

    public MacOS() {
        log = new Log("maccmds");
        unixMenu = new UnixMenu(log);
    }

    public MacOS(Log log) {
        MacOS.log = log;
        unixMenu = new UnixMenu(MacOS.log);
    }

    public static String getDesktopDirectory() {
        String string = "Desktop";
        File file = new File(System.getProperty("user.home"));
        if (file != null && file.exists()) {
            File file2 = new File(file, "Desktop");
            string = file2.getPath();
        } else {
            log.write("Unable to get the user's home directory");
            log.write("and therefore unable to get the desktop dir");
        }
        return string;
    }

    public static boolean isError() {
        return LangUtilities.isError();
    }

    public static Exception getLastException() {
        return LangUtilities.getLastException();
    }

    public static String getLastError() {
        return LangUtilities.getLastError();
    }

    public static void clearError() {
        LangUtilities.clearError();
    }

    public void setSubmenu(String string) {
        this.submenu = string.replace('/', File.separatorChar);
    }

    public void setInstallDir(String string) {
        this.installDir = string;
        if (this.workingDir == null || this.workingDir.length() <= 0) {
            this.workingDir = this.installDir;
        }
    }

    public void setWorkingDir(String string) {
        this.workingDir = string;
        if (this.installDir == null || this.installDir.length() <= 0) {
            this.installDir = this.workingDir;
        }
    }

    public void setLaunchDirName(String string) {
        this.launchDirName = string;
        unixMenu.setLaunchDirName(string);
    }

    public void setLongName(String string) {
        this.longName = string;
    }

    public void setShortName(String string) {
        this.shortName = string;
    }

    public void setExecutableFile(String string) {
        this.executableFile = string;
    }

    public void setCommandLineArguments(String string) {
        this.commandLineArguments = string;
    }

    public void setRunAsAdmin(boolean bl) {
        this.runAsAdmin = bl;
    }

    public void setAllUsers(boolean bl) {
        this.allUsers = bl;
    }

    public void setIconFilename(String string) {
        this.iconFilename = string;
    }

    public void setSplashFile(String string) {
        this.splashFile = string;
    }

    public String addLaunchScript() {
        return this.addLaunchScript(false, false, "", false);
    }

    public String addLaunchScript(boolean bl, boolean bl2, String string, boolean bl3) {
        String string2 = this.shortName;
        if (!string2.endsWith(".command")) {
            string2 = this.shortName + ".command";
        }
        log.write("unix launch script name: " + string2);
        unixMenu.setSubmenu(this.submenu);
        unixMenu.setInstallDir(this.installDir);
        unixMenu.setWorkingDir(this.workingDir);
        unixMenu.setLaunchDirName(this.installDir);
        unixMenu.setLongName(this.longName);
        unixMenu.setShortName(string2);
        unixMenu.setExecutableFile(this.executableFile);
        unixMenu.setCommandLineArguments(this.commandLineArguments);
        unixMenu.setIconFilename(this.iconFilename);
        unixMenu.setRunAsAdmin(this.runAsAdmin);
        unixMenu.setAllUsers(this.allUsers);
        unixMenu.addLaunchScript(bl, bl2, string, false, false, false);
        if (bl3) {
            this.addDesktopLink(this.installDir, string2, this.longName);
        } else {
            log.write("No desktop icon created for " + string2);
        }
        File file = new File(this.installDir, string2);
        CommandMap.put(this.longName, file.getPath());
        return string2;
    }

    public String addMacLauncher(boolean bl, boolean bl2, String string, String string2, String string3, String string4, String string5, String string6, String string7) {
        return this.addMacLauncher(bl, bl2, string, string2, string3, string4, string5, string6, string7, true);
    }

    public String addMacLauncher(boolean bl, boolean bl2, String string, String string2, String string3, String string4, String string5, String string6, String string7, boolean bl3) {
        return this.addMacLauncher(bl, bl2, string, string2, string3, string4, string5, string6, string7, bl3, false);
    }

    public String addMacLauncher(boolean bl, boolean bl2, String string, String string2, String string3, String string4, String string5, String string6, String string7, boolean bl3, boolean bl4) {
        String string8;
        int n;
        if (this.shortName.endsWith(".command") && (n = this.shortName.lastIndexOf(46)) > 0) {
            this.shortName = this.shortName.substring(0, n);
        }
        if (bl) {
            string8 = this.createJavaAppLauncher(string2, string3, string4, string5, string6, string7, bl3);
            File file = new File(this.installDir, this.longName + ".app");
            File file2 = new File(file, "Contents");
            File file3 = new File(file2, "MacOS");
            File file4 = new File(file3, this.shortName);
            CommandMap.put(this.longName, file4.getPath());
        } else {
            File file = new File(this.installDir, this.executableFile);
            if (file.exists()) {
                string8 = file.getPath();
                if (file.isDirectory()) {
                    UnixCommands.chmod("-R 0755", string8);
                    log.write("set executable bit on: " + string8);
                } else {
                    UnixCommands.chmod("0755", file.getPath());
                    log.write("set executable bit on: " + string8);
                }
                if (bl3) {
                    this.addDesktopLink(this.installDir, this.executableFile);
                }
                CommandMap.put(this.longName, string8);
            } else {
                string8 = this.addLaunchScript(bl, bl2, string, bl3);
            }
        }
        return string8;
    }

    public String createJavaAppLauncher(String string, String string2, String string3, String string4, String string5, String string6, boolean bl) {
        Object object;
        boolean bl2 = false;
        String string7 = this.longName.length() > 0 ? this.longName : this.shortName;
        String string8 = string7 + ".app";
        log.write("creating Java app launcher: " + string8);
        File file = this.buildJavaAppDirTree(string8);
        if (file != null) {
            object = this.copyIconToResources(file);
            String string9 = this.setupJavaApp(file, this.shortName);
            boolean bl3 = bl2 = string9 != null;
            if (bl2) {
                bl2 = this.copyPackageInfo(file);
            }
            if (bl2) {
                bl2 = this.buildJavaInfoProperty(file, string9, string7, (String)object, string, string2, string3, string4, string5, string6);
            }
            if (bl2) {
                if (bl) {
                    this.addDesktopLink(this.installDir, string8);
                } else {
                    log.write("No desktop icon created for " + string8);
                }
            } else {
                log.write("not ok after buildInfoProperty");
            }
        }
        if (!bl2) {
            object = new File(this.installDir, string8);
            if (object.exists()) {
                FileSystem.removeDirectory((File)object);
            }
            string8 = null;
        }
        return string8;
    }

    public String createAppLauncher(String string, String string2, String string3, boolean bl) {
        Object object;
        boolean bl2 = false;
        String string4 = this.longName.length() > 0 ? this.longName : this.shortName;
        String string5 = string4 + ".app";
        log.write("creating app launcher: " + string5);
        File file = this.buildAppDirTree(string5);
        if (file != null) {
            object = this.copyIconToResources(file);
            File file2 = new File(this.installDir, string);
            bl2 = this.copyFileToMacOS(file, file2, string);
            if (bl2) {
                bl2 = this.copyPackageInfo(file);
            }
            if (bl2) {
                bl2 = this.buildInfoProperty(file, string4, (String)object, string2, string3);
            }
            if (bl2) {
                if (bl) {
                    this.addDesktopLink(this.installDir, string5);
                } else {
                    log.write("No desktop icon created for " + string5);
                }
            } else {
                log.write("not ok after buildInfoProperty");
            }
        }
        if (!bl2) {
            object = new File(this.installDir, string5);
            if (object.exists()) {
                FileSystem.removeDirectory((File)object);
            }
            string5 = null;
        }
        return string5;
    }

    public File buildAppDirTree(String string) {
        File file;
        boolean bl = false;
        File file2 = null;
        if (!string.endsWith(".app")) {
            string = string + ".app";
        }
        if ((file = new File(this.installDir, string)).exists()) {
            FileSystem.removeDirectory(file);
        }
        if (this.makeDir(this.installDir, string)) {
            if (this.makeDir(file, "Contents")) {
                File file3 = new File(file, "Contents");
                if (!this.makeDir(file3, "MacOS")) {
                    bl = false;
                    log.write("unable to create Mac OS directory");
                }
                if (this.makeDir(file3, "Resources")) {
                    File file4 = new File(file3, "Resources");
                    this.makeDir(file4, Locale.ENGLISH.getLanguage() + ".lproj");
                    this.makeDir(file4, "es.lproj");
                    this.makeDir(file4, Locale.GERMAN.getLanguage() + ".lproj");
                    this.makeDir(file4, Locale.FRENCH.getLanguage() + ".lproj");
                    this.makeDir(file4, "pl.lproj");
                    this.makeDir(file4, Locale.JAPANESE.getLanguage() + ".lproj");
                    this.makeDir(file4, Locale.SIMPLIFIED_CHINESE.getLanguage() + ".lproj");
                    this.makeDir(file4, Locale.TRADITIONAL_CHINESE.getLanguage() + ".lproj");
                    this.makeDir(file4, Locale.ITALIAN.getLanguage() + ".lproj");
                    this.makeDir(file4, "pt.lproj");
                    this.makeDir(file4, "nl.lproj");
                    bl = true;
                } else {
                    bl = false;
                    log.write("unable to create Mac resources directory");
                }
                if (bl) {
                    file2 = file3;
                }
            } else {
                bl = false;
                log.write("unable to create Mac contents directory");
            }
        } else {
            bl = false;
            log.write("unable to create Mac app directory");
        }
        return file2;
    }

    public void deleteLaunchScript(String string) {
        File file = new File(string);
        if (file.exists()) {
            file.delete();
        }
    }

    public List getCreatedDirs() {
        return this.createdDirs;
    }

    public static String getJvmVersion(String string, String string2, String string3) {
        String string4;
        String string5 = MacOS.stripSubversion(string);
        String string6 = MacOS.stripSubversion(string2);
        String string7 = MacOS.stripSubversion(string3);
        if (string5.length() > 0) {
            string4 = string5;
            int n = string4.indexOf(".");
            if (n != -1 && string4.length() > n) {
                if ((n = string4.substring(n).indexOf(".")) == -1) {
                    string4 = string4 + "*";
                }
            } else {
                string4 = string4 + "*";
            }
        } else if (string6.length() > 0) {
            string4 = string6;
            if (string7.length() > 0) {
                int n = string7.indexOf(".");
                int n2 = string7.lastIndexOf(".");
                if (n != -1) {
                    if (n != n2) {
                        string7 = string7.substring(0, n2);
                    }
                    string4 = string6.startsWith(string7) ? string4 + "*" : string4 + "+";
                } else {
                    string4 = string4 + "+";
                }
            } else {
                string4 = string4 + "+";
            }
        } else {
            string4 = MacOS.stripSubversion(System.getProperty("java.version", "1.5")) + "+";
        }
        return string4;
    }

    public static void insertClasspath(String string, BufferedReader bufferedReader, PrintWriter printWriter) {
        String string2;
        int n = string.indexOf(File.pathSeparator);
        while (n != -1) {
            string2 = MacOS.getClasspathComponent(string, n);
            printWriter.println("            <string>" + string2 + "</string>");
            string = string.substring(n + 1);
            n = string.indexOf(File.pathSeparator);
        }
        string2 = MacOS.getClasspathComponent(string, string.length());
        printWriter.println("            <string>" + string2 + "</string>");
    }

    private static String stripSubversion(String string) {
        int n;
        String string2 = string;
        if (string != null && (n = string.indexOf("_")) != -1) {
            string2 = string.substring(0, n);
        }
        return string2;
    }

    private void adjustLaunchScript(String string, String string2) {
        boolean bl = true;
        File file = new File(this.installDir, string2);
        File file2 = new File(file, "Contents");
        File file3 = new File(file2, "MacOS");
        File file4 = new File(file3, string);
        File file5 = new File(file3, string + ".new");
        log.write("adjusting launch script: " + file4.getPath());
        try {
            FileReader fileReader = new FileReader(file4);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            FileOutputStream fileOutputStream = new FileOutputStream(file5);
            try {
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                String string3 = bufferedReader.readLine();
                while (string3 != null) {
                    if (string3.startsWith("dir=")) {
                        string3 = "dir=\"${0%/*}/../../..\"";
                    }
                    if (string3 == null) continue;
                    printWriter.println(string3);
                    string3 = bufferedReader.readLine();
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var12_14) {
                bl = false;
                this.logException("Unable to save the command " + file5.getPath(), var12_14);
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (IOException var9_10) {
            bl = false;
            log.write("Unexpected error: " + var9_10.getMessage());
        }
        if (bl) {
            file4.delete();
            file5.renameTo(file4);
            UnixCommands.chmod("0755", file4.getPath());
            log.write("finished adjusting script");
        }
    }

    private boolean addLoginItem(String string, boolean bl) {
        boolean bl2 = false;
        File file = new File(System.getProperty("user.home"));
        if (file != null && file.exists()) {
            File file2 = new File(file, "Library");
            if (file2 != null && file2.exists()) {
                File file3 = new File(file2, "Preferences");
                if (file3 != null && file3.exists()) {
                    File file4 = new File(file3, "loginwindow.plist");
                    if (file4 != null && file4.exists()) {
                        bl2 = true;
                    } else {
                        log.write("Unable to add login item; no loginwindow.plist");
                    }
                } else {
                    log.write("Unable to get the user's Preferences directory");
                }
            } else {
                log.write("Unable to get the user's Library directory");
            }
        } else {
            log.write("Unable to get the user's home directory");
        }
        return bl2;
    }

    void rememberError(Exception exception) {
        LangUtilities.rememberError(exception);
    }

    void rememberError(String string) {
        LangUtilities.rememberError(string);
    }

    void rememberError(String string, Exception exception) {
        LangUtilities.rememberError(string, exception);
    }

    void logException(String string, Exception exception) {
        log.write(string);
        log.write("Exception: " + exception.getMessage());
        this.rememberError(string, exception);
    }

    void debug(String string) {
    }

    private File buildJavaAppDirTree(String string) {
        boolean bl = true;
        File file = this.buildAppDirTree(string);
        if (file != null && file.exists() && file.isDirectory()) {
            File file2 = new File(file, "MacOS");
            File file3 = new File(file, "Resources");
            this.makeDir(file3, "Java");
        }
        return file;
    }

    private String copyIconToResources(File file) {
        boolean bl = false;
        File file2 = null;
        String string = this.iconFilename;
        if (this.iconFilename != null && this.iconFilename.length() > 0) {
            file2 = new File(this.iconFilename);
            bl = this.copyIconFile(file2, file);
        } else {
            bl = false;
            this.iconFilename = "";
        }
        if (bl) {
            string = file2.getName();
            log.write("installed " + string + " to " + file.getPath());
        } else {
            log.write("unable to copy " + this.iconFilename + " to " + file.getPath());
            file2 = new File(TempFiles.getDefaultDirectory(), "JavaApp.icns");
            if (!(file2 == null || file2.exists())) {
                if (LangUtilities.getResourceAsFile(file2.getPath())) {
                    file2.deleteOnExit();
                    log.write("got " + file2.getPath() + " as resource");
                } else {
                    file2 = null;
                    log.write("Unable to extract " + file2.getPath());
                }
            }
            if (file2 != null && this.copyIconFile(file2, file)) {
                string = file2.getName();
                log.write("installed default icon file to resources " + string);
            } else {
                string = null;
                log.write("unable to install any icon to resources");
            }
        }
        return string;
    }

    private boolean copyIconFile(File file, File file2) {
        boolean bl = false;
        if (file != null && file.exists()) {
            File file3 = new File(file2, "Resources");
            try {
                FileSystem.copyFile(file, file3);
                bl = true;
            }
            catch (Exception var5_5) {
                bl = false;
                this.logException("Unable to copy icon file (" + file.getPath() + ") to " + file3.getPath(), var5_5);
            }
        }
        return bl;
    }

    private boolean copyPackageInfo(File file) {
        boolean bl = false;
        File file2 = new File(TempFiles.getDefaultDirectory(), "PkgInfo");
        if (!(file2 == null || file2.exists())) {
            if (LangUtilities.getResourceAsFile(file2.getPath())) {
                file2.deleteOnExit();
            } else {
                file2 = null;
                log.write("Unable to extract " + file2.getPath());
            }
        }
        if (file2 != null) {
            try {
                FileSystem.copyFile(file2, file);
                bl = true;
            }
            catch (Exception var4_4) {
                bl = false;
                this.logException("Unable to copy " + file2.getPath() + " to " + file.getPath(), var4_4);
            }
        } else {
            bl = false;
            log.write("Unable to extract " + file2.getPath());
        }
        return bl;
    }

    private String setupJavaApp(File file, String string) {
        String string2 = null;
        if (this.copyJavaStub(file)) {
            File file2;
            String string3 = "JavaApp.command";
            if (this.runAsAdmin) {
                file2 = this.getFile("JavaAdmin.bin");
                if (file2 != null && this.copyFileToMacOS(file, file2, "JavaAdmin.bin")) {
                    string2 = string;
                } else {
                    log.write("Unable to copy JavaAdmin.bin");
                }
                string3 = "JavaAdminApp.command";
            }
            if ((file2 = this.getFile(string3)) != null && this.copyFileToMacOS(file, file2, string)) {
                string2 = string;
            } else {
                log.write("Unable to copy " + string3);
            }
        }
        return string2;
    }

    private boolean copyJavaStub(File file) {
        boolean bl = false;
        File file2 = new File("/System/Library/Frameworks/JavaVM.framework/Resources/MacOS", "JavaApplicationStub");
        if (!(file2 != null && file2.exists() && file2.length() != 0)) {
            log.write("getting distributed java stub");
            file2 = this.getFile("JavaAppStub");
        }
        if (file2 != null) {
            bl = this.copyFileToMacOS(file, file2, "JavaApp.bin");
        } else {
            log.write("Unable to get JavaAppStub");
        }
        return bl;
    }

    private File getFile(String string) {
        File file = new File(TempFiles.getDefaultDirectory(), string);
        if (!(file == null || file.exists())) {
            if (LangUtilities.getResourceAsFile(file.getPath())) {
                file.deleteOnExit();
            } else {
                File file2 = new File(System.getProperty("user.dir", ""), "macapp");
                file = new File(file2, string);
                if (!file.exists()) {
                    file = null;
                }
            }
        }
        return file;
    }

    private boolean copyFileToMacOS(File file, File file2, String string) {
        boolean bl = false;
        if (file2 != null && file2.exists()) {
            File file3 = new File(file, "MacOS");
            File file4 = new File(file3, string);
            try {
                if (!file3.exists()) {
                    log.write("Creating " + file3.getPath());
                    this.makeDir(file, "MacOS");
                }
                log.write("Copying " + file2.getPath());
                log.write("     to " + file4.getPath());
                FileSystem.copyFile(file2, file4);
                if (file4 != null && file4.exists()) {
                    UnixCommands.chmod("0755", file4.getPath());
                    log.write("configured: " + file4.getPath());
                } else {
                    log.write("File doesn't exist: " + file4.getPath());
                }
                bl = true;
            }
            catch (Exception var7_7) {
                bl = false;
                this.logException("Unable to copy file", var7_7);
            }
        }
        return bl;
    }

    private boolean buildInfoProperty(File file, String string, String string2, String string3, String string4) {
        boolean bl = false;
        File file2 = new File(TempFiles.getDefaultDirectory(), "InfoAppTemplate.plist");
        if (!(file2 == null || file2.exists())) {
            if (LangUtilities.getResourceAsFile(file2.getPath())) {
                file2.deleteOnExit();
            } else {
                file2 = null;
                log.write("Unable to extract " + file2.getPath());
            }
        }
        if (file2 != null) {
            try {
                FileSystem.copyFile(file2, file);
                bl = this.modifyInfoProperties(file, string, string2, string3, string4);
                File file3 = new File(file, "InfoAppTemplate.plist");
                file3.delete();
            }
            catch (Exception var8_9) {
                bl = false;
                this.logException("Unable to copy " + file2.getPath() + " to " + file.getPath(), var8_9);
            }
        } else {
            bl = false;
            log.write("Unable to extract " + file2.getPath());
        }
        return bl;
    }

    private boolean modifyInfoProperties(File file, String string, String string2, String string3, String string4) {
        boolean bl = true;
        try {
            File file2 = new File(file, "InfoAppTemplate.plist");
            FileReader fileReader = new FileReader(file2);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            File file3 = new File(file, "Info.plist");
            FileOutputStream fileOutputStream = new FileOutputStream(file3);
            try {
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                String string5 = bufferedReader.readLine();
                while (string5 != null) {
                    String string6;
                    int n = string5.indexOf("JEX_LaunchScript");
                    if (n != -1) {
                        string5 = string6 = string5.substring(0, n) + this.executableFile + string5.substring(n + "JEX_LaunchScript".length());
                        log.write("Executable file: " + this.executableFile);
                    } else {
                        n = string5.indexOf("JEX_MenuIconName");
                        if (n != -1) {
                            string5 = string6 = string5.substring(0, n) + string2 + string5.substring(n + "JEX_MenuIconName".length());
                            log.write("icon filename: " + string2);
                        } else {
                            n = string5.indexOf("JEX_MenuLongName");
                            if (n != -1) {
                                string5 = string6 = string5.substring(0, n) + string + string5.substring(n + "JEX_MenuLongName".length());
                                log.write("bundle name: " + string);
                            } else {
                                n = string5.indexOf("JEX_PackageVersion");
                                if (n != -1) {
                                    string5 = string6 = string5.substring(0, n) + string3 + string5.substring(n + "JEX_PackageVersion".length());
                                    log.write("app version: " + string3);
                                } else {
                                    n = string5.indexOf("JEX_PackageCopyright");
                                    if (n != -1) {
                                        string5 = string6 = string5.substring(0, n) + string4 + string5.substring(n + "JEX_PackageCopyright".length());
                                        log.write("info about app: " + string4);
                                    }
                                }
                            }
                        }
                    }
                    if (string5 == null) continue;
                    printWriter.println(string5);
                    string5 = bufferedReader.readLine();
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var12_14) {
                bl = false;
                this.logException("Unable to save the updated properties " + file3.getPath(), var12_14);
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (IOException var7_8) {
            // empty catch block
        }
        return bl;
    }

    private boolean buildJavaInfoProperty(File file, String string, String string2, String string3, String string4, String string5, String string6, String string7, String string8, String string9) {
        boolean bl = false;
        File file2 = new File(TempFiles.getDefaultDirectory(), "InfoJavaTemplate.plist");
        if (!(file2 == null || file2.exists())) {
            if (LangUtilities.getResourceAsFile(file2.getPath())) {
                file2.deleteOnExit();
            } else {
                file2 = null;
                log.write("Unable to extract " + file2.getPath());
            }
        }
        if (file2 != null) {
            try {
                FileSystem.copyFile(file2, file);
                bl = this.modifyJavaInfoProperties(file, string, string2, string3, string4, string5, string6, string7, string8, string9);
                File file3 = new File(file, "InfoJavaTemplate.plist");
                file3.delete();
            }
            catch (Exception var13_14) {
                bl = false;
                this.logException("Unable to copy " + file2.getPath() + " to " + file.getPath(), var13_14);
            }
        } else {
            bl = false;
            log.write("Unable to extract " + file2.getPath());
        }
        return bl;
    }

    private boolean modifyJavaInfoProperties(File file, String string, String string2, String string3, String string4, String string5, String string6, String string7, String string8, String string9) {
        boolean bl = true;
        try {
            Object object;
            String string10 = this.workingDir;
            if (this.workingDir.equals(this.installDir)) {
                string10 = "$APP_PACKAGE/..";
            } else if (this.workingDir.startsWith(this.installDir)) {
                object = this.workingDir.substring(this.installDir.length());
                if (!object.startsWith("/")) {
                    object = "/" + object.substring(1);
                }
                string10 = "$APP_PACKAGE/.." + (String)object;
            }
            log.write("mac working dir: " + string10);
            object = new File(file, "InfoJavaTemplate.plist");
            FileReader fileReader = new FileReader((File)object);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            File file2 = new File(file, "Info.plist");
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            try {
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                String string11 = bufferedReader.readLine();
                while (string11 != null) {
                    String string12;
                    String string13;
                    int n = string11.indexOf("JEX_JavaAppStub");
                    if (n != -1) {
                        string12 = MacOS.escapeString(string);
                        string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_JavaAppStub".length());
                        log.write("Java stub app: " + string12);
                    } else {
                        n = string11.indexOf("JEX_MenuIconName");
                        if (n != -1) {
                            string12 = MacOS.escapeString(string3);
                            string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_MenuIconName".length());
                            log.write("icon filename: " + string12);
                        } else {
                            n = string11.indexOf("JEX_MenuLongName");
                            if (n != -1) {
                                string12 = MacOS.escapeString(string2);
                                string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_MenuLongName".length());
                                log.write("bundle name: " + string12);
                            } else {
                                n = string11.indexOf("JEX_PackageVersion");
                                if (n != -1) {
                                    string12 = MacOS.escapeString(string4);
                                    string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_PackageVersion".length());
                                    log.write("app version: " + string12);
                                } else {
                                    n = string11.indexOf("JEX_JvmVersion");
                                    if (n != -1) {
                                        string12 = MacOS.escapeString(string7);
                                        string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_JvmVersion".length());
                                        log.write("jvm version: " + string12);
                                    } else {
                                        n = string11.indexOf("JEX_WorkingDir");
                                        if (n != -1) {
                                            string12 = MacOS.escapeString(string10);
                                            string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_WorkingDir".length());
                                            log.write("working dir: " + string12);
                                        } else {
                                            n = string11.indexOf("JEX_MenuExecutableFile");
                                            if (n != -1) {
                                                string12 = MacOS.escapeString(this.executableFile);
                                                string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_MenuExecutableFile".length());
                                                log.write("main class filename: " + string12);
                                            } else {
                                                n = string11.indexOf("JEX_MenuCommandLineArguments");
                                                if (n != -1) {
                                                    string12 = MacOS.escapeString(this.commandLineArguments);
                                                    string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_MenuCommandLineArguments".length());
                                                    log.write("command line arguments: " + string12);
                                                } else {
                                                    n = string11.indexOf("JEX_SplashFile");
                                                    if (n != -1) {
                                                        string12 = "";
                                                        if (this.splashFile != null && this.splashFile.length() > 0) {
                                                            string12 = MacOS.escapeString(this.splashFile);
                                                            string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_SplashFile".length());
                                                        }
                                                        log.write("splash file: " + string12);
                                                    } else {
                                                        n = string11.indexOf("JEX_InstallJvmParameters");
                                                        if (n != -1) {
                                                            string12 = MacOS.escapeString(string6);
                                                            string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_InstallJvmParameters".length());
                                                            log.write("jvm parameters: " + string12);
                                                        } else {
                                                            n = string11.indexOf("JEX_PackageCopyright");
                                                            if (n != -1) {
                                                                string12 = MacOS.escapeString(string8);
                                                                string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_PackageCopyright".length());
                                                                log.write("info about app: " + string12);
                                                            } else {
                                                                n = string11.indexOf("JEX_InstalledBy");
                                                                if (n != -1) {
                                                                    string12 = MacOS.escapeString(string9);
                                                                    string11 = string13 = string11.substring(0, n) + string12 + string11.substring(n + "JEX_InstalledBy".length());
                                                                    log.write("installed by: " + string12);
                                                                } else {
                                                                    n = string11.indexOf("<key>ClassPath</key>");
                                                                    if (n != -1) {
                                                                        if (string5 != null && string5.length() > 0) {
                                                                            printWriter.println(string11);
                                                                            string12 = MacOS.escapeString(string5);
                                                                            string11 = this.addClasspath(string12, bufferedReader, printWriter);
                                                                        } else {
                                                                            log.write("no classpath defined");
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (string11 == null) continue;
                    printWriter.println(string11);
                    string11 = bufferedReader.readLine();
                }
                printWriter.close();
                fileOutputStream.close();
            }
            catch (Exception var18_22) {
                bl = false;
                this.logException("Unable to save the updated properties " + file2.getPath(), var18_22);
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (IOException var12_13) {
            // empty catch block
        }
        return bl;
    }

    private String addClasspath(String string, BufferedReader bufferedReader, PrintWriter printWriter) {
        String string2 = null;
        boolean bl = false;
        boolean bl2 = false;
        while (!bl2) {
            try {
                string2 = bufferedReader.readLine();
                if (string2 == null || string2.indexOf("</array>") >= 0 || string2.indexOf("<key>") >= 0 || string2.indexOf("</key>") >= 0 || string2.indexOf("</dict>") >= 0) {
                    bl2 = true;
                    continue;
                }
                printWriter.println(string2);
                if (string2.indexOf("<array>") < 0) continue;
                bl = true;
            }
            catch (Exception var7_7) {
                bl2 = true;
                string2 = null;
                this.logException("Unable to readLine of Info.plist", var7_7);
            }
        }
        if (bl && string2.indexOf("</array>") >= 0) {
            MacOS.insertClasspath(string, bufferedReader, printWriter);
        } else {
            if (bl) {
                log.write("start of classpath's array found");
            }
            log.write("unable to set the classpath: " + string2);
        }
        return string2;
    }

    private static String getClasspathComponent(String string, int n) {
        String string2 = string.substring(0, n);
        if (string2.startsWith(".")) {
            string2 = string2.length() > 1 ? (string2.startsWith("." + File.separator) ? "$APP_PACKAGE/.." + string.substring(1, n) : "$APP_PACKAGE/.." + File.separator + string2) : "$APP_PACKAGE/..";
        } else if (!(string2.startsWith("$APP_PACKAGE/") || string2.startsWith(File.separator))) {
            string2 = "$APP_PACKAGE/.." + File.separator + string2;
        }
        return string2;
    }

    private void addDesktopLink(String string, String string2) {
        this.addDesktopLink(string, string2, string2);
    }

    private void addDesktopLink(String string, String string2, String string3) {
        String string4 = MacOS.getDesktopDirectory();
        if (string4 != null && string4.length() > 0) {
            this.addDesktopLink(string, string2, string4, string3);
        } else {
            log.write("Unable to get the user's desktop directory ");
        }
        if (string.startsWith("/Applications")) {
            log.write("app dir is in /Applications so no need for special icon");
        } else {
            this.addDesktopLink(string, string2, "/Applications", string3);
        }
    }

    private void addDesktopLink(String string, String string2, String string3, String string4) {
        File file = new File(string3);
        if (!file.exists()) {
            this.createSubfolders(file);
        }
        if (file.exists()) {
            File file2 = new File(string, string2);
            File file3 = new File(file, string4);
            UnixCommands.ln(file2.getPath(), file3.getPath());
            log.write("Linked " + file2.getPath() + " to " + file3.getPath());
        }
    }

    private boolean makeDir(String string, String string2) {
        File file = new File(string);
        return this.makeDir(file, string2);
    }

    private boolean makeDir(File file, String string) {
        boolean bl = true;
        File file2 = new File(file, string);
        try {
            bl = file2.mkdirs();
            log.write("created " + file2.getPath() + " ok: " + bl);
            file2 = new File(file, string);
            if (file2.exists() && file2.isDirectory()) {
                bl = true;
                log.write(string + " exists");
                UnixCommands.chmod("0755", file2.getPath());
            } else {
                bl = false;
                log.write(file2.getPath() + " doesn't exist or isn't a directory");
            }
        }
        catch (Exception var5_5) {
            bl = false;
            this.logException("unable to make dir: " + file2.getPath(), var5_5);
        }
        return bl;
    }

    private void createSubfolders(File file) {
        MakeDirs makeDirs = new MakeDirs();
        makeDirs.mkdirs(file);
        List list = makeDirs.getCreatedDirs();
        if (list == null || list.isEmpty()) {
            log.write("no newly created subdirectories");
        } else {
            if (this.createdDirs == null) {
                this.createdDirs = new Vector();
            }
            int n = 0;
            while (n < list.size()) {
                String string = (String)list.get(n++);
                this.createdDirs.add(string);
                log.write("created dir: " + string);
            }
        }
    }

    public static String escapeString(String string) {
        String string2 = string;
        int n = string2.indexOf("&");
        while (n >= 0) {
            int n2 = string2.substring(n).length();
            if (!(n2 >= 4 && string2.substring(n + 4).startsWith(";"))) {
                string2 = string2.substring(0, n) + "&amp;" + string2.substring(n + 1);
            }
            if (string2.substring(n).length() > 1) {
                int n3 = n + 1;
                n = string2.substring(n3).indexOf("&");
                if (n < 0) continue;
                n+=n3;
                continue;
            }
            n = -1;
        }
        n = string2.indexOf("//");
        while (n >= 0) {
            string2 = string2.substring(0, n) + "&#47;&#47;" + string2.substring(n + 2);
            n = string2.indexOf("//");
        }
        return string2;
    }
}
