/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.runtime.Exec;
import com.denova.runtime.OS;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Vector;

public class UnixCommands {
    public static final String UnixOsLogFilename = "unixcmds";
    private static final String EnvCommand = "env";
    private static final String Quote = "\"";
    private static final String BlankString = "";
    private static final String Space = " ";
    private static final String CloseParan = ")";
    private static Log log = null;
    private static String logFilename = "unixcmds";

    public static String getSystemPath() {
        String string = null;
        string = UnixCommands.getSystemPath("echo $PATH", "");
        if (string == null || string.length() <= 0) {
            string = UnixCommands.getSystemPath("echo $path", "");
        }
        if (string == null || string.length() <= 0) {
            string = UnixCommands.getSystemPath("set", "path");
        }
        return string;
    }

    public static boolean chmod(int n, String string) {
        boolean bl;
        try {
            bl = UnixCommands.chmod(String.valueOf(n), string);
        }
        catch (Exception var3_3) {
            bl = false;
            UnixCommands.log("Unable to change the int permissions on " + string);
            UnixCommands.log(var3_3);
        }
        return bl;
    }

    public static boolean chmod(String string, String string2) {
        boolean bl = true;
        try {
            File file;
            String string3 = null;
            String string4 = null;
            UnixCommands.log("chmod " + string + " " + string2);
            if (string2.startsWith("\"") && string2.endsWith("\"")) {
                string2 = string2.substring(1, string2.length() - 1);
                UnixCommands.log("stripped quotes from filename: " + string2);
            }
            string4 = (file = new File(string2)).isDirectory() ? string2 : ((string3 = file.getParent()) != null ? file.getName() : string2);
            string4 = Exec.quoteArg(string4);
            if (string3 != null) {
                string3 = Exec.quoteArg(string3);
            }
            if (string3 != null) {
                Exec.runCommand("chmod " + string + " " + string4, string3);
                UnixCommands.log("command: chmod " + string + " " + string4 + " in directory " + string3);
            } else {
                Exec.runCommand("chmod " + string + " " + string4);
                UnixCommands.log("command: chmod " + string + " " + string4);
            }
        }
        catch (Exception var3_4) {
            bl = false;
            UnixCommands.log("Unable to change the permissions on " + string2);
            UnixCommands.log(var3_4);
        }
        return bl;
    }

    public static int getPermissions(String string) {
        int n = -1;
        try {
            File file;
            String string2 = string;
            UnixCommands.log("get permissions for " + string2);
            if (string.startsWith("\"") && string.endsWith("\"")) {
                string2 = string.substring(1, string.length() - 1);
                UnixCommands.log("stripped quotes from filename: " + string2);
            }
            if ((file = new File(string2)).exists()) {
                Vector<String> vector = new Vector<String>();
                vector.add("stat");
                vector.add("--format=%a");
                vector.add(string2);
                String[] arrstring = Exec.getCommandAsStringArray(vector);
                String string3 = Exec.getCommandOutput(arrstring).trim();
                int n2 = string3.indexOf("\n");
                if (n2 >= 0) {
                    string3 = string3.substring(0, n2);
                }
                UnixCommands.log("permissions: " + string3);
                UnixCommands.log("length permissions: " + string3.length());
                n = Integer.valueOf(string3, 8);
                UnixCommands.log("permissions: " + n);
            } else {
                n = -1;
                UnixCommands.log("file does not exist");
            }
        }
        catch (Exception var2_3) {
            n = -1;
            UnixCommands.log("Unable to get the permissions for " + string);
            UnixCommands.log(var2_3);
        }
        return n;
    }

    public static void ln(String string, String string2) {
        UnixCommands.symbolicallyLinkFile(string, string2);
    }

    public static void symbolicallyLinkFile(String string, String string2) {
        String string3 = string;
        String string4 = string2;
        try {
            File file = new File(string4);
            if (file.exists()) {
                file.delete();
            }
            string3 = Exec.quoteArg(string3);
            string4 = Exec.quoteArg(string4);
            Exec.runCommand("ln -s " + string3 + " " + string4);
        }
        catch (Exception var4_5) {
            UnixCommands.log("Unable to symbolically link " + string3 + " to " + string4);
            UnixCommands.log(var4_5);
        }
    }

    public static void setLog(Log log) {
        UnixCommands.log = log;
    }

    private static String getSystemPath(String string, String string2) {
        String string3 = null;
        File file = null;
        InputStreamReader inputStreamReader = null;
        BufferedReader bufferedReader = null;
        try {
            String string4 = UnixCommands.tempFilename("zos.zos");
            UnixCommands.log("searching for path using command: " + string);
            String string5 = string + " > " + Exec.quoteArg(string4);
            Exec.runCommand(string5, UnixCommands.getTempDir());
            file = new File(string4);
            inputStreamReader = new FileReader(file);
            bufferedReader = new BufferedReader(inputStreamReader);
            String string6 = bufferedReader.readLine();
            while (string6 != null && string3 == null) {
                string6 = string6.trim();
                UnixCommands.log("systemPath: " + string6);
                if (string2 != null && string2.length() > 0) {
                    String string7 = string6.toLowerCase();
                    if (string7.startsWith(string2)) {
                        UnixCommands.log("found " + string2);
                        int n = string6.indexOf(File.separator);
                        string3 = n != -1 ? string6.substring(n) : string6.substring(string2.length());
                        if (string3.endsWith(")") && (n = string3.lastIndexOf(")")) != -1) {
                            string3 = string3.substring(0, n);
                        }
                    }
                } else {
                    string3 = string6;
                }
                string6 = bufferedReader.readLine();
            }
        }
        catch (FileNotFoundException var6_11) {
            UnixCommands.log("Unable to get the system's path from command: " + string);
        }
        catch (Exception var6_12) {
            UnixCommands.log("Unable to get the system's path");
            UnixCommands.log(var6_12);
        }
        try {
            if (inputStreamReader != null) {
                inputStreamReader.close();
            }
            if (bufferedReader != null) {
                bufferedReader.close();
            }
            if (file != null) {
                file.delete();
            }
        }
        catch (Exception var6_13) {
            UnixCommands.log(var6_13);
        }
        return string3;
    }

    public static String[] getEnvironment() {
        String[] arrstring = new String[]{};
        try {
            String string = UnixCommands.tempFilename("zos.zos");
            Exec.runCommand("env > " + Exec.quoteArg(string), UnixCommands.getTempDir());
            File file = new File(string);
            if (file.exists()) {
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                String string2 = bufferedReader.readLine();
                while (string2 != null) {
                    arrstring = OS.addArg(arrstring, string2);
                    string2 = bufferedReader.readLine();
                }
                fileReader.close();
                bufferedReader.close();
                file.delete();
            }
        }
        catch (Exception var1_6) {
            UnixCommands.log("Unable to get the environment");
            UnixCommands.log(var1_6);
        }
        return arrstring;
    }

    public static boolean mkdirs(String string, String string2) {
        boolean bl = true;
        try {
            File file = new File(string);
            file.mkdirs();
            UnixCommands.chmod(string2, string);
        }
        catch (Exception var3_4) {
            bl = false;
            UnixCommands.log(var3_4);
        }
        return bl;
    }

    static String getTempDir() {
        String string;
        File file = TempFiles.getDefaultDirectory();
        try {
            string = file.getCanonicalPath();
        }
        catch (Exception var2_2) {
            string = file.getAbsolutePath();
        }
        return string;
    }

    static String tempFilename(String string) {
        String string2 = "";
        File file = new File(TempFiles.getDefaultDirectory(), string);
        try {
            string2 = file.getCanonicalPath();
        }
        catch (Exception var3_3) {
            string2 = file.getAbsolutePath();
        }
        return string2;
    }

    private static void log(String string) {
        UnixCommands.startLog();
        log.write(string);
    }

    private static void log(Exception exception) {
        UnixCommands.startLog();
        log.write(exception);
    }

    private static void startLog() {
        if (log == null) {
            log = new Log(logFilename);
        }
    }
}
