/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.io.MakeDirs;
import com.denova.lang.LangUtilities;
import com.denova.runtime.CommandMap;
import com.denova.runtime.Exec;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.UnixCommands;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.List;
import java.util.Vector;

public class UnixMenu {
    public static final String UnixMenuLogFilename = "unixmenus";
    public static final String MenuExtension = ".desktop";
    public static final String DesktopSubdir = "Desktop";
    private static final String Quote = "\"";
    private static final String BlankString = "";
    private static final String Space = " ";
    private static final String CloseParan = ")";
    private static final boolean debugging = false;
    private static final String LocalKdeSubmenuDir = ".kde";
    private static final String UsrLocalKdeDir = "/usr/local/kde";
    private static final String OptKdeDir = "/opt";
    private static final String UsrShareKdeDir = "/usr";
    private static final String GnomeShareSubdir = "share";
    private static final String GnomeAppSubdir = "applications";
    private static final String GnomeSubmenuDir = "share/applications";
    private static final String PublicGnomeSubmenuDir = "/usr/share/applications";
    private static final String LocalGnomeShareSubdir = ".local/share";
    private static final String LocalGnomeSubmenuDir = ".local/share/applications";
    private static final String AlacarteDesktopFile = "alacarte-made";
    private static final String XfceMenuXml = "menu.xml";
    private static final String XfceMenuName = "menu name";
    private static final String XfceAppName = "app name";
    private static final String XfceCmd = "cmd";
    private static final String XfceIcon = "icon";
    private static final String XdgMenus = "/etc/xdg/menus";
    private static Log log = new Log("unixmenus");
    private static boolean publicDir = false;
    private List createdDirs = null;
    private String installDir = "";
    private String workingDir = "";
    private String launchDirName = "";
    private String submenu = "";
    private String longName = "";
    private String shortName = "";
    private String executableFile = "";
    private String commandLineArguments = "";
    private String iconFilename = "";
    private boolean runAsAdmin = false;
    private boolean addDesktopShortcut = false;
    private boolean installOnGnome = false;
    private boolean installOnKDE = false;
    private boolean installOnXfce = false;
    private static boolean allUsers = false;

    public UnixMenu() {
    }

    public UnixMenu(Log log) {
        this();
        UnixMenu.log = log;
    }

    public static boolean isError() {
        return LangUtilities.isError();
    }

    public static Exception getLastException() {
        return LangUtilities.getLastException();
    }

    public static String getLastError() {
        return LangUtilities.getLastError();
    }

    public static void clearError() {
        LangUtilities.clearError();
    }

    public void setSubmenu(String string) {
        this.submenu = string.replace('/', File.separatorChar);
    }

    public void setInstallDir(String string) {
        this.installDir = string;
        if (this.workingDir == null || this.workingDir.length() <= 0) {
            this.workingDir = this.installDir;
        }
    }

    public void setWorkingDir(String string) {
        this.workingDir = string;
        if (this.installDir == null || this.installDir.length() <= 0) {
            this.installDir = this.workingDir;
        }
    }

    public void setLaunchDirName(String string) {
        this.launchDirName = string;
    }

    public void setLongName(String string) {
        this.longName = string;
    }

    public void setShortName(String string) {
        this.shortName = string;
    }

    public void setExecutableFile(String string) {
        this.executableFile = string;
    }

    public void setCommandLineArguments(String string) {
        this.commandLineArguments = string;
    }

    public void setIconFilename(String string) {
        this.iconFilename = string;
    }

    public void setRunAsAdmin(boolean bl) {
        this.runAsAdmin = bl;
    }

    public void setAddDesktopShortcut(boolean bl) {
        this.addDesktopShortcut = bl;
    }

    public void setInstallOnGnome(boolean bl) {
        this.installOnGnome = bl;
    }

    public void setInstallOnKDE(boolean bl) {
        this.installOnKDE = bl;
    }

    public void setInstallOnXfce(boolean bl) {
        this.installOnXfce = bl;
    }

    public void setAllUsers(boolean bl) {
        allUsers = bl;
    }

    public static boolean kdeMenusInstalled() {
        boolean bl = false;
        String string = UnixMenu.getKdeMenuDir();
        if (string != null && string.length() > 0) {
            File file = new File(string);
            bl = file.exists() && file.isDirectory();
        }
        return bl;
    }

    public static boolean gnomeMenusInstalled() {
        boolean bl = false;
        String string = UnixMenu.getGnomeMenuDir();
        if (string != null && string.length() > 0) {
            File file = new File(string);
            bl = file.exists() && file.isDirectory();
        }
        return bl;
    }

    public static boolean xfceMenusInstalled() {
        boolean bl = false;
        String string = UnixMenu.getXfceMenuDir();
        if (string != null && string.length() > 0) {
            File file = new File(string);
            bl = file.exists() && file.isDirectory();
        }
        return bl;
    }

    public static String getKdeMenuDir() {
        String string = "";
        File file = null;
        if (allUsers) {
            file = new File("/opt", "share/applnk");
            if (!(file.exists() && file.isDirectory())) {
                file = new File("/usr", "share/applnk");
            }
            if (!(file.exists() && file.isDirectory())) {
                file = new File("/usr/local/kde");
            }
        }
        if (!(file != null && file.exists() && file.isDirectory())) {
            file = new File(System.getProperty("user.home", "."), ".kde");
        }
        if (file.exists() && file.isDirectory()) {
            string = file.getPath();
            log.write("kde menu dir: " + string);
        } else {
            log.write("no private or public kde menu directory");
        }
        return string;
    }

    public static String getSubmenuDir(String string, String string2) {
        String string3 = "";
        String string4 = UnixMenu.getKdeMenuDir();
        if (string4 == null) {
            string4 = "";
        }
        if (UnixMenu.kdeMenusInstalled() && string.equals(string4)) {
            File file = null;
            String string5 = string2;
            if (string5 == null || string5.length() <= 0) {
                string5 = "Utilities";
            }
            if (string5.startsWith("Development") || string5.startsWith("Internet") || string5.startsWith("Utilities") || string5.startsWith("Graphics") || string5.startsWith("Edutainment") || string5.startsWith("Games") || string5.startsWith("Office") || string5.startsWith("Settings") || string5.startsWith("System")) {
                file = new File(string, string5);
            } else {
                File file2 = new File(string, "Utilities");
                file = new File(file2, string2);
            }
            string3 = file.getPath();
            log.write("kde subdir: " + string3);
        } else {
            File file = new File(string, string2);
            string3 = file.getPath();
            log.write("subdir: " + string3);
        }
        return string3;
    }

    public static String getGnomeMenuDir() {
        File file;
        Object object;
        String string = "";
        boolean bl = false;
        bl = UnixMenu.gnomeMenuDirOk("/usr/share/applications");
        if (bl) {
            object = new File("/usr/share/applications");
            string = object.getPath();
            publicDir = true;
        }
        if (allUsers) {
            if (!bl && (bl = UnixMenu.gnomeMenuDirOk((String)(object = "/usr/share/gnome/applications/")))) {
                file = new File((String)object);
                string = file.getPath();
                publicDir = true;
            }
            if (!bl && (bl = UnixMenu.gnomeMenuDirOk((String)(object = "/usr/share/gnome/apps/")))) {
                file = new File((String)object);
                string = file.getPath();
                publicDir = true;
            }
            if (!bl && (bl = UnixMenu.gnomeMenuDirOk((String)(object = "/etc/X11/applnk/")))) {
                file = new File((String)object);
                string = file.getPath();
                publicDir = true;
            }
            if (!bl && (bl = UnixMenu.gnomeMenuDirOk((String)(object = "/usr/share/applnk/")))) {
                file = new File((String)object);
                string = file.getPath();
                publicDir = true;
            }
            if (!bl && (bl = UnixMenu.gnomeMenuDirOk((String)(object = "/etc/xdg/menus/")))) {
                file = new File((String)object);
                string = file.getPath();
                publicDir = true;
            }
        }
        if (!bl) {
            object = System.getProperty("user.home", ".");
            file = new File((String)object, ".local/share/applications");
            if (!UnixMenu.gnomeMenuDirOk(file)) {
                file = new File((String)object, ".local/share");
                if (file.exists()) {
                    file = new File((String)object, ".local/share/applications");
                    file.mkdirs();
                } else {
                    file = new File((String)object, ".local/share/applications");
                }
            }
            if (UnixMenu.gnomeMenuDirOk(file)) {
                string = file.getPath();
            } else {
                log.write("no gnome menu directory");
                string = "";
            }
        }
        return string;
    }

    public static String getXfceMenuDir() {
        File file = new File(System.getProperty("user.home"), ".config/xfce4/desktop");
        String string = file.getPath();
        if (!(file.exists() && file.isDirectory())) {
            log.write("no xfce menu directory (" + string + ")");
            string = "";
        }
        return string;
    }

    public static String getDesktopDir() {
        String string = "";
        File file = new File(System.getProperty("user.home", "~"), "Desktop");
        if (file.exists() && file.isDirectory()) {
            string = file.getPath();
        }
        return string;
    }

    public static String getMenuName(String string, String string2) {
        String string3 = string;
        if (string3 == null || string3.length() <= 0) {
            string3 = string2;
        }
        log.write("menu name: " + string3);
        return string3;
    }

    public void addLaunchScript() {
        this.addLaunchScript(false, false, "");
    }

    public void addLaunchScript(boolean bl, boolean bl2, String string) {
        this.addLaunchScript(bl, bl2, string, this.installOnKDE && UnixMenu.kdeMenusInstalled(), this.installOnGnome && UnixMenu.gnomeMenusInstalled(), this.installOnXfce && UnixMenu.xfceMenusInstalled(), "");
    }

    public void addLaunchScript(boolean bl, boolean bl2, String string, boolean bl3, boolean bl4, boolean bl5) {
        this.addLaunchScript(bl, bl2, string, bl3, bl4, bl5, "");
    }

    public void addLaunchScript(boolean bl, boolean bl2, String string, boolean bl3, boolean bl4, boolean bl5, String string2) {
        String string3;
        Object object;
        int n;
        String string4 = this.executableFile;
        File file = new File(string4);
        String string5 = this.getLaunchScriptDir(this.installDir);
        if (!bl) {
            this.makeFileExecutable(this.executableFile);
        }
        if (!((n = string4.indexOf(32)) == -1 || string4.startsWith("\""))) {
            string4 = "\"" + string4 + "\"";
        }
        if (bl) {
            string4 = JRE.adjustJreClasspath(string, this.installDir, false) + string4;
        } else {
            object = new File(this.installDir, this.executableFile);
            if (!object.exists()) {
                object = new File(this.workingDir, this.executableFile);
            }
            UnixCommands.chmod("0754", object.getPath());
            log.write(object.getPath() + " script made executable");
        }
        object = string4;
        if (this.commandLineArguments != null && this.commandLineArguments.length() > 0) {
            string3 = "";
            if (this.commandLineArguments.lastIndexOf(" &") != -1) {
                int n2 = this.commandLineArguments.lastIndexOf(" &");
                string3 = this.commandLineArguments.substring(n2);
                if (string3.equals(" &")) {
                    this.commandLineArguments = this.commandLineArguments.substring(0, n2);
                } else {
                    string3 = "";
                }
            }
            object = (String)object + " " + this.commandLineArguments + " \"$@\"" + string3;
        } else {
            object = (String)object + " \"$@\"";
        }
        log.write("adding launch script");
        log.write("    menu name " + this.shortName);
        log.write("   install dir " + this.installDir);
        log.write("   working dir " + this.workingDir);
        log.write("   launch dir " + string5);
        log.write("     use Java " + String.valueOf(bl));
        log.write("  use console " + String.valueOf(bl2));
        log.write("   cmd prefix " + string);
        log.write("   executable " + string4);
        log.write("     cmd args " + this.commandLineArguments);
        log.write("      command " + (String)object);
        log.write("    icon file " + this.iconFilename);
        log.write(" add KDE menu " + String.valueOf(bl3));
        log.write("    add gnome " + String.valueOf(bl4));
        log.write("     add xfce " + String.valueOf(bl5));
        log.write("         echo " + string2);
        File file2 = this.getLaunchScript(string5, this.shortName, string4);
        string3 = file2.getPath();
        log.write("script name: " + string3);
        if (this.writeLaunchScript(file2, (String)object, string2)) {
            CommandMap.put(this.longName, string3);
            if (bl3) {
                this.createKdeMenu(string3, bl2);
            }
            if (bl4) {
                this.createGnomeMenu(string3, bl2);
            }
            if (bl5) {
                this.createXfceMenu(string3, bl2);
            }
            if (this.addDesktopShortcut) {
                this.createDesktopShortcut(string3, bl2);
            }
        }
    }

    public void deleteLaunchScript(String string) {
        this.deleteLaunchScript(string, null, null);
    }

    public void deleteLaunchScript(String string, String string2, String string3) {
        String string4;
        File file = new File(string);
        if (file.exists()) {
            file.delete();
        }
        if ((string4 = UnixMenu.getKdeMenuName(string3, file.getName())) != null && string4.length() > 0) {
            this.deleteKdeMenu(string2, string4);
            this.deleteGnomeMenu(string2, string4);
        }
    }

    public boolean createKdeMenu(String string, boolean bl) {
        boolean bl2 = false;
        if (this.installOnKDE && UnixMenu.kdeMenusInstalled()) {
            String string2 = UnixMenu.getKdeMenuName(this.longName, this.shortName);
            if (string2 != null && string2.length() > 0) {
                this.deleteKdeMenu(this.submenu, string2);
            }
            String string3 = UnixMenu.getKdeMenuDir();
            File file = new File(string3);
            boolean bl3 = false;
            bl2 = this.createMenu(file.getPath(), this.submenu, string, bl, bl3);
            if (bl2) {
                try {
                    Exec.execCommand("kbuildsycoca --noincremental");
                }
                catch (Exception var8_8) {
                    bl2 = false;
                    log.write(var8_8);
                }
            }
        }
        return bl2;
    }

    public void deleteKdeMenu(String string, String string2) {
        if (UnixMenu.kdeMenusInstalled()) {
            String string3 = UnixMenu.getKdeMenuDir();
            File file = new File(string3, string2 + ".desktop");
            if (file.exists()) {
                file.delete();
                log.write("deleted " + file.getPath());
            }
        } else {
            log.write("no kde menu directory");
        }
    }

    public static String getKdeMenuName(String string, String string2) {
        String string3 = UnixMenu.getMenuName(string, string2).trim();
        int n = string3.indexOf(" ");
        while (n != -1) {
            string3 = string3.substring(0, n) + string3.substring(n + 1);
            n = string3.indexOf(" ");
        }
        log.write("kde menu name: " + string3);
        return string3;
    }

    public String getKdeMenuName(String string, String string2, String string3) {
        String string4 = "";
        if (UnixMenu.kdeMenusInstalled()) {
            String string5 = UnixMenu.getKdeMenuDir();
            File file = new File(UnixMenu.getSubmenuDir(string5, string));
            this.createSubfolders(file);
            if (file.exists()) {
                String string6 = UnixMenu.getKdeMenuName(string2, string3);
                File file2 = new File(file, string6 + ".desktop");
                string4 = file2.getPath();
                log.write("kde menu's name: " + string4);
            } else {
                log.write("No kde app directory: " + file.getPath());
            }
        } else {
            log.write("no kde menu directory");
        }
        return string4;
    }

    public String getKdeAutostartDir() {
        String string = "";
        File file = new File(System.getProperty("user.home", "."), ".kde");
        File file2 = new File(file, "Autostart");
        if (!(file2.exists() && file2.isDirectory())) {
            file2 = new File("/usr/local/kde", "Autostart");
        }
        if (!(file2.exists() && file2.isDirectory())) {
            file2 = new File("/opt", "Autostart");
        }
        if (!(file2.exists() && file2.isDirectory())) {
            file2 = new File("/usr", "Autostart");
        }
        if (file2.exists() && file2.isDirectory()) {
            string = file2.getPath();
            log.write("autostart dir: " + string);
        } else {
            log.write("no private or public autostart directory");
        }
        return string;
    }

    public boolean createGnomeMenu(String string, boolean bl) {
        boolean bl2 = false;
        if (this.installOnGnome && UnixMenu.gnomeMenusInstalled()) {
            String string2 = UnixMenu.getMenuName(this.longName, this.shortName);
            if (string2 != null && string2.length() > 0) {
                this.deleteGnomeMenu(this.submenu, string2);
            }
            boolean bl3 = false;
            String string3 = UnixMenu.getGnomeMenuDir();
            bl2 = this.createMenu(string3, this.submenu, string, bl, bl3);
            if (this.submenu != null && this.submenu.length() > 0) {
                bl2 = this.createGnomeSubdir(string3, this.submenu);
            }
        }
        return bl2;
    }

    public void deleteGnomeMenu(String string, String string2) {
        String string3;
        File file;
        if (UnixMenu.gnomeMenusInstalled() && (file = new File(string3 = UnixMenu.getGnomeMenuDir(), string2 + ".desktop")).exists()) {
            file.delete();
            log.write("deleted " + file.getPath());
        }
    }

    public boolean createXfceMenu(String string, boolean bl) {
        boolean bl2 = false;
        if (this.installOnXfce && UnixMenu.xfceMenusInstalled()) {
            String string2 = UnixMenu.getMenuName(this.longName, this.shortName);
            if (string2 != null && string2.length() > 0) {
                this.deleteXfceMenu(this.submenu, string2);
            }
            boolean bl3 = false;
            String string3 = UnixMenu.getXfceMenuDir();
            bl2 = true;
        }
        return bl2;
    }

    public void deleteXfceMenu(String string, String string2) {
        if (UnixMenu.xfceMenusInstalled()) {
            // empty if block
        }
    }

    public boolean createDesktopShortcut(String string, boolean bl) {
        boolean bl2 = false;
        if (UnixMenu.gnomeMenusInstalled() || UnixMenu.kdeMenusInstalled()) {
            String string2;
            String string3 = UnixMenu.getMenuName(this.longName, this.shortName);
            if (string3 != null && string3.length() > 0) {
                this.deleteDesktopShortcut(this.submenu, string3);
            }
            if ((string2 = UnixMenu.getDesktopDir()) != null && string2.length() > 0) {
                boolean bl3 = true;
                bl2 = this.createMenu(string2, this.submenu, string, bl, bl3);
            }
        }
        return bl2;
    }

    public void deleteDesktopShortcut(String string, String string2) {
        File file;
        if ((UnixMenu.gnomeMenusInstalled() || UnixMenu.kdeMenusInstalled()) && (file = new File(System.getProperty("user.home", "~"), "Desktop")).exists()) {
            String string3 = UnixMenu.getGnomeMenuDir();
            File file2 = new File(file, string2 + ".desktop");
            if (file2.exists()) {
                file2.delete();
                log.write("deleted " + file2.getPath());
            }
        }
    }

    public List getCreatedDirs() {
        return this.createdDirs;
    }

    private File getLaunchScript(String string, String string2, String string3) {
        int n = 0;
        File file = new File(string, string2);
        File file2 = this.getAbsoluteFile(file);
        File file3 = string3.startsWith(File.separator) ? this.getAbsoluteFile(new File(string3)) : this.getAbsoluteFile(new File(file2.getParent(), string3));
        log.write("initial full script name: " + file2.getPath());
        log.write("full exec script name: " + file3.getPath());
        if (file2.getPath().equals(file3.getPath())) {
            file = new File(string, string2 + String.valueOf(++n));
            log.write("changing script name from " + string2 + " to " + string2 + String.valueOf(n));
        }
        while (file.exists() && file.isDirectory() && n < 100) {
            file = new File(string, string2 + String.valueOf(++n));
        }
        return file;
    }

    private File getAbsoluteFile(File file) {
        File file2 = file;
        try {
            file2 = file.getCanonicalFile();
        }
        catch (Exception var3_3) {
            try {
                file2 = file.getAbsoluteFile();
            }
            catch (Exception var4_4) {
                file2 = file;
            }
        }
        return file2;
    }

    private boolean createAlacarteMenu(String string, String string2, String string3) {
        boolean bl = false;
        int n = 0;
        File file = new File(string, "alacarte-made.desktop");
        while (file.exists() && n < 100) {
            file = new File(string, "alacarte-made-" + String.valueOf(++n) + ".desktop");
        }
        if (file.exists()) {
            bl = false;
        } else {
            File file2 = new File(string, string3 + ".desktop");
            UnixCommands.ln(file2.getPath(), file.getPath());
            bl = true;
            if (string2 != null && string2.length() > 0) {
                bl = this.createGnomeSubdir(string, string2);
            }
        }
        return bl;
    }

    private boolean createGnomeSubdir(String string, String string2) {
        boolean bl = false;
        try {
            File file = new File(string);
            File file2 = new File(file.getParent(), "desktop-directories");
            file2.mkdirs();
            File file3 = new File(file2, string2 + ".directory");
            log.write("creating gnome subdir in " + file3.getPath());
            FileOutputStream fileOutputStream = new FileOutputStream(file3);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            printWriter.println("[Desktop Entry]");
            printWriter.println("Name=" + string2);
            printWriter.println("Icon=" + this.iconFilename);
            printWriter.println("Type=Directory");
            printWriter.println("NoDisplay=false");
            printWriter.println("X-Ubuntu-Gettext-Domain=gnome-menus");
            printWriter.close();
            fileOutputStream.close();
            bl = true;
        }
        catch (Exception var4_5) {
            log.write("Unable to create menu subdir");
            this.rememberError("Unable to create menu subdir", var4_5);
        }
        return bl;
    }

    private boolean createMenu(String string, String string2, String string3, boolean bl, boolean bl2) {
        boolean bl3 = false;
        String string4 = UnixMenu.getMenuName(this.longName, this.shortName);
        String string5 = UnixMenu.getKdeMenuName(this.longName, this.shortName) + ".desktop";
        File file = new File(string, string5);
        log.write("creating desktop menu in " + file.getPath());
        bl3 = this.createDesktopFile(file, string4, string2, string3, bl, bl2);
        log.write("menu created " + bl3);
        return bl3;
    }

    private boolean createDesktopFile(File file, String string, String string2, String string3, boolean bl, boolean bl2) {
        boolean bl3 = false;
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            String string4 = string3;
            File file2 = new File("/usr/bin/env");
            File file3 = new File("/usr/bin/xdg-open");
            if (file2.exists() && file3.exists()) {
                printWriter.println("#!/usr/bin/env xdg-open");
            } else {
                bl2 = false;
            }
            printWriter.println("# Desktop Config File");
            printWriter.println("[Desktop Entry]");
            printWriter.println("Name=" + string);
            printWriter.println("Icon=" + this.iconFilename);
            if (bl2) {
                printWriter.println("URL=file://" + string4);
                printWriter.println("Type=Link");
            } else {
                if (!(string3.indexOf(" ") == -1 || string3.startsWith("\"") || string3.endsWith("\""))) {
                    string4 = "\"" + string3 + "\"";
                }
                printWriter.println("Exec=" + string4);
                printWriter.println("Type=Application");
                String string5 = "";
                if (string2 != null && string2.length() > 0) {
                    string5 = string2 + ";";
                }
                printWriter.println("Categories=Applications;" + string5);
            }
            if (bl) {
                printWriter.println("Terminal=true");
                printWriter.println("TerminalOptions=");
            } else {
                printWriter.println("Terminal=false");
            }
            printWriter.println("Name[en_US]=" + string);
            printWriter.close();
            fileOutputStream.close();
            bl3 = true;
            UnixCommands.chmod("0754", file.getPath());
            log.write("desktop made executable");
        }
        catch (Exception var8_9) {
            log.write("Unable to create desktop menu");
            this.rememberError("Unable to create desktop menu", var8_9);
        }
        return bl3;
    }

    private static boolean gnomeMenuDirOk(String string) {
        return UnixMenu.gnomeMenuDirOk(new File(string));
    }

    private static boolean gnomeMenuDirOk(File file) {
        boolean bl = false;
        if (file != null && file.exists() && file.isDirectory()) {
            File file2 = new File(file, "__test__jex");
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file2);
                fileOutputStream.write(999);
                fileOutputStream.close();
                bl = file2.exists() && file2.length() > 0;
                file2.delete();
                if (bl) {
                    bl = !file2.exists();
                }
            }
            catch (Exception var4_4) {
                bl = false;
            }
        }
        return bl;
    }

    private boolean writeLaunchScript(File file, String string, String string2) {
        boolean bl = true;
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            String string3 = this.getShellCommand();
            if (string3 != null) {
                printWriter.println(string3);
                log.write("added shell command " + string3);
            }
            if (string2 != null && string2.length() > 0) {
                printWriter.println("echo " + string2);
            }
            if (OS.isMacOsX() || !OS.isLinux()) {
                printWriter.println("ulimit -S -n 2000");
            }
            if (this.installDir.equals(this.workingDir)) {
                printWriter.println("dir=\"${0%/*}\"");
                printWriter.println("cd \"$dir\"");
            } else {
                printWriter.println("dir=" + this.workingDir);
                printWriter.println("cd \"$dir\"");
            }
            if (!string.startsWith(File.separator)) {
                string = "." + File.separator + string;
            }
            printWriter.println("exec " + string);
            printWriter.close();
            fileOutputStream.close();
            log.write("script created");
            UnixCommands.chmod("0754", file.getPath());
            log.write(file.getPath() + " script made executable");
        }
        catch (Exception var5_6) {
            bl = false;
            log.write("Unable to create script");
            this.rememberError("Unable to create script", var5_6);
        }
        return bl;
    }

    private String getShellCommand() {
        File file;
        String string = null;
        if (OS.isSolaris() && (file = new File("/bin", "ksh")).exists()) {
            string = "#!" + file.getPath();
        }
        if (string == null && (file = new File("/bin", "sh")).exists()) {
            string = "#!" + file.getPath();
        }
        if (string == null && (file = new File("/bin", "bash")).exists()) {
            string = "#!" + file.getPath();
        }
        if (string == null && (file = new File("/usr/bin", "bash")).exists()) {
            string = "#!" + file.getPath();
        }
        if (string == null && (file = new File("/usr/bin", "sh")).exists()) {
            string = "#!" + file.getPath();
        }
        return string;
    }

    private String getLaunchScriptDir(String string) {
        File file;
        String string2 = string;
        if (this.launchDirName != null && this.launchDirName.length() > 0 && (file = new File(this.launchDirName)).exists() && file.isDirectory()) {
            string2 = this.launchDirName;
        }
        return string2;
    }

    private void makeFileExecutable(String string) {
        String string2 = string;
        File file = new File(string2);
        if (file.exists()) {
            UnixCommands.chmod("0754", file.getPath());
            log.write(file.getPath() + " made executable");
        } else {
            log.write(file.getPath() + " does not exist");
        }
    }

    private void createSubfolders(File file) {
        MakeDirs makeDirs = new MakeDirs();
        makeDirs.mkdirs(file);
        List list = makeDirs.getCreatedDirs();
        if (list == null || list.isEmpty()) {
            log.write("no newly created subdirectories");
        } else {
            if (this.createdDirs == null) {
                this.createdDirs = new Vector();
            }
            int n = 0;
            while (n < list.size()) {
                String string = (String)list.get(n++);
                this.createdDirs.add(string);
                log.write("created dir: " + string);
            }
        }
    }

    private boolean isDebianDistro() {
        boolean bl = false;
        File file = null;
        InputStreamReader inputStreamReader = null;
        BufferedReader bufferedReader = null;
        try {
            String string = UnixCommands.tempFilename("zos.zos");
            String string2 = "lsb_release --id > " + Exec.quoteArg(string);
            log.write("checking distro: " + string2);
            Exec.runCommand(string2, UnixCommands.getTempDir());
            file = new File(string);
            inputStreamReader = new FileReader(file);
            bufferedReader = new BufferedReader(inputStreamReader);
            String string3 = bufferedReader.readLine().toLowerCase();
            bl = string3.indexOf("debian") >= 0;
            log.write("distro results: " + string3);
        }
        catch (FileNotFoundException var5_8) {
            log.write("lsb_release not found");
        }
        catch (Exception var5_9) {
            log.write("Unable to run lsb_release");
            log.write(var5_9);
        }
        try {
            if (inputStreamReader != null) {
                inputStreamReader.close();
            }
            if (bufferedReader != null) {
                bufferedReader.close();
            }
            if (file != null) {
                file.delete();
            }
        }
        catch (Exception var5_10) {
            log.write(var5_10);
        }
        log.write("debian distro: " + bl);
        return bl;
    }

    private void runCommand(String[] arrstring) throws Exception {
        Exec.runCommand(arrstring);
    }

    void rememberError(Exception exception) {
        LangUtilities.rememberError(exception);
    }

    void rememberError(String string) {
        LangUtilities.rememberError(string);
    }

    void rememberError(String string, Exception exception) {
        LangUtilities.rememberError(string, exception);
    }

    private void debug(String string) {
    }
}
