/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.runtime.OS;
import com.denova.runtime.WindowsUtils;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.Reader;

public class WindowsDirs {
    private static final String WindowsDirCommand = "windir";
    private static final String WindowsProgramManagerDirCommand = "progmandir";
    private static final String WindowsAppDataCommand = "appdatadir";
    private static final String WindowsMenusDirCommand = "menusdir";
    private static final String WindowsStartupMenusDirCommand = "startmenusdir";
    private static final String WindowsDesktopDirCommand = "desktopdir";
    private static final String WindowsDocumentsCommand = "documentsdir";
    private static final String WindowsRoamingAppDataCommand = "roamingdir";
    private static final String DirectoryResultsFilename = "windir.txt";

    public static String getWindowsDirectory() {
        return WindowsDirs.getDirName("windir");
    }

    public static String getProgramManagerDirectory() {
        return WindowsDirs.getDirName("progmandir");
    }

    public static String getAppDataDirectory() {
        return WindowsDirs.getAppDataDirectory("currentUser");
    }

    public static String getAppDataDirectory(String string) {
        return WindowsDirs.getDirName("appdatadir", string);
    }

    public static String getRoamingAppDataDirectory() {
        return WindowsDirs.getRoamingAppDataDirectory("currentUser");
    }

    public static String getRoamingAppDataDirectory(String string) {
        return WindowsDirs.getDirName("roamingdir", string);
    }

    public static String getDocumentsDirectory() {
        return WindowsDirs.getDocumentsDirectory("currentUser");
    }

    public static String getDocumentsDirectory(String string) {
        return WindowsDirs.getDirName("documentsdir", string);
    }

    public static String getMenuDir() {
        return WindowsDirs.getMenuDir("currentUser");
    }

    public static String getMenuDir(String string) {
        return WindowsDirs.getDirName("menusdir", string);
    }

    public static String getStartupMenuDir() {
        return WindowsDirs.getStartupMenuDir("currentUser");
    }

    public static String getStartupMenuDir(String string) {
        return WindowsDirs.getDirName("startmenusdir", string);
    }

    public static String getDesktopDir() {
        return WindowsDirs.getDesktopDir("currentUser");
    }

    public static String getDesktopDir(String string) {
        return WindowsDirs.getDirName("desktopdir", string);
    }

    private static String getDirName(String string) {
        return WindowsDirs.getDirName(string, null);
    }

    private static String getDirName(String string, String string2) {
        String string3;
        string3 = null;
        if (OS.isWindows()) {
            String[] arrstring = string2 == null ? new String[]{WindowsUtils.getCommandProgramFilename(), string, WindowsUtils.getTempDir()} : new String[]{WindowsUtils.getCommandProgramFilename(), string, string2, WindowsUtils.getTempDir()};
            try {
                WindowsUtils.runCommand(arrstring);
                String string4 = WindowsUtils.tempFilename("windir.txt");
                try {
                    File file = new File(string4);
                    FileReader fileReader = new FileReader(file);
                    BufferedReader bufferedReader = new BufferedReader(fileReader);
                    String string5 = bufferedReader.readLine();
                    if (string5 != null) {
                        string3 = string5.trim();
                    }
                    fileReader.close();
                    bufferedReader.close();
                    file.delete();
                    if (string3 != null) {
                        int n = string3.indexOf(File.separator + File.separator);
                        while (n >= 0) {
                            string3 = string3.substring(0, n) + string3.substring(n + 1);
                            n = string3.indexOf(File.separator + File.separator);
                        }
                    }
                }
                catch (Exception var5_7) {
                    WindowsUtils.rememberError("Unable to read " + string4, var5_7);
                }
            }
            catch (Exception var4_5) {
                WindowsUtils.rememberError("Unable to execute command " + arrstring.toString(), var4_5);
            }
        }
        WindowsUtils.log("dirname: " + string3);
        return string3;
    }
}
