/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.io.MakeDirs;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsConstants;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsLinks;
import com.denova.runtime.WindowsUtils;
import java.io.File;
import java.util.List;
import java.util.Vector;

public class WindowsMenus
implements WindowsConstants {
    protected static final String WindowsStartupMenuCommand = "startupMenu";
    protected static final String WindowsDesktopCommand = "desktop";
    protected static final String WindowsAddProgramsMenu = "addProgramsMenu";
    protected static final String WindowsAddStartupMenu = "addStartupMenu";
    protected static final String WindowsAddDesktop = "addDesktop";
    private static final String EmptyString = "";
    private static final String Space = " ";
    private static final String Quote = "\"";
    private static Log menuLog;
    private List createdDirs = null;

    public WindowsMenus() {
        menuLog = null;
    }

    public WindowsMenus(Log log) {
        menuLog = log;
    }

    public static String getExecutable(String string, boolean bl, String string2, String string3) {
        return WindowsMenus.getExecutable(string, bl, false, string2, string3);
    }

    public static String getExecutable(String string, boolean bl, boolean bl2, String string2, String string3) {
        String string4 = string3;
        WindowsMenus.log("starting to get executable");
        WindowsMenus.log("install dir: " + string);
        WindowsMenus.log("useJavaCommandPrefix: " + bl);
        WindowsMenus.log("useJavaConsole: " + bl2);
        WindowsMenus.log("javaCommandPrefix: " + string2);
        WindowsMenus.log("executableFile: " + string3);
        if (bl) {
            if (!bl2 && string2.startsWith("java ")) {
                string2 = "javaw " + string2.substring("java ".length());
            }
            string3 = string2 + string3;
            WindowsMenus.log("updated executableFile: " + string3);
            string3 = JRE.adjustJreClasspath(string3, string, false);
            WindowsMenus.log("executableFile after adjusting jre: " + string3);
            if (string3.startsWith("\"")) {
                WindowsMenus.log("executable file starts with a quote");
                string3 = string3.substring(1);
                int n = string3.indexOf("\"");
                string4 = n > 0 ? string3.substring(0, n).trim() : string3;
                WindowsMenus.log("executableFile after quotes removed: " + string3);
            } else {
                int n = string3.indexOf(" ");
                if (n > 0) {
                    string4 = string3.substring(0, n);
                }
            }
        } else if (string3.startsWith("\"") && string3.endsWith("\"") && string3.length() > 2) {
            int n = string3.length() - 1;
            WindowsMenus.log("executable file starts and ends with a quote");
            string4 = string3.substring(1, n).trim();
            WindowsMenus.log("executableFile after quotes removed: " + string3);
        }
        WindowsMenus.log("final executableFile: " + string4);
        return string4;
    }

    public static String getArguments(String string, boolean bl, String string2, String string3, String string4) {
        return WindowsMenus.getArguments(string, bl, false, string2, string3, string4);
    }

    public static String getArguments(String string, boolean bl, boolean bl2, String string2, String string3, String string4) {
        int n;
        WindowsMenus.log("starting to get arguments");
        WindowsMenus.log("install dir: " + string);
        WindowsMenus.log("useJavaCommandPrefix: " + bl);
        WindowsMenus.log("useJavaConsole: " + bl2);
        WindowsMenus.log("javaCommandPrefix: " + string2);
        WindowsMenus.log("executableFile: " + string3);
        WindowsMenus.log("commandLineArguments: " + string4);
        String string5 = null;
        if (bl) {
            if (!bl2) {
                if (string2.startsWith("jre ")) {
                    string2 = "jrew " + string2.substring("jre ".length());
                } else if (string2.startsWith("java ")) {
                    string2 = "javaw " + string2.substring("java ".length());
                }
                WindowsMenus.log("new javaCommandPrefix: " + string2);
            }
            string3 = string2 + string3;
            WindowsMenus.log("new executableFile: " + string3);
        }
        string3 = JRE.adjustJreClasspath(string3, string, false);
        WindowsMenus.log("executableFile after JRE adjusted: " + string3);
        String string6 = "";
        if (bl) {
            if (string3.startsWith("\"")) {
                int n2 = string3.indexOf("\"", 1);
                if (n2 >= 0) {
                    string6 = string3.substring(n2 + 1);
                    string3 = string3.substring(1, n2);
                }
            } else {
                int n3 = string3.indexOf(" ");
                if (n3 > 0) {
                    string6 = string3.substring(n3);
                    string3 = string3.substring(0, n3);
                }
            }
        } else if (string3.startsWith("\"") && (n = string3.indexOf("\"", 1)) >= 0) {
            string6 = string3.substring(n + 1);
            string3 = string3.substring(1, n);
        }
        WindowsMenus.log("extraArgs: " + string6);
        WindowsMenus.log("executableFile after extra args removed: " + string3);
        string5 = string6 + " " + string4;
        string5 = string5.trim();
        WindowsMenus.log("arguments: " + string5);
        return string5;
    }

    public boolean addMenuItem(String string, String string2, String string3, String string4, String string5, String string6, String string7) {
        return this.addMenuItem(string, string2, string3, false, false, "", string4, string5, string6, string7);
    }

    public boolean addMenuItem(String string, String string2, String string3, boolean bl, String string4, String string5, String string6, String string7, String string8) {
        return this.addMenuItem(string, string2, string3, bl, false, string4, string5, string6, string7, string8, "currentUser");
    }

    public boolean addMenuItem(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8) {
        return this.addMenuItem(string, string2, string3, bl, bl2, string4, string5, string6, string7, string8, "currentUser");
    }

    public boolean addMenuItem(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8, String string9) {
        return this.addMenuItem(string, string2, string3, bl, bl2, string4, string5, string6, string7, string8, string9, string3);
    }

    public boolean addMenuItem(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8, String string9, String string10) {
        WindowsMenus.log("adding menu for " + string2);
        boolean bl3 = this.addShortcutItem("programsMenu", "addProgramsMenu", "specmenu", string, string2, string3, bl, bl2, string4, string5, string6, string7, string8, string9, string10);
        WindowsMenus.log("added menu ok: " + bl3);
        return bl3;
    }

    public boolean deleteMenuItem(String string, String string2) {
        return this.deleteMenuItem(string, string2, "currentUser");
    }

    public boolean deleteMenuItem(String string, String string2, String string3) {
        boolean bl = this.deleteShortcutItem("programsMenu", "deleteProgramsMenu", "specmenu", string, string2, string3);
        WindowsMenus.log("delete " + string3 + " + menu ok: " + bl);
        if (string3.equals("allUsers")) {
            boolean bl2 = this.deleteShortcutItem("programsMenu", "deleteProgramsMenu", "specmenu", string, string2, "currentUser");
            WindowsMenus.log("delete current menu ok: " + bl2);
        }
        return bl;
    }

    public boolean addStartupMenuItem(String string, String string2, String string3, String string4, String string5, String string6) {
        return this.addStartupMenuItem(string, string2, false, "", string3, string4, string5, string6);
    }

    public boolean addStartupMenuItem(String string, String string2, boolean bl, String string3, String string4, String string5, String string6, String string7) {
        return this.addStartupMenuItem(string, string2, bl, false, string3, string4, string5, string6, string7);
    }

    public boolean addStartupMenuItem(String string, String string2, boolean bl, boolean bl2, String string3, String string4, String string5, String string6, String string7) {
        return this.addStartupMenuItem(string, string2, bl, bl2, string3, string4, string5, string6, string7, "currentUser");
    }

    public boolean addStartupMenuItem(String string, String string2, boolean bl, boolean bl2, String string3, String string4, String string5, String string6, String string7, String string8) {
        return this.addStartupMenuItem(string, string2, bl, bl2, string3, string4, string5, string6, string7, string8, string2);
    }

    public boolean addStartupMenuItem(String string, String string2, boolean bl, boolean bl2, String string3, String string4, String string5, String string6, String string7, String string8, String string9) {
        WindowsMenus.log("adding auto startup menu for " + string);
        return this.addShortcutItem("startupMenu", "addStartupMenu", "specmenu", "", string, string2, bl, bl2, string3, string4, string5, string6, string7, string8, string9);
    }

    public boolean deleteStartupMenuItem(String string) {
        return this.deleteStartupMenuItem(string, "currentUser");
    }

    public boolean deleteStartupMenuItem(String string, String string2) {
        boolean bl = this.deleteShortcutItem("startupMenu", "deleteStartupMenu", "specmenu", "", string, string2);
        WindowsMenus.log("delete " + string2 + " start up menu ok: " + bl);
        if (string2.equals("allUsers")) {
            boolean bl2 = this.deleteShortcutItem("startupMenu", "deleteStartupMenu", "specmenu", "", string, "currentUser");
            WindowsMenus.log("delete current start up menu ok: " + bl2);
        }
        return bl;
    }

    public boolean addDesktopShortcut(String string, String string2, String string3, String string4, String string5, String string6, String string7) {
        return this.addDesktopShortcut("", string2, string3, false, "", string4, string5, string6, string7);
    }

    public boolean addDesktopShortcut(String string, String string2, String string3, boolean bl, String string4, String string5, String string6, String string7, String string8) {
        return this.addDesktopShortcut("", string2, string3, bl, false, string4, string5, string6, string7, string8);
    }

    public boolean addDesktopShortcut(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8) {
        WindowsMenus.log("adding desktop icon for current user");
        return this.addDesktopShortcut("", string2, string3, bl, bl2, string4, string5, string6, string7, string8, "currentUser");
    }

    public boolean addDesktopShortcut(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8, String string9) {
        return this.addDesktopShortcut("", string2, string3, bl, bl2, string4, string5, string6, string7, string8, "currentUser", string3);
    }

    public boolean addDesktopShortcut(String string, String string2, String string3, boolean bl, boolean bl2, String string4, String string5, String string6, String string7, String string8, String string9, String string10) {
        WindowsMenus.log("adding desktop icon for " + string2);
        return this.addShortcutItem("desktop", "addDesktop", "specdesktop", "", string2, string3, bl, bl2, string4, string5, string6, string7, string8, string9, string10);
    }

    public boolean deleteDesktopShortcut(String string, String string2) {
        return this.deleteDesktopShortcut(string, string2, "currentUser");
    }

    public boolean deleteDesktopShortcut(String string, String string2, String string3) {
        boolean bl = this.deleteShortcutItem("desktop", "deleteDesktop", "specdesktop", "", string2, string3);
        WindowsMenus.log("delete " + string3 + " desktop icon ok: " + bl);
        if (string3.equals("allUsers")) {
            boolean bl2 = this.deleteShortcutItem("desktop", "deleteDesktop", "specdesktop", "", string2, "currentUser");
            WindowsMenus.log("delete current desktop icon ok: " + bl2);
        }
        return bl;
    }

    public List getCreatedDirs() {
        return this.createdDirs;
    }

    private boolean addShortcutItem(String string, String string2, String string3, String string4, String string5, String string6, boolean bl, boolean bl2, String string7, String string8, String string9, String string10, String string11, String string12, String string13) {
        File file;
        boolean bl3 = false;
        String string14 = string8;
        WindowsMenus.log("execFile before getExecutable '" + string8 + "'");
        string8 = WindowsMenus.getExecutable(string6, bl, bl2, string7, string8);
        WindowsMenus.log("execFile after getExecutable '" + string8 + "'");
        WindowsMenus.log("cmdLineArgs before getArguments '" + string9 + "'");
        string9 = WindowsMenus.getArguments(string6, bl, string7, string14, string9);
        WindowsMenus.log("cmdLineArgs after getArguments '" + string9 + "'");
        if (!bl) {
            file = new File(string6, string8);
            if (!file.exists()) {
                file = new File(string13, string8);
            }
            if (!file.exists()) {
                file = new File(string8);
            }
            string8 = file.getPath();
            WindowsMenus.log("full exec filename: " + string8);
        }
        if ((file = new File(string8)).exists() || !bl) {
            try {
                WindowsMenus.log("shortcutCommand: " + string);
                WindowsMenus.log("addCommand: " + string2);
                WindowsMenus.log("submenu: " + string4);
                WindowsMenus.log("shortcutName: " + string5);
                WindowsMenus.log("executableFile: " + string8);
                WindowsMenus.log("commandLineArguments: " + string9);
                WindowsMenus.log("install dir: " + string6);
                WindowsMenus.log("working dir: " + string13);
                WindowsMenus.log("icon: " + string11);
                WindowsMenus.log("user: " + string12);
                String string15 = string4;
                string15 = string15 == null ? "" : string15.replace('/', File.separatorChar);
                String string16 = this.prepMenu(string2, string15, string5, string12);
                if (OS.isSecureWindows()) {
                    string12 = "currentUser";
                }
                WindowsLinks windowsLinks = new WindowsLinks(menuLog);
                bl3 = windowsLinks.add(string, string2, string3, string16, string15, string5, string13, string8, string9, string10, string11, string12);
            }
            catch (Exception var19_20) {
                WindowsUtils.rememberError("Unable to create menu", var19_20);
            }
        } else {
            bl3 = false;
            WindowsUtils.rememberError("No executable file for menu");
        }
        WindowsMenus.log("shortcut added successfully: " + bl3);
        return bl3;
    }

    private boolean deleteShortcutItem(String string, String string2, String string3, String string4, String string5, String string6) {
        boolean bl = false;
        String string7 = this.getMenuDirname(string2, string6);
        WindowsLinks windowsLinks = new WindowsLinks(menuLog);
        bl = windowsLinks.remove(string, string2, string3, string7, string4, string5, string6);
        String string8 = null;
        try {
            WindowsMenus.log("deleting " + string);
            string8 = string2.equals("deleteProgramsMenu") ? WindowsDirs.getMenuDir(string6) : (string2.equals("deleteStartupMenu") ? WindowsDirs.getStartupMenuDir(string6) : (string2.equals("deleteDesktop") ? WindowsDirs.getDesktopDir(string6) : WindowsDirs.getMenuDir(string6)));
            WindowsMenus.removeLink(string8, string4, string5);
        }
        catch (Exception var11_11) {
            WindowsMenus.log("Unable to delete menu because of an exception");
        }
        WindowsMenus.log("shortcut deleted successfully: " + bl);
        return bl;
    }

    private static void removeLink(String string, String string2, String string3) {
        Object object;
        File file;
        if (string2 == null || string2.length() <= 0) {
            file = new File(string);
        } else {
            string2 = string2.replace('/', File.separatorChar);
            file = new File(string, string2);
        }
        if (string3 != null && string3.length() > 0) {
            object = new File(file, string3 + ".lnk");
            Vector<String> vector = new Vector<String>();
            vector.add("-r");
            WindowsCommands.changePermissions(object.getPath(), vector);
            if (object.exists()) {
                object.delete();
                WindowsMenus.log("issued delete command");
            }
            boolean bl = !object.exists();
            WindowsMenus.log("deleted " + object.getPath() + ": " + bl);
        }
        if (string2 != null && string2.length() > 0 && file.exists() && file.isDirectory() && (object = file.list()).length <= 0) {
            file.delete();
            WindowsMenus.log("deleted empty dir: " + file.getPath());
        }
    }

    private String getMenuDirname(String string, String string2) {
        String string3 = "";
        if (string.equals("addProgramsMenu") || string.equals("deleteProgramsMenu")) {
            string3 = WindowsDirs.getMenuDir(string2);
        } else if (string.equals("addDesktop") || string.equals("deleteDesktop")) {
            string3 = WindowsDirs.getDesktopDir(string2);
        } else if (string.equals("addStartupMenu") || string.equals("deleteStartupMenu")) {
            string3 = WindowsDirs.getStartupMenuDir(string2);
        }
        WindowsMenus.log(string + " menu dir: " + string3);
        return string3;
    }

    private String prepMenu(String string, String string2, String string3, String string4) {
        String string5;
        String string6 = this.getMenuDirname(string, string4);
        WindowsMenus.removeLink(string6, string2, string3);
        this.createSubfolders(string6, string2);
        if (OS.isSecureWindows() && string4.equals("currentUser") && string2 != null && string2.length() > 0 && (string5 = this.getMenuDirname(string, "allUsers")) != null && string5.length() > 0) {
            WindowsMenus.log("all users menu dir: " + string5);
            File file = new File(string5, string2);
            Vector<String> vector = new Vector<String>();
            vector.add(file.getPath());
            this.createSubfolders(file, vector);
        }
        return string6;
    }

    private void createSubfolders(String string, String string2) {
        if (string2 == null || string2.length() <= 0) {
            WindowsMenus.log("no subfolders for this menu item.");
        } else {
            File file;
            WindowsMenus.log("creating subfolders for " + string2);
            if (string == null || string.length() <= 0) {
                file = new File(string2);
                WindowsMenus.log("no main menu dir defined");
            } else {
                file = new File(string, string2);
                WindowsMenus.log(" in " + file.getPath());
            }
            this.createSubfolders(file);
        }
    }

    private void createSubfolders(File file) {
        MakeDirs makeDirs = new MakeDirs();
        makeDirs.mkdirs(file);
        List list = makeDirs.getCreatedDirs();
        this.createSubfolders(file, list);
    }

    private void createSubfolders(File file, List list) {
        if (list == null || list.isEmpty()) {
            WindowsMenus.log("no newly created subdirectories");
        } else {
            WindowsMenus.log("created subfolders for " + file.getPath());
            if (this.createdDirs == null) {
                this.createdDirs = new Vector();
            }
            int n = 0;
            while (n < list.size()) {
                String string;
                if (this.createdDirs.contains(string = (String)list.get(n++))) continue;
                this.createdDirs.add(string);
                WindowsMenus.log("added dir: " + string);
            }
        }
    }

    private static void log(String string) {
        if (menuLog == null) {
            WindowsUtils.log(string);
        } else {
            menuLog.write(string);
        }
    }
}
