/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.lang.LangUtilities;
import com.denova.runtime.Exec;
import com.denova.runtime.WindowsConstants;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.Reader;

public class WindowsUtils
implements WindowsConstants {
    private static final String WindowsCommandsFilename = "JExpressWinAPI.exe";
    private static String logFilename = "winapi";
    private static Log winLog = null;
    private static boolean loggingCmds = false;
    private static String tempDirName = null;
    private static File commandProgram = null;
    private static File defaultDirectory = null;
    private static File commandFile = null;
    private static int attemptsToGetCommandProgram = 0;

    public static void setDefaultDirectory(File file) {
        defaultDirectory = file;
    }

    public static void setDefaultDirectory(String string) {
        WindowsUtils.setDefaultDirectory(new File(string));
    }

    public static String getWindowsCommandsFilename() {
        return "JExpressWinAPI.exe";
    }

    public static String getCommandProgramFilename() {
        String string = WindowsUtils.getWindowsCommandsFilename();
        if (commandProgram == null) {
            WindowsUtils.getCommandProgram();
        }
        if (commandProgram == null) {
            WindowsUtils.log("unable to get full path to command file");
        } else {
            try {
                string = commandProgram.getCanonicalPath();
            }
            catch (Exception var1_1) {
                string = commandProgram.getAbsolutePath();
            }
        }
        return string;
    }

    public static void runCommand(String[] arrstring) throws Exception {
        File file;
        boolean bl = true;
        String string = "";
        if (!(arrstring.length <= 0 || (bl = (file = new File(string = arrstring[0])).exists()))) {
            WindowsUtils.log("executable not found: " + string);
        }
        if (bl) {
            Exec.runCommand(arrstring);
        }
    }

    public static String runCommand(String[] arrstring, String string) {
        String string2 = null;
        try {
            WindowsUtils.runCommand(arrstring);
            String string3 = WindowsUtils.tempFilename(string);
            try {
                File file = new File(string3);
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                String string4 = bufferedReader.readLine();
                if (string4 != null) {
                    string2 = string4.trim();
                } else {
                    WindowsUtils.log("results were empty");
                }
                fileReader.close();
                bufferedReader.close();
                file.delete();
            }
            catch (FileNotFoundException var4_6) {
                WindowsUtils.rememberError("Results file not found: " + string3);
            }
            catch (Exception var4_7) {
                WindowsUtils.rememberError("Unable to read " + string3, var4_7);
            }
        }
        catch (Exception var3_4) {
            WindowsUtils.rememberError("Unable to execute command " + arrstring.toString(), var3_4);
        }
        WindowsUtils.log("result: " + string2);
        return string2;
    }

    public static boolean isError() {
        return LangUtilities.isError();
    }

    public static Exception getLastException() {
        return LangUtilities.getLastException();
    }

    public static String getLastError() {
        return LangUtilities.getLastError();
    }

    public static void clearError() {
        LangUtilities.clearError();
    }

    public static void rememberError(Exception exception) {
        LangUtilities.rememberError(exception);
        WindowsUtils.log(exception);
    }

    public static void rememberError(String string) {
        LangUtilities.rememberError(string);
        WindowsUtils.log(string);
    }

    public static void rememberError(String string, Exception exception) {
        LangUtilities.rememberError(string, exception);
        WindowsUtils.log(string);
        WindowsUtils.log(exception);
    }

    public static String tempFilename(String string) {
        String string2 = "";
        File file = TempFiles.getFile(string);
        try {
            string2 = file.getCanonicalPath();
        }
        catch (Exception var3_3) {
            string2 = file.getAbsolutePath();
        }
        return string2;
    }

    public static String getTempDir() {
        String string;
        File file = TempFiles.getDefaultDirectory();
        try {
            string = file.getCanonicalPath();
        }
        catch (Exception var2_2) {
            string = file.getAbsolutePath();
        }
        return string;
    }

    public static void log(String string) {
        WindowsUtils.startLog();
        winLog.write(string);
    }

    public static void log(Exception exception) {
        WindowsUtils.startLog();
        winLog.write(exception);
    }

    public static boolean getLogging() {
        WindowsUtils.startLog();
        return winLog.getLogging();
    }

    public static void startLog() {
        if (winLog == null) {
            winLog = new Log(logFilename);
        }
    }

    private static File getCommandProgram() {
        if (commandProgram == null) {
            commandProgram = WindowsUtils.getCommandFile();
        }
        return commandProgram;
    }

    private static File getCommandFile() {
        if (commandFile == null) {
            String string;
            int n = "JExpressWinAPI.exe".indexOf(".exe");
            String string2 = System.getProperty("os.arch", "unknown").toLowerCase();
            boolean bl = string2.indexOf("64") >= 0;
            WindowsUtils.log("64 bit: " + bl);
            File file = WindowsUtils.getCommandFile("JExpressWinAPI.exe");
            if (file == null && bl && (file = WindowsUtils.getCommandFile(string = "JExpressWinAPI.exe".substring(0, n) + "-x64" + ".exe")) == null) {
                WindowsUtils.log("unable to find " + string);
            }
            if (file == null && (file = WindowsUtils.getCommandFile(string = "JExpressWinAPI.exe".substring(0, n) + "-x32" + ".exe")) == null) {
                WindowsUtils.log("unable to find " + string);
            }
            if (!(file != null && file.exists())) {
                WindowsUtils.log("unable to getCommandFile()");
            } else {
                commandFile = file;
                WindowsUtils.log("getCommandFile() is " + commandFile.getPath());
            }
        }
        return commandFile;
    }

    private static File getCommandFile(String string) {
        File file = null;
        File file2 = null;
        try {
            if (!(defaultDirectory != null && defaultDirectory.exists())) {
                defaultDirectory = TempFiles.getDefaultDirectory();
            }
            if (!(file2 = new File(defaultDirectory, string)).exists()) {
                WindowsUtils.log(file2.getPath() + " doesn't exist");
                file2 = new File(string);
            }
            if (!file2.exists()) {
                WindowsUtils.log(file2.getPath() + " doesn't exist");
                file2 = new File("JExpress", string);
            }
            if (!file2.exists()) {
                WindowsUtils.log(file2.getPath() + " doesn't exist");
                file2 = TempFiles.getFile(string);
                TempFiles.add(file2);
                if (!(file2.exists() || FileSystem.getResourceAsFile(string, null))) {
                    WindowsUtils.log("unable to use file system to get " + string);
                }
                if (file2.exists()) {
                    WindowsUtils.log("temporarily extracted " + file2.getPath());
                }
            }
        }
        catch (Exception var3_3) {
            WindowsUtils.log(var3_3.getMessage());
        }
        if (!(file2 != null && file2.exists())) {
            WindowsUtils.log("unable to extract " + string);
        } else {
            file = file2;
            try {
                String[] arrstring = new String[]{"attrib", "+H", "\"" + file2.getPath() + "\""};
                Exec.execCommand(arrstring);
                WindowsUtils.log("file hidden");
            }
            catch (Exception var3_5) {
                WindowsUtils.log(var3_5);
            }
        }
        return file;
    }
}
