/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.runtime.ThreadManager;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;

public class AutoProgressBar
extends JProgressBar
implements Runnable {
    public static final int Interval = 100;
    public static final int SecondsToReachTarget = 2;
    public static final int MillisecondsInSecond = 1000;
    public static final int MillisecondsToReachTarget = 2000;
    public static final int NumberOfIntervals = 20;
    private static final Log log = new Log("autoprogressbar");
    private static final int DefaultMaximum = 1000;
    private int currentPosition = 0;
    private int targetPosition = 0;
    private int increment = 1;
    private Thread thread = null;
    private boolean running = false;

    public void run() {
        while (this.running) {
            if (this.isMaximized()) {
                this.stop();
                this.log("stopped because progress bar maximized");
                continue;
            }
            if (this.currentPosition <= this.targetPosition) {
                this.log("currentPosition: " + this.currentPosition);
                this.log("targetPosition: " + this.targetPosition);
                boolean bl = false;
                if (this.increment > 0) {
                    this.log("increment: " + this.increment);
                    if (this.currentPosition + this.increment <= this.targetPosition) {
                        this.setValueNow(this.currentPosition + this.increment);
                        bl = true;
                        this.log("currentPosition + increment: " + this.currentPosition);
                    }
                } else {
                    this.log("increment is zero");
                }
                if (!bl) {
                    this.setValueNow(this.targetPosition);
                    this.log("currentPosition set to targetPosition: " + this.currentPosition);
                }
            }
            this.log("started to sleep");
            ThreadManager.sleep(100);
            this.log("finished sleeping");
        }
        this.log("not running any more");
    }

    public int getValue() {
        return this.currentPosition;
    }

    public void setValue(int n) {
        if (n < this.currentPosition) {
            this.log("setValue(" + n + ") tried to back up");
        } else if (this.isMaximized()) {
            this.log("setValue(" + n + ") called but alreaxdy maximimized");
        } else {
            this.targetPosition = n;
            this.log("set targetPosition: " + n);
            this.log("currentPosition: " + this.currentPosition);
            if (this.targetPosition > this.currentPosition) {
                this.increment = (this.targetPosition - this.currentPosition) / 20;
            }
            if (this.increment <= 0) {
                this.increment = 1;
            }
            this.log("increment: " + this.increment);
        }
    }

    public void setValueNow(int n) {
        if (n < 0 || n < this.currentPosition) {
            this.log("setValueNow(" + n + ") tried to back up");
        } else if (this.isMaximized()) {
            this.log("setValueNow(" + n + ") called but alreaxdy maximimized");
        } else {
            this.currentPosition = n;
            this.log("scheduling setValueNow(" + n + ")");
            SwingUtilities.invokeLater(new Runnable(){

                public void run() {
                    AutoProgressBar.this.superSetValue(AutoProgressBar.this.currentPosition);
                }
            });
        }
    }

    public void start() {
        this.running = true;
        if (this.getMaximum() <= 0) {
            this.setMaximum(1000);
        }
        if (this.thread == null) {
            this.thread = new Thread(this);
            this.thread.start();
        }
        this.log("started");
    }

    public void stop() {
        this.running = false;
        this.log("stopped running in " + this.getName());
    }

    public void maximize() {
        this.log("maximizing fast");
        this.setValue(this.getMaximum());
    }

    private void superSetValue(int n) {
        this.log("superSetValue(" + n + ")");
        if (n < this.currentPosition) {
            n = this.currentPosition;
        }
        super.setValue(n);
        this.log("progress bar set now: " + n);
    }

    public boolean isMaximized() {
        return this.getValue() >= this.getMaximum();
    }

    private void log(String string) {
        String string2 = this.getName();
        if (string2 != null) {
            string = string2 + ": " + string;
        }
        log.write(string);
        log.flush();
    }

}
