/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.Fonts;
import com.denova.ui.UiLayoutUtilities;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;

public final class JWordWrapLabel
extends JScrollPane {
    public static final String MessageArea = "MessageArea";
    public static final int MaxWidth = JWordWrapLabel.getMaxWidth();
    private static final int MinRows = 2;
    private String text = null;
    private int rows = 2;
    private int sideMargins = 0;
    private int fontCharWidth = -1;
    private int fontLineHeight = -1;
    private Font font = null;
    private Color foreground = null;
    private Color background = null;
    private Border areaBorder = null;
    private Border scrollBorder = null;
    private JTextArea textArea = null;
    private static final Log log = new Log("wraplabel");

    public JWordWrapLabel() {
        this(Fonts.Dialog);
    }

    public JWordWrapLabel(String string) {
        this();
        this.setAndWrapText(string);
    }

    public JWordWrapLabel(String string, Font font) {
        this(font);
        this.setAndWrapText(string);
    }

    public JWordWrapLabel(Font font) {
        super(21, 31);
        this.font = font;
        this.setFontDimensions();
        this.setOpaque(false);
    }

    public String getText() {
        return this.text;
    }

    public void setText(String string) {
        this.setAndWrapText(string);
        if (this.textArea != null) {
            UiLayoutUtilities.update((Component)this.textArea, (Object)string);
        }
    }

    public String getName() {
        String string = null;
        if (this.textArea != null) {
            string = this.textArea.getName();
        }
        return string;
    }

    public void setName(String string) {
        if (this.textArea != null) {
            this.textArea.setName(string);
        }
    }

    public int getRows() {
        return this.rows;
    }

    public void setRows(int n) {
        this.rows = n;
        log.write("set rows: " + this.rows);
        this.wrapText();
    }

    public Font getFont() {
        return this.font;
    }

    public void setFont(Font font) {
        this.font = font;
        if (this.textArea != null) {
            this.textArea.setFont(this.font);
        }
        this.setFontDimensions();
        this.wrapText();
    }

    public Color getForeground() {
        return this.foreground;
    }

    public void setForeground(Color color) {
        this.foreground = color;
        if (this.foreground != null) {
            if (this.textArea != null) {
                this.textArea.setForeground(this.foreground);
                log.write("setting foreground color");
            }
            super.setForeground(this.foreground);
        }
    }

    public Color getBackground() {
        return this.background;
    }

    public void setBackground(Color color) {
        this.background = color;
        if (this.background == null) {
            if (this.textArea != null) {
                this.textArea.setOpaque(false);
            }
        } else {
            if (this.textArea != null) {
                this.textArea.setBackground(this.background);
                log.write("setting background color");
            }
            super.setBackground(this.background);
        }
    }

    public Border getAreaBorder() {
        return this.areaBorder;
    }

    public void setAreaBorder(Border border, int n) {
        this.areaBorder = border;
        if (n != 0) {
            this.sideMargins = 2 * n;
        }
        if (this.textArea != null && this.areaBorder != null) {
            this.textArea.setBorder(this.areaBorder);
        }
    }

    public Border getScrollBorder() {
        return this.scrollBorder;
    }

    public void setScrollBorder(Border border) {
        this.scrollBorder = border;
    }

    private void setupScrollPane() {
        if (this.scrollBorder == null) {
            this.setBorder(new EmptyBorder(0, 0, 0, 0));
        } else {
            this.setBorder(this.scrollBorder);
        }
        if (this.getBackground() != null) {
            this.getViewport().setBackground(this.getBackground());
        }
        this.getViewport().add(this.getTextArea());
    }

    private JTextArea getTextArea() {
        if (this.textArea == null) {
            this.textArea = this.getNewTextArea();
        }
        this.textArea.setPreferredSize(this.getPreferredSize());
        this.setTextAreaAttributes(this.textArea);
        return this.textArea;
    }

    private void setTextAreaAttributes(JTextArea jTextArea) {
        if (jTextArea != null) {
            jTextArea.setEditable(false);
            jTextArea.setLineWrap(true);
            jTextArea.setWrapStyleWord(true);
            jTextArea.setFont(this.font);
            jTextArea.setText(this.text);
            jTextArea.setName("MessageArea");
            if (this.getForeground() != null) {
                jTextArea.setForeground(this.getForeground());
            }
            if (this.getBackground() == null) {
                jTextArea.setOpaque(false);
            } else {
                jTextArea.setBackground(this.getBackground());
            }
            if (this.areaBorder != null) {
                jTextArea.setBorder(this.areaBorder);
            }
        }
    }

    public Dimension getPreferredSize() {
        int n;
        int n2;
        if (this.text != null) {
            n2 = this.getFontMetrics().stringWidth(this.text);
            if (n2 < MaxWidth) {
                n = n2;
                log.write("width set to text width: " + n);
            } else {
                n = MaxWidth;
                log.write("width set to max width: " + n);
            }
        } else {
            n = MaxWidth;
            log.write("no text, so width set from graphics env: " + n);
        }
        n2 = this.getRows() * this.fontLineHeight;
        log.write("preferred size: " + n + " width; " + n2 + " height");
        log.write("                " + this.fontCharWidth + " fontCharWidth: " + this.fontLineHeight + " fontLineHeight");
        return new Dimension(n, n2);
    }

    private void setAndWrapText(String string) {
        this.text = string;
        log.write("text: " + this.text);
        this.wrapText();
    }

    private void wrapText() {
        this.calcSize();
        this.setupScrollPane();
    }

    private void calcSize() {
        if (this.text != null && this.text.length() > 0) {
            FontMetrics fontMetrics = this.getFontMetrics();
            int n = fontMetrics.stringWidth(this.text);
            log.write("textWidth: " + n);
            int n2 = this.getPreferredSize().width;
            log.write("rowWidth: " + n2);
            this.rows = 1;
            while (n > 0) {
                n-=n2;
                ++this.rows;
            }
            log.write("rows for text: " + this.rows);
            int n3 = this.getBlankRows();
            if (n3 > 0) {
                this.rows+=n3;
                log.write("rows with blank rows: " + this.rows);
            }
        } else {
            this.rows = 2;
            log.write("no text, so set rows to min: " + this.rows);
        }
    }

    private int getBlankRows() {
        int n = 0;
        if (this.text != null) {
            String string = this.text;
            int n2 = string.indexOf("\n");
            while (n2 > -1) {
                ++n;
                string = string.substring(n2 + 1);
                n2 = string.indexOf("\n");
            }
            log.write("blank rows: " + n);
        }
        return n;
    }

    private JTextArea getNewTextArea() {
        JTextArea jTextArea = new JTextArea();
        this.setTextAreaAttributes(jTextArea);
        return jTextArea;
    }

    private FontMetrics getFontMetrics() {
        JTextArea jTextArea = this.textArea != null ? this.textArea : this.getNewTextArea();
        return jTextArea.getFontMetrics(this.font);
    }

    private static int getMaxWidth() {
        GraphicsEnvironment graphicsEnvironment = GraphicsEnvironment.getLocalGraphicsEnvironment();
        Rectangle rectangle = graphicsEnvironment.getMaximumWindowBounds();
        return rectangle.width / 2;
    }

    private void setFontDimensions() {
        FontMetrics fontMetrics = this.getFontMetrics();
        this.fontCharWidth = fontMetrics.getMaxAdvance();
        this.fontLineHeight = fontMetrics.getMaxAscent() + fontMetrics.getMaxDescent();
    }
}
