/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.runtime.OS;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.UiPopups;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.InputStream;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.plaf.metal.DefaultMetalTheme;
import javax.swing.plaf.metal.MetalLookAndFeel;
import javax.swing.plaf.metal.OceanTheme;
import javax.swing.plaf.synth.SynthLookAndFeel;

public class LookAndFeel {
    public static final String Metal = "Metal";
    public static final String Native = "Native";
    public static final String Nimbus = "Nimbus";
    public static final String Synth = "Synth";
    public static final String NimROD = "NimROD";
    public static final String OceanMetalLook = "Ocean";
    public static final String DefaultMetalLook = "DefaultMetal";
    public static final String DefaultNimbusLook = "Default";
    public static final String DefaultSynthLook = "Blue gradient";
    public static final String DefaultNimRODLook = "Default";
    public static final String NimbusXmlName = "nimbus.xml";
    public static final String NimbusComXmlName = "nimbuscom.xml";
    public static final String NimbusOrgXmlName = "nimbusorg.xml";
    public static final String SynthXmlName = "synth.xml";
    private static final String CrossPlatformLookAndFeel = "javax.swing.plaf.multi.MultiLookAndFeel";
    private static final String WindowsLookAndFeel = "javax.swing.plaf.windows.WindowsLookAndFeel";
    private static final String MetalLookAndFeel = "javax.swing.plaf.metal.MetalLookAndFeel";
    private static final String NimbusJavaxLookAndFeel = "javax.swing.plaf.nimbus.NimbusLookAndFeel";
    private static final String NimbusOrgLookAndFeel = "org.jdesktop.swingx.plaf.nimbus.NimbusLookAndFeel";
    private static final String NimbusComLookAndFeel = "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
    private static final String NimRODLookAndFeel = "com.nilo.plaf.nimrod.NimRODLookAndFeel";
    private static final String NimRODTheme = "com.nilo.plaf.nimrod.NimRODTheme";
    private static final Log log = new Log("lf.log");
    private static String activeLookAndFeel = "Native";

    public static String getActiveLookAndFeel() {
        log.write("active look and feel: " + activeLookAndFeel);
        return activeLookAndFeel;
    }

    public static boolean set() {
        boolean bl = false;
        try {
            try {
                bl = LookAndFeel.changeLF("Native");
            }
            catch (Exception var1_1) {
                bl = false;
                log.write(var1_1);
            }
            if (!bl) {
                try {
                    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
                    activeLookAndFeel = "Metal";
                    bl = true;
                    log.write("setting cross platform look and feel");
                }
                catch (Exception var1_2) {
                    bl = false;
                    LookAndFeel.unexpectedStartupError();
                    log.write(var1_2);
                }
            }
        }
        catch (Exception var1_3) {
            bl = false;
            LookAndFeel.unexpectedStartupError();
            log.write(var1_3);
        }
        return bl;
    }

    public static boolean set(String string, String string2) {
        boolean bl = false;
        if (string != null && string.length() > 0) {
            bl = LookAndFeel.changeLF(string);
        }
        if (!bl) {
            if (string2 == null || string2.length() <= 0) {
                log.write("no default look and feel defined");
            } else {
                log.write("setting look and feel to default: " + string2);
                bl = LookAndFeel.changeLF(string2);
            }
        }
        return bl;
    }

    public static boolean set(String string, String string2, String string3) {
        boolean bl = false;
        if (string != null && string.length() > 0) {
            bl = string2 != null && string2.length() > 0 ? LookAndFeel.changeLF(string, string2) : LookAndFeel.changeLF(string);
        }
        if (!bl) {
            if (string3 == null || string3.length() <= 0) {
                log.write("no default look and feel defined");
            } else {
                log.write("setting look and feel to default: " + string3);
                bl = LookAndFeel.changeLF(string3);
            }
        }
        return bl;
    }

    public static boolean set(String string, Class class_) {
        boolean bl = false;
        try {
            if (string.equals("Nimbus")) {
                String string2 = LookAndFeel.getNimbusClassname();
                if (string2 == null) {
                    bl = LookAndFeel.set("Native", "Metal");
                } else {
                    String string3 = "nimbus.xml";
                    if (string2.equals("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel")) {
                        string3 = "nimbuscom.xml";
                    } else if (string2.equals("org.jdesktop.swingx.plaf.nimbus.NimbusLookAndFeel")) {
                        string3 = "nimbusorg.xml";
                    }
                    log.write("trying to set nimbus l&f with " + string3);
                    Constructor constructor = LookAndFeel.getNoParamConstructor(string2);
                    Object[] arrobject = new Object[]{};
                    SynthLookAndFeel synthLookAndFeel = (SynthLookAndFeel)constructor.newInstance(arrobject);
                    synthLookAndFeel.load(class_.getResourceAsStream(string3), class_);
                    UIManager.setLookAndFeel(synthLookAndFeel);
                    activeLookAndFeel = "Nimbus";
                    log.write("set nimbus l&f");
                    bl = true;
                }
            } else if (string.equals("Synth")) {
                log.write("trying to set synth l&f");
                SynthLookAndFeel synthLookAndFeel = new SynthLookAndFeel();
                synthLookAndFeel.load(class_.getResourceAsStream("synth.xml"), class_);
                UIManager.setLookAndFeel(synthLookAndFeel);
                activeLookAndFeel = "Synth";
                log.write("set synth l&f");
                bl = true;
            } else {
                bl = LookAndFeel.set(string, "Metal");
            }
        }
        catch (Exception var3_5) {
            log.write(var3_5);
            bl = LookAndFeel.set("Native", "Metal");
        }
        return bl;
    }

    public static void setMinimizedIcon(JFrame jFrame, String string) {
        try {
            boolean bl = false;
            Image image = null;
            ButtonsIcons buttonsIcons = new ButtonsIcons();
            ImageIcon imageIcon = buttonsIcons.getIcon(string);
            if (imageIcon == null) {
                log.write("unable to get icon from " + string);
            } else {
                log.write("got icon");
                image = imageIcon.getImage();
                log.write("got image");
                bl = LookAndFeel.setMinimizedImage(jFrame, image);
            }
            if (!(bl && image != null)) {
                image = Toolkit.getDefaultToolkit().getImage(string);
                LookAndFeel.setMinimizedImage(jFrame, image);
            }
        }
        catch (Exception var2_3) {
            log.write(var2_3);
        }
    }

    public static void setMinimizedIcon(JFrame jFrame, URL uRL) {
        try {
            log.write("getting image from url: " + uRL.toString());
            LookAndFeel.setMinimizedImage(jFrame, Toolkit.getDefaultToolkit().getImage(uRL));
        }
        catch (Exception var2_2) {
            log.write(var2_2);
        }
    }

    public static boolean setMinimizedImage(JFrame jFrame, Image image) {
        boolean bl = false;
        try {
            if (image == null) {
                log.write("image undefined in setMinimizedIcon");
            } else {
                jFrame.setIconImage(image);
                bl = true;
            }
        }
        catch (Exception var3_3) {
            log.write(var3_3);
        }
        log.write("set icon image: " + bl);
        return bl;
    }

    public static boolean lafSupportsChangingColors(String string) {
        return string.equals("Native") || string.equals("Metal") || string.equals("Nimbus");
    }

    public static boolean lafSupportsThemes(String string) {
        return string.equals("Nimbus") || string.equals("Synth") || string.equals("Metal") || string.equals("NimROD");
    }

    private static boolean changeLF(String string, String string2) {
        boolean bl = false;
        try {
            if (string.equals("Metal")) {
                if (string2.equals("DefaultMetal")) {
                    MetalLookAndFeel.setCurrentTheme(new DefaultMetalTheme());
                } else if (string2.equals("Ocean")) {
                    MetalLookAndFeel.setCurrentTheme(new OceanTheme());
                } else {
                    MetalLookAndFeel.setCurrentTheme(new DefaultMetalTheme());
                }
                UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
                activeLookAndFeel = "Metal";
                bl = true;
            } else if (string.equals("NimROD")) {
                File file;
                Constructor constructor = LookAndFeel.getNoParamConstructor("com.nilo.plaf.nimrod.NimRODLookAndFeel");
                Object[] arrobject = new Object[]{};
                MetalLookAndFeel metalLookAndFeel = (MetalLookAndFeel)constructor.newInstance(arrobject);
                if (!(string2.equals("Default") || (file = LookAndFeel.getNimRODThemeFile(string2)) == null)) {
                    constructor = LookAndFeel.getNimRODThemeConstructor();
                    Object[] arrobject2 = new Object[]{file.getPath()};
                    DefaultMetalTheme defaultMetalTheme = (DefaultMetalTheme)constructor.newInstance(arrobject2);
                    MetalLookAndFeel.setCurrentTheme(defaultMetalTheme);
                }
                UIManager.setLookAndFeel(metalLookAndFeel);
                activeLookAndFeel = "NimROD";
                bl = true;
            } else {
                bl = LookAndFeel.changeLF(string);
            }
        }
        catch (Exception var3_4) {
            bl = false;
        }
        return bl;
    }

    private static boolean changeLF(String string) {
        boolean bl = false;
        if (string != null && string.length() > 0) {
            String string2;
            String string3 = null;
            if (string.equals("Native")) {
                string3 = LookAndFeel.getNativeLF();
                activeLookAndFeel = "Native";
            } else if (string.equals("Metal")) {
                string3 = "javax.swing.plaf.metal.MetalLookAndFeel";
                activeLookAndFeel = "Metal";
            } else if (string.equals("Nimbus")) {
                string3 = LookAndFeel.getNimbusClassname();
                if (string3 == null) {
                    string3 = "Native";
                    activeLookAndFeel = "Native";
                    log.write("nimbus laf not available; using native");
                } else {
                    activeLookAndFeel = "Nimbus";
                }
            } else if (string.equals("NimROD")) {
                string3 = "com.nilo.plaf.nimrod.NimRODLookAndFeel";
                string2 = System.getProperty("java.version");
                if (string2 == null || string2.compareTo("1.6") < 0) {
                    string3 = "Native";
                    activeLookAndFeel = "Native";
                } else {
                    activeLookAndFeel = "NimROD";
                }
            } else {
                string3 = UIManager.getCrossPlatformLookAndFeelClassName();
                activeLookAndFeel = "Metal";
            }
            if (string3 != null) {
                string2 = null;
                try {
                    string2 = UIManager.getLookAndFeel().getName();
                }
                catch (Exception var4_4) {
                    log.write(var4_4);
                }
                if (string2.equals(string3)) {
                    log.write("look and feel already set to " + string2);
                    bl = true;
                } else {
                    try {
                        log.write("current look and feel: " + string2);
                        UIManager.setLookAndFeel(string3);
                        bl = true;
                        log.write("look and feel changed to " + string3);
                    }
                    catch (Exception var4_5) {
                        bl = false;
                        log.write("unable to use " + string3 + " look and feel");
                        log.write(var4_5);
                    }
                }
            }
        }
        return bl;
    }

    private static String getNativeLF() {
        String string = null;
        try {
            if (OS.isWindows()) {
                string = "javax.swing.plaf.windows.WindowsLookAndFeel";
                log.write("windows look and feel: javax.swing.plaf.windows.WindowsLookAndFeel");
                log.write("system look and feel: " + UIManager.getSystemLookAndFeelClassName());
            } else {
                try {
                    string = UIManager.getSystemLookAndFeelClassName();
                    log.write("system look and feel: " + string);
                }
                catch (Exception var1_1) {
                    log.write(var1_1);
                }
            }
        }
        catch (Exception var1_2) {
            log.write(var1_2);
        }
        return string;
    }

    private static String getNimbusClassname() {
        String string = null;
        String string2 = System.getProperty("java.version");
        if (string2 == null) {
            log.write("unknown version of java");
        } else {
            string = string2.compareTo("1.7") >= 0 ? "javax.swing.plaf.nimbus.NimbusLookAndFeel" : "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
        }
        return string;
    }

    private static File getNimRODThemeFile(String string) {
        File file = null;
        try {
            if (!string.endsWith(".theme")) {
                string = string + ".theme";
            }
            log.write("getting nimrod's theme: " + string);
            File file2 = TempFiles.getDefaultDirectory();
            if (FileSystem.getResourceAsFile(string, file2.getPath())) {
                file = new File(file2, string);
                log.write("got nimrod's theme: " + file.getPath());
                TempFiles.add(file);
                file.deleteOnExit();
            } else {
                log.write("unable to get nimrod's theme");
            }
        }
        catch (Exception var2_3) {
            log.write(var2_3);
        }
        return file;
    }

    private static Class getClass(String string) {
        Class class_ = null;
        try {
            class_ = Class.forName(string);
        }
        catch (ClassNotFoundException var2_2) {
            log.write("Unable to find class: " + string);
        }
        catch (Exception var2_3) {
            log.write("Unexpected error loading: " + string);
        }
        return class_;
    }

    private static Constructor getNoParamConstructor(String string) {
        Constructor constructor = null;
        Class class_ = LookAndFeel.getClass(string);
        if (class_ != null) {
            try {
                Class[] arrclass = new Class[]{};
                constructor = class_.getConstructor(arrclass);
            }
            catch (NoSuchMethodException var3_4) {
                log.write("No matching constructor for " + string);
            }
            catch (Exception var3_5) {
                log.write("Unexpected error getting constructor for  \"" + string + "\"" + " " + var3_5.getMessage());
            }
        }
        return constructor;
    }

    private static Constructor getNimRODThemeConstructor() {
        Constructor constructor = null;
        String string = "com.nilo.plaf.nimrod.NimRODTheme";
        Class class_ = LookAndFeel.getClass(string);
        if (class_ != null) {
            try {
                Class class_2 = Class.forName("java.lang.String");
                Class[] arrclass = new Class[]{class_2};
                constructor = class_.getConstructor(arrclass);
            }
            catch (NoSuchMethodException var3_4) {
                log.write("No matching constructor for " + string);
            }
            catch (Exception var3_5) {
                log.write("Unexpected error getting constructor for  \"" + string + "\"" + " " + var3_5.getMessage());
            }
        }
        return constructor;
    }

    private static void unexpectedStartupError() {
        UiPopups.unexpectedStartupError();
    }
}
