/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.Fonts;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintStream;
import java.util.List;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JWindow;

public class Marquee
extends JWindow {
    private static Log log = null;
    private String fontName = new JLabel().getName();
    private int fontSize = 0;
    private String backgroundFilename = null;
    private Color backgroundColor = null;
    private Color textColor = Color.black;
    private List text = null;
    private int topMargin = 25;
    private int bottomMargin = 25;
    private int leftMargin = 10;
    private int rightMargin = 10;
    private String bottomText = null;
    private JButton closeButton = null;
    private String closeLabel = null;
    private String closeTip = null;
    private boolean setDefaultButton = false;
    private int marqueeIndex = 0;
    private JPanel marqueePanel;
    private MainTextPanel mainPanel;
    private JPanel buttonPanel;
    private boolean debugging = false;

    public void showWindow() {
        this.logMessage("showing marquee");
        this.setContentPane(this.getPanel());
        this.pack();
        this.setVisible(true);
    }

    public JPanel getPanel() {
        this.marqueeIndex = 0;
        this.marqueePanel = new JPanel(new BorderLayout());
        this.setComponentBackground(this.marqueePanel);
        this.mainPanel = new MainTextPanel();
        this.marqueePanel.add((Component)this.mainPanel, "Center");
        ++this.marqueeIndex;
        this.buttonPanel = this.getButtonPanel();
        if (this.buttonPanel != null) {
            this.marqueePanel.add((Component)this.buttonPanel, "South");
            ++this.marqueeIndex;
        }
        this.logMessage("got marquee");
        return this.marqueePanel;
    }

    public JPanel updatePanel() {
        this.setComponentBackground(this.marqueePanel);
        this.mainPanel.setup();
        JPanel jPanel = this.getButtonPanel();
        if (this.buttonPanel != null) {
            this.marqueePanel.remove(this.marqueeIndex - 1);
            --this.marqueeIndex;
        }
        if (jPanel != null) {
            this.buttonPanel = jPanel;
            this.marqueePanel.add((Component)this.buttonPanel, "South");
            ++this.marqueeIndex;
        }
        this.logMessage("updated marquee");
        return this.marqueePanel;
    }

    public void exit() {
        this.dispose();
    }

    public JButton getCloseButton() {
        return this.closeButton;
    }

    public void setBackgroundFilename(String string) {
        this.backgroundFilename = string;
        this.logMessage("setBackgroundFilename: " + this.backgroundFilename);
    }

    public void setBackgroundColor(Color color) {
        this.backgroundColor = color;
        this.logMessage("setBackgroundColor: " + this.backgroundColor);
    }

    public void setText(List list) {
        this.text = list;
        int n = 0;
        if (this.text != null) {
            n = this.text.size();
        }
        this.logMessage("set text size: " + n);
    }

    public void setTextColor(Color color) {
        this.textColor = color;
        this.logMessage("setTextColor: " + this.textColor);
    }

    public void setFontName(String string) {
        this.fontName = string;
        this.logMessage("setFontName: " + this.fontName);
    }

    public void setFontSize(int n) {
        this.fontSize = n;
        this.logMessage("setFontSize: " + this.fontSize);
    }

    public void setBottomText(String string) {
        this.bottomText = string;
        this.logMessage("setBottomText: " + this.bottomText);
    }

    public void setTopMargin(int n) {
        this.topMargin = n;
        this.logMessage("setTopMargin: " + this.topMargin);
    }

    public void setBottomMargin(int n) {
        this.bottomMargin = n;
        this.logMessage("setBottomMargin: " + this.bottomMargin);
    }

    public void setLeftMargin(int n) {
        this.leftMargin = n;
        this.logMessage("setLeftMargin: " + this.leftMargin);
    }

    public void setRightMargin(int n) {
        this.rightMargin = n;
        this.logMessage("setRightMargin: " + this.rightMargin);
    }

    public void setCloseLabel(String string) {
        this.closeLabel = string;
        this.logMessage("setCloseLabel: " + this.closeLabel);
    }

    public void setCloseTip(String string) {
        this.closeTip = string;
        this.logMessage("setCloseTip: " + this.closeTip);
    }

    public void setDefaultButton(boolean bl) {
        this.setDefaultButton = bl;
        this.logMessage("setDefaultButton: " + this.setDefaultButton);
    }

    private JPanel getButtonPanel() {
        JPanel jPanel = null;
        if (this.closeLabel != null) {
            Box box = Box.createHorizontalBox();
            String string = "Center";
            box.add(Box.createHorizontalGlue(), string);
            this.closeButton = new JButton(this.closeLabel);
            this.closeButton.setName("CloseButton");
            box.add(this.closeButton);
            this.closeButton.addActionListener(new ButtonAction());
            this.setComponentBackground(this.closeButton);
            if (this.closeTip != null) {
                this.closeButton.setToolTipText(this.closeTip);
            }
            jPanel = new JPanel();
            this.setComponentBackground(jPanel);
            jPanel.add(box);
            if (this.setDefaultButton) {
                this.getRootPane().setDefaultButton(this.closeButton);
                this.closeButton.requestFocusInWindow();
            }
        }
        return jPanel;
    }

    private void setComponentBackground(JComponent jComponent) {
        if (this.backgroundColor != null) {
            jComponent.setBackground(this.backgroundColor);
        }
    }

    private void logMessage(String string) {
        this.startLogging();
        log.write(string);
        this.debug(string);
    }

    private void logException(Exception exception) {
        this.startLogging();
        log.write(exception);
        if (this.debugging) {
            exception.printStackTrace();
        }
    }

    private void startLogging() {
        if (log == null) {
            log = new Log("marquee");
            if (this.debugging) {
                log.setLogging(true);
            }
        }
    }

    private void debug(String string) {
        if (this.debugging) {
            System.out.println(string);
        }
    }

    private class MainTextPanel
    extends JComponent {
        private ImageIcon imageIcon;
        private int maxTextWidth;

        public MainTextPanel() {
            this.maxTextWidth = 0;
            Marquee.this.logMessage("instantiating MainTextPanel");
            this.setup();
        }

        public void paintComponent(Graphics graphics) {
            graphics.setColor(Marquee.this.textColor);
            FontMetrics fontMetrics = graphics.getFontMetrics();
            if (this.imageIcon != null) {
                this.imageIcon.paintIcon(this, graphics, 1, 1);
            }
            if (Marquee.this.bottomText != null) {
                graphics.drawString(Marquee.this.bottomText, (this.getWidth() - fontMetrics.stringWidth(Marquee.this.bottomText)) / 2, this.getHeight() - 5);
            }
            if (Marquee.this.text != null && Marquee.this.text.size() > 0) {
                this.paintText(graphics, fontMetrics);
            }
            Marquee.this.logMessage("painted component");
        }

        public Dimension getPreferredSize() {
            Dimension dimension = null;
            dimension = this.imageIcon == null ? super.getPreferredSize() : new Dimension(1 + this.imageIcon.getIconWidth(), 1 + this.imageIcon.getIconHeight());
            return dimension;
        }

        private void paintText(Graphics graphics, FontMetrics fontMetrics) {
            try {
                int n = this.maxTextWidth + Marquee.this.leftMargin + Marquee.this.rightMargin;
                int n2 = this.getHeight() + Marquee.this.topMargin + Marquee.this.bottomMargin;
                int n3 = (this.getWidth() - n) / 2;
                int n4 = Marquee.this.topMargin;
                Marquee.this.logMessage("text area: x:" + n3 + " y:" + Marquee.this.topMargin + " w:" + n + " h:" + n2);
                Graphics graphics2 = graphics.create(n3, Marquee.this.topMargin, n, n2);
                int n5 = fontMetrics.getHeight();
                int n6 = Math.min(Marquee.this.text.size(), (this.getHeight() - Marquee.this.topMargin - Marquee.this.bottomMargin) / n5);
                int n7 = 0;
                String string = null;
                if (n7 < n6) {
                    string = (String)Marquee.this.text.get(n7);
                    int n8 = (n - (fontMetrics.stringWidth(string) + Marquee.this.leftMargin)) / 2;
                    graphics2.drawString(string, n8, n4);
                    n4+=fontMetrics.getHeight();
                    ++n7;
                }
                while (n7 < n6) {
                    string = (String)Marquee.this.text.get(n7);
                    graphics2.drawString(string, Marquee.this.leftMargin, n4);
                    n4+=fontMetrics.getHeight();
                    ++n7;
                }
                Marquee.this.logMessage("painted " + n7 + " text lines");
            }
            catch (Exception var3_4) {
                Marquee.this.logException(var3_4);
            }
        }

        public void setup() {
            ButtonsIcons buttonsIcons = new ButtonsIcons();
            this.imageIcon = buttonsIcons.getIcon(Marquee.this.backgroundFilename);
            boolean bl = this.imageIcon != null;
            Marquee.this.logMessage("got " + Marquee.this.backgroundFilename + ": " + bl);
            this.setFont(Fonts.Big);
            this.setForeground(Marquee.this.textColor);
            if (Marquee.this.text == null || Marquee.this.text.size() <= 0) {
                Marquee.this.logMessage("no main text to display");
            } else {
                this.calculateMaxWidth();
            }
        }

        private void calculateMaxWidth() {
            FontMetrics fontMetrics = this.getFontMetrics(this.getFont());
            this.maxTextWidth = 0;
            for (String string : Marquee.this.text) {
                this.maxTextWidth = Math.max(this.maxTextWidth, fontMetrics.stringWidth(string));
            }
        }
    }

    private class MainHtmlPanel
    extends JComponent {
        private ImageIcon imageIcon;

        public MainHtmlPanel() {
            Marquee.this.logMessage("instantiating MainHtmlPanel");
            this.setup();
        }

        public void paintComponent(Graphics graphics) {
            graphics.setColor(Marquee.this.textColor);
            FontMetrics fontMetrics = graphics.getFontMetrics();
            if (this.imageIcon != null) {
                this.imageIcon.paintIcon(this, graphics, 1, 1);
            }
            if (Marquee.this.text == null || Marquee.this.text.size() > 0) {
                // empty if block
            }
            Marquee.this.logMessage("painted component");
        }

        public Dimension getPreferredSize() {
            Dimension dimension = null;
            dimension = this.imageIcon == null ? super.getPreferredSize() : new Dimension(1 + this.imageIcon.getIconWidth(), 1 + this.imageIcon.getIconHeight());
            return dimension;
        }

        public void setup() {
            ButtonsIcons buttonsIcons = new ButtonsIcons();
            this.imageIcon = buttonsIcons.getIcon(Marquee.this.backgroundFilename);
            boolean bl = this.imageIcon != null;
            Marquee.this.logMessage("got " + Marquee.this.backgroundFilename + ": " + bl);
        }
    }

    private class ButtonAction
    implements ActionListener {
        private ButtonAction() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == Marquee.this.closeButton) {
                Marquee.this.exit();
                Marquee.this.logMessage("close button clicked");
            }
        }
    }

}
