/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.AutoProgressBar;
import com.denova.ui.Fonts;
import com.denova.ui.GridBagControl;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.MessageListener;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class ProgressPanel
extends WizardPanel
implements MessageListener {
    protected static final Log progressLog = new Log("progress");
    private static final int ProgressBarMinValue = 0;
    private static final int ProgressBarMaxValue = 1000;
    private static final int TimePerTick = 50;
    private static List panelNames = new Vector();
    private static Timer progressTimer = null;
    private static int totalProgressShares = 0;
    private static int usedProgressShares = 0;
    private static int savedProgressBarValue = 0;
    private static String upperStatusText = "";
    private static String lowerStatusText = "";
    private static String progressBarStatusText = "";
    protected JLabel progressBarLabel;
    protected AutoProgressBar progressBar;
    private boolean progressBarStarted = false;
    private ChangeListener progressBarListener = null;
    private Timer autoTimer = null;
    private int panelSeconds = 0;
    private int panelMaxValue = 0;
    private int panelMaxOffset = 0;
    private int startedProgressBarValue = 0;
    private int virtualPercent = 0;
    private boolean entered = false;
    private boolean maximized = false;
    private JPanel progressPanel = null;
    private JPanel progressBarPanel = null;
    private Color foregroundColor = Color.blue;
    private Color backgroundColor = new Color(238, 238, 238);

    public ProgressPanel(PropertyList propertyList) {
        super(propertyList);
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder(12));
        this.progressPanel = this.getProgressPanel();
        this.progressPanel.setName("ProgressPanel");
        this.add(this.progressPanel);
        panelNames.add(this.getName());
        ProgressPanel.log("new status panel " + this.getName());
        ProgressPanel.log("cumlative progress shares: " + (totalProgressShares+=this.getPanelProgressShares()));
    }

    public void gotMessage(Object object, Object object2) {
        if (object == this && object2 instanceof String) {
            String string = (String)object2;
            if (string.equals("enter")) {
                this.enterPanel();
            }
            if (string.equals("leave")) {
                this.leavePanel();
            }
        }
    }

    public void showNextPanel() {
        ProgressPanel.log("entering show next panel");
        this.enterPanel();
        ProgressPanel.log("progressBarStarted: " + this.progressBarStarted);
        if (this.isLastSharedPanel()) {
            ProgressPanel.log("last shared panel");
            this.stopAutoTimer();
            if (this.progressBar.isMaximized() || this.maximized) {
                this.startProgressTimer();
            } else {
                if (this.progressBarListener == null) {
                    ProgressPanel.log("adding last progress bar listener for " + this.getName());
                    this.progressBarListener = new ProgressChangeListener();
                    this.progressBar.addChangeListener(this.progressBarListener);
                }
                this.maximize();
            }
        } else {
            this.updateProgressBar(1000);
            this.superShowNextPanel();
        }
    }

    public synchronized void prepareToEnter() {
        ProgressPanel.log("presetting progress bar: " + savedProgressBarValue);
        this.progressBar.setValueNow(savedProgressBarValue);
        this.startedProgressBarValue = savedProgressBarValue;
        this.updateLabelsNow();
    }

    public void startProgressBar() {
        if (!this.progressBarStarted) {
            this.progressBarStarted = true;
            this.panelSeconds = this.getEstimatedTime();
            ProgressPanel.log("estimated time: " + this.panelSeconds + " seconds");
            this.progressBar.start();
        }
    }

    public void stopProgressBar() {
        this.progressBarStarted = false;
        this.progressBar.stop();
    }

    public void pauseProgressBar() {
    }

    public void incrementProgressBar() {
        this.incrementProgressBar(1);
    }

    public void incrementProgressBar(int n) {
        this.virtualPercent+=n;
        if (this.virtualPercent > 1000) {
            this.virtualPercent = 1000;
        }
        this.updateProgressBar(this.virtualPercent);
    }

    public void updateProgressBar(int n) {
        this.virtualPercent = n;
        int n2 = this.progressBar.getValue();
        if (n2 < this.panelMaxValue) {
            double d = (double)n / 100.0;
            double d2 = (double)this.panelMaxOffset * d;
            int n3 = this.getPanelMinValue() + (int)d2;
            if (n3 > this.panelMaxValue) {
                n3 = this.panelMaxValue;
            }
            ProgressPanel.log(this.getName() + " changed progress bar to" + " percent: " + n + "%" + "/scaled: " + (int)d2 + "/value: " + n3);
            this.progressBar.setValue(n3);
        } else {
            this.stopAutoTimer();
        }
    }

    public void maximize() {
        this.stopAutoTimer();
        this.progressBar.maximize();
        this.maximized = true;
        ProgressPanel.log("maximizing progress bar for " + this.getName());
    }

    public void updateProgressBarLabel(String string) {
        if (this.isNewStatusText(string, progressBarStatusText)) {
            ProgressPanel.log("updating progressBarLabel: " + progressBarStatusText);
            ProgressPanel.log("                     with: " + string);
            progressBarStatusText = string;
            this.updateLabelsNow();
        }
    }

    public void setEnabledNamedPanel(String string, boolean bl) {
        super.setEnabledNamedPanel(string, bl);
        panelNames.remove(string);
    }

    public boolean isCancelButtonEnabled() {
        return false;
    }

    public boolean isNextButtonEnabled() {
        return false;
    }

    public boolean isPreviousButtonEnabled() {
        return false;
    }

    public int getPanelProgressShares() {
        return 1;
    }

    public int getEstimatedTime() {
        return 0;
    }

    public void setIndeterminate(boolean bl) {
        this.progressBar.setIndeterminate(bl);
    }

    public void reset() {
        this.stopTimerAndListeners();
        this.stopProgressBar();
        this.entered = false;
        this.progressBarStarted = false;
        this.panelSeconds = 0;
        this.virtualPercent = 0;
        savedProgressBarValue = this.startedProgressBarValue;
        if ((usedProgressShares-=this.getPanelProgressShares()) < 0) {
            usedProgressShares = 0;
        }
        ProgressPanel.log("reset panel");
    }

    public void setBackgroundColor(Color color) {
        this.backgroundColor = color;
        if (this.backgroundColor != null) {
            ProgressPanel.log("set background color: " + this.backgroundColor.toString());
            if (this.progressBar != null) {
                this.progressBar.setBackground(this.backgroundColor);
                ProgressPanel.log("set progress bar background color");
            }
        }
    }

    public void setForegroundColor(Color color) {
        this.foregroundColor = color;
        if (this.foregroundColor != null) {
            ProgressPanel.log("set foreground color: " + this.foregroundColor.toString());
            if (this.progressBar != null) {
                this.progressBar.setForeground(this.foregroundColor);
                ProgressPanel.log("set progress bar foreground color");
            }
        }
    }

    protected JPanel getProgressPanel() {
        JPanel jPanel = new JPanel();
        GridBagControl gridBagControl = new GridBagControl(jPanel);
        gridBagControl.addVerticalSpace();
        this.progressBarPanel = this.getProgressBarPanel();
        this.progressBarPanel.setName("ProgressBar");
        GridBagConstraints gridBagConstraints = GridBagControl.fillHorizontalConstraints(GridBagControl.getDefaultConstraints());
        gridBagControl.add(gridBagConstraints, this.progressBarPanel);
        gridBagControl.endRow();
        gridBagControl.addVerticalSpace();
        return jPanel;
    }

    protected JPanel getProgressBarPanel() {
        JPanel jPanel = new JPanel();
        GridBagControl gridBagControl = new GridBagControl(jPanel);
        GridBagConstraints gridBagConstraints = GridBagControl.fillHorizontalConstraints(GridBagControl.getDefaultConstraints());
        this.progressBar = new AutoProgressBar();
        this.progressBar.setName(this.getName());
        this.progressBar.setMinimum(0);
        this.progressBar.setMaximum(1000);
        this.progressBar.setValueNow(savedProgressBarValue);
        this.progressBar.setForeground(this.foregroundColor);
        this.progressBar.setBackground(this.backgroundColor);
        gridBagControl.add(gridBagConstraints, this.progressBar);
        gridBagControl.endRow();
        this.progressBarLabel = new JLabel("                                        ");
        Fonts.setFont(this.progressBarLabel, Fonts.Small);
        gridBagControl.add(gridBagConstraints, this.progressBarLabel);
        gridBagControl.endRow();
        return jPanel;
    }

    private static void log(String string) {
        progressLog.write(string);
    }

    private void enterPanel() {
        if (!this.entered) {
            ProgressPanel.log("entering panel " + this.getName());
            this.entered = true;
            if (totalProgressShares <= 0) {
                totalProgressShares = 1;
            }
            this.startProgressBar();
            this.updateLabelsNow();
            ProgressPanel.log("panel index of " + this.getName() + " is " + this.getProgressPanelIndex());
            ProgressPanel.log("panel's progress bar share: " + this.getPanelProgressShares());
            ProgressPanel.log("usedProgressShares: " + usedProgressShares);
            ProgressPanel.log("savedProgressBarValue: " + savedProgressBarValue);
            ProgressPanel.log("panel min value: " + this.getPanelMinValue());
            this.panelMaxOffset = (int)(1000.0 / (double)totalProgressShares * (double)this.getPanelProgressShares());
            ProgressPanel.log("panel max offset =: " + this.panelMaxOffset);
            this.virtualPercent = 0;
            this.panelMaxValue = this.isLastSharedPanel() ? 1000 : this.getPanelMinValue() + this.panelMaxOffset;
            ProgressPanel.log("panel max value: " + this.panelMaxValue);
            if (this.panelSeconds > 0) {
                this.startAutoTimer();
            }
        }
    }

    private void leavePanel() {
        ProgressPanel.log("leaving panel " + this.getName());
        if (this.entered) {
            ProgressPanel.log("used progress bar shares: " + (usedProgressShares+=this.getPanelProgressShares()));
        }
        this.entered = false;
        this.stopTimerAndListeners();
        this.stopProgressBar();
        savedProgressBarValue = this.progressBar.getValue();
        ProgressPanel.log("saving progress bar end value for " + this.getName() + ": " + savedProgressBarValue);
    }

    private void startProgressTimer() {
        if (progressTimer == null) {
            ProgressPanel.log("waiting for progress bar to maximize");
            int n = 1000;
            progressTimer = new Timer();
            progressTimer.schedule((TimerTask)new ProgressTimer(), n);
        }
    }

    private void startAutoTimer() {
        if (this.autoTimer == null) {
            ProgressPanel.log("starting auto progress bar timer");
            this.autoTimer = new Timer();
            this.autoTimer.schedule((TimerTask)new AutoTimer(this.panelSeconds), 50, 50);
        }
    }

    private void stopAutoTimer() {
        if (this.autoTimer != null) {
            ProgressPanel.log("cancelling auto timer");
            this.autoTimer.cancel();
            this.autoTimer = null;
        }
    }

    private void stopTimerAndListeners() {
        if (this.progressBarListener != null) {
            ProgressPanel.log("removing progress bar listener");
            this.progressBar.removeChangeListener(this.progressBarListener);
            this.progressBarListener = null;
        }
        this.stopAutoTimer();
    }

    private void superShowNextPanel() {
        this.stopTimerAndListeners();
        ProgressPanel.log("showing next panel after " + this.getName());
        super.showNextPanel();
    }

    private int getPanelMinValue() {
        if (totalProgressShares <= 0) {
            totalProgressShares = 1;
        }
        int n = 1000 / totalProgressShares * usedProgressShares;
        return n;
    }

    private boolean isFirstSharedPanel() {
        return this.getProgressPanelIndex() <= 0;
    }

    private boolean isLastSharedPanel() {
        return this.getProgressPanelIndex() >= panelNames.size() - 1;
    }

    private int getProgressPanelIndex() {
        return panelNames.indexOf(this.getName());
    }

    private boolean isNewStatusText(String string, String string2) {
        return string != null && string.trim().length() > 0 && !string.equals(string2);
    }

    private synchronized void updateLabelsNow() {
        String string = progressBarStatusText;
        synchronized (string) {
            if (this.isNewStatusText(progressBarStatusText, this.progressBarLabel.getText())) {
                ProgressPanel.log("changing progressBarLabel from: " + this.progressBarLabel.getText());
                ProgressPanel.log("                            to: " + progressBarStatusText);
                UiLayoutUtilities.update((Component)this.progressBarLabel, (Object)progressBarStatusText);
            }
        }
    }

    private class ProgressChangeListener
    implements ChangeListener {
        private ProgressChangeListener() {
        }

        public void stateChanged(ChangeEvent changeEvent) {
            AutoProgressBar autoProgressBar = (AutoProgressBar)changeEvent.getSource();
            if (ProgressPanel.this.isLastSharedPanel()) {
                if (autoProgressBar.isMaximized() && progressTimer == null) {
                    ProgressPanel.log("progress bar maximized");
                    ProgressPanel.this.startProgressTimer();
                }
            } else {
                int n = autoProgressBar.getValue();
                if (n < ProgressPanel.this.panelMaxValue) {
                    ProgressPanel.log("progress bar value: " + n);
                    ProgressPanel.this.updateProgressBar(1000);
                }
                ProgressPanel.this.superShowNextPanel();
            }
        }
    }

    private class ProgressTimer
    extends TimerTask {
        private ProgressTimer() {
        }

        public synchronized void run() {
            ProgressPanel.this.superShowNextPanel();
        }
    }

    private class AutoTimer
    extends TimerTask {
        int ticksPerPercent;
        int percentPerTick;
        int ticks;

        public AutoTimer(int n) {
            this.ticks = 0;
            this.debug("secondsForPanel: " + n);
            this.debug("timePerTick: 50");
            double d = n * 1000 / 50;
            this.debug("total ticks: " + d);
            if (d > 1000.0) {
                this.ticksPerPercent = (int)(d / 1000.0);
                this.debug("ticks per percent %: " + this.ticksPerPercent);
                this.percentPerTick = 0;
            } else {
                this.percentPerTick = (int)(1000.0 / d);
                this.debug("percent per tick %: " + this.percentPerTick);
                this.ticksPerPercent = 0;
            }
        }

        public synchronized void run() {
            ++this.ticks;
            this.debug("ticks : " + this.ticks);
            if (this.percentPerTick > 0) {
                ProgressPanel.this.incrementProgressBar(this.percentPerTick);
            } else if (this.ticks % this.ticksPerPercent == 0) {
                ProgressPanel.this.incrementProgressBar(1);
            }
        }

        private void debug(String string) {
            ProgressPanel.log(ProgressPanel.this.getName() + " auto timer " + string);
        }
    }

}
