/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

public class RepackWindow
implements Runnable {
    private static boolean repacking = false;
    private JFrame frame = null;
    private Log log = null;
    private boolean debugging = false;
    private static final String LogFilename = "repack";

    public RepackWindow(JFrame jFrame) {
        this.frame = jFrame;
    }

    public void run() {
        this.repackNow();
    }

    public void repack() {
        this.scheduleRepack();
    }

    private void scheduleRepack() {
        try {
            if (SwingUtilities.isEventDispatchThread()) {
                this.repackNow();
            } else {
                SwingUtilities.invokeLater(this);
                this.log("repacking window later");
            }
        }
        catch (Exception var1_1) {
            this.log(var1_1);
        }
    }

    private void repackNow() {
        RepackWindowNow repackWindowNow = new RepackWindowNow();
        repackWindowNow.start();
    }

    private void log(String string) {
        this.startLogging();
        this.log.write(string);
    }

    private void log(Exception exception) {
        this.startLogging();
        this.log.write(exception);
    }

    private void startLogging() {
        if (this.log == null) {
            this.log = new Log("repack");
            if (this.debugging) {
                this.log.setLogging(true);
            }
        }
    }

    private class RepackWindowNow
    extends Thread {
        private RepackWindowNow() {
        }

        public synchronized void run() {
            if (!repacking) {
                repacking = true;
                RepackWindow.this.log("repacking window");
                RepackWindow.this.frame.pack();
                RepackWindow.this.log("window repacked");
                repacking = false;
            }
        }
    }

}
