/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.SwingCheckerThread;
import java.awt.Component;
import java.awt.Container;
import java.awt.Rectangle;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import javax.swing.JComponent;
import javax.swing.RepaintManager;
import javax.swing.SwingUtilities;

protected class SwingCheckerThread.Checker
extends RepaintManager {
    private PropertyChangeSupport propertyChanger;
    private int tabCount;

    public SwingCheckerThread.Checker() {
        this.tabCount = 0;
        this.propertyChanger = new PropertyChangeSupport(this);
    }

    public synchronized void addInvalidComponent(JComponent jComponent) {
        this.checkThread(jComponent);
        super.addInvalidComponent(jComponent);
    }

    public synchronized void addDirtyRegion(JComponent jComponent, int n, int n2, int n3, int n4) {
        this.checkThread(jComponent);
        PropertyChangeEvent propertyChangeEvent = new PropertyChangeEvent(jComponent, SwingCheckerThread.AddDirtyRegionProperty, null, new Rectangle(n, n2, n3, n4));
        this.propertyChanger.firePropertyChange(propertyChangeEvent);
        super.addDirtyRegion(jComponent, n, n2, n3, n4);
    }

    public void addListener(PropertyChangeListener propertyChangeListener) {
        this.propertyChanger.addPropertyChangeListener(propertyChangeListener);
    }

    private void checkThread(JComponent jComponent) {
        if (SwingUtilities.isEventDispatchThread()) {
            if (LogCorrectThread) {
                this.logStackTrace("Called correctly in EDT. This is informational only. NOT AN ERROR.");
            }
        } else {
            this.logStackTrace("Must be called from Swing/AWT Event Dispatch Thread");
        }
    }

    private String getStacktraceAsString(Throwable throwable) {
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        PrintStream printStream = new PrintStream(byteArrayOutputStream);
        throwable.printStackTrace(printStream);
        printStream.flush();
        return byteArrayOutputStream.toString();
    }

    private void dumpComponentTree(Component component) {
        log.write("----------Component Tree");
        this.resetTabCount();
        while (component != null) {
            log.write(this.getTabIndent() + component.toString());
            log.write(this.getTabIndent() + "Showing:" + component.isShowing() + " Visible: " + component.isVisible());
            this.incrementTabCount();
            component = component.getParent();
        }
    }

    private void resetTabCount() {
        this.tabCount = 1;
    }

    private void incrementTabCount() {
        ++this.tabCount;
    }

    private String getTabIndent() {
        StringBuffer stringBuffer = new StringBuffer();
        for (int i = 0; i < this.tabCount; ++i) {
            stringBuffer.append("\t");
        }
        return stringBuffer.toString();
    }

    void logStackTrace(String string) {
        Exception exception = new Exception(string);
        String string2 = this.getStacktraceAsString(exception);
        log.write(string2);
    }
}
