/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import java.awt.Component;
import java.awt.Container;
import java.awt.Rectangle;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import javax.swing.JComponent;
import javax.swing.RepaintManager;
import javax.swing.SwingUtilities;

public class SwingCheckerThread
extends Thread {
    public static String SwingCheckerThreadName;
    public static String SwingCheckerThreadLogName;
    public static String AddDirtyRegionProperty;
    private static Log log;
    private static boolean enabled;
    private static boolean LogCorrectThread;

    public SwingCheckerThread() {
        this.startChecker();
    }

    public SwingCheckerThread(Runnable runnable) {
        super(runnable);
        this.startChecker();
    }

    public static synchronized void startChecking() {
        if (enabled) {
            new SwingCheckerThread().startChecker();
        }
    }

    public static boolean isEnabled() {
        return enabled;
    }

    public static void setEnabled(boolean bl) {
        if (bl) {
            if (!log.logFileExists()) {
                log.startLogging();
            }
        } else {
            log.stopLogging();
        }
        enabled = bl;
    }

    public static Log getLog() {
        return log;
    }

    protected synchronized void startChecker() {
        if (enabled) {
            RepaintManager.setCurrentManager(new Checker());
        }
    }

    static {
        SwingCheckerThreadLogName = SwingCheckerThread.SwingCheckerThreadName = "swingcheckerthread";
        AddDirtyRegionProperty = SwingCheckerThreadName + ": add dirty region";
        log = new Log(SwingCheckerThreadLogName);
        enabled = log.logFileExists();
        LogCorrectThread = true;
    }

    protected class Checker
    extends RepaintManager {
        private PropertyChangeSupport propertyChanger;
        private int tabCount;

        public Checker() {
            this.tabCount = 0;
            this.propertyChanger = new PropertyChangeSupport(this);
        }

        public synchronized void addInvalidComponent(JComponent jComponent) {
            this.checkThread(jComponent);
            super.addInvalidComponent(jComponent);
        }

        public synchronized void addDirtyRegion(JComponent jComponent, int n, int n2, int n3, int n4) {
            this.checkThread(jComponent);
            PropertyChangeEvent propertyChangeEvent = new PropertyChangeEvent(jComponent, SwingCheckerThread.AddDirtyRegionProperty, null, new Rectangle(n, n2, n3, n4));
            this.propertyChanger.firePropertyChange(propertyChangeEvent);
            super.addDirtyRegion(jComponent, n, n2, n3, n4);
        }

        public void addListener(PropertyChangeListener propertyChangeListener) {
            this.propertyChanger.addPropertyChangeListener(propertyChangeListener);
        }

        private void checkThread(JComponent jComponent) {
            if (SwingUtilities.isEventDispatchThread()) {
                if (LogCorrectThread) {
                    this.logStackTrace("Called correctly in EDT. This is informational only. NOT AN ERROR.");
                }
            } else {
                this.logStackTrace("Must be called from Swing/AWT Event Dispatch Thread");
            }
        }

        private String getStacktraceAsString(Throwable throwable) {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            PrintStream printStream = new PrintStream(byteArrayOutputStream);
            throwable.printStackTrace(printStream);
            printStream.flush();
            return byteArrayOutputStream.toString();
        }

        private void dumpComponentTree(Component component) {
            log.write("----------Component Tree");
            this.resetTabCount();
            while (component != null) {
                log.write(this.getTabIndent() + component.toString());
                log.write(this.getTabIndent() + "Showing:" + component.isShowing() + " Visible: " + component.isVisible());
                this.incrementTabCount();
                component = component.getParent();
            }
        }

        private void resetTabCount() {
            this.tabCount = 1;
        }

        private void incrementTabCount() {
            ++this.tabCount;
        }

        private String getTabIndent() {
            StringBuffer stringBuffer = new StringBuffer();
            for (int i = 0; i < this.tabCount; ++i) {
                stringBuffer.append("\t");
            }
            return stringBuffer.toString();
        }

        void logStackTrace(String string) {
            Exception exception = new Exception(string);
            String string2 = this.getStacktraceAsString(exception);
            log.write(string2);
        }
    }

}
