/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.ErrorLog;
import com.denova.ui.LookAndFeel;
import com.denova.ui.UiLayoutFrame;
import com.denova.ui.UiLayoutRedraw;
import com.denova.ui.UpdateComponent;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.LayoutManager;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.io.PrintStream;
import javax.swing.ComboBoxEditor;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;
import javax.swing.border.AbstractBorder;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.JTextComponent;
import org.jdesktop.swingx.plaf.nimbus.RoundedBorder;

public class UiLayoutUtilities {
    static final int InitialDefaultMargin = 12;
    static int defaultMargin = 12;
    private static boolean debugging = false;

    public static boolean setLookAndFeel() {
        return LookAndFeel.set();
    }

    public static void setColors(Container container, Color color, Color color2) {
        if (color != null && color2 != null) {
            try {
                if (container instanceof JLabel || container instanceof JButton || container instanceof JComboBox || container instanceof JCheckBox || container instanceof JRadioButton || container instanceof JList) {
                    container.setForeground(color);
                }
                if (!(container instanceof JTextField)) {
                    if (!(container instanceof JEditorPane)) {
                        container.setBackground(color2);
                    }
                }
                for (int i = 0; i < container.getComponentCount(); ++i) {
                    Component component = container.getComponent(i);
                    UiLayoutUtilities.setColors((Container)component, color, color2);
                }
            }
            catch (Exception var3_4) {
                UiLayoutUtilities.debug(var3_4.getMessage());
            }
        } else if (color != null) {
            UiLayoutUtilities.setTextColor(container, color);
        } else if (color2 != null) {
            UiLayoutUtilities.setBackgroundColor(container, color2);
        }
    }

    public static void setBackgroundColor(Component component, Color color) {
        if (color != null) {
            try {
                if (component.isEnabled()) {
                    component.setBackground(color);
                }
                if (component instanceof Container) {
                    Container container = (Container)component;
                    for (int i = 0; i < container.getComponentCount(); ++i) {
                        Component component2 = container.getComponent(i);
                        UiLayoutUtilities.setBackgroundColor((Container)component2, color);
                    }
                }
            }
            catch (Exception var2_3) {
                UiLayoutUtilities.debug(var2_3.getMessage());
            }
        }
    }

    public static void setTextColor(Container container, Color color) {
        if (color != null) {
            try {
                if (container instanceof JLabel || container instanceof JEditorPane || container instanceof JButton) {
                    container.setForeground(color);
                }
                Component[] arrcomponent = container.getComponents();
                for (int i = 0; i < arrcomponent.length; ++i) {
                    Component component = container.getComponent(i);
                    UiLayoutUtilities.setTextColor((Container)component, color);
                }
            }
            catch (Exception var2_3) {
                UiLayoutUtilities.debug(var2_3.getMessage());
            }
        }
    }

    public static void setOpaque(Container container, boolean bl) {
        try {
            Object object;
            if (!(container instanceof JLabel || container instanceof JTextField || container instanceof JEditorPane || container instanceof JButton || container instanceof JComboBox || container instanceof JCheckBox || container instanceof JRadioButton)) {
                if (!(container instanceof JList)) {
                    object = (JComponent)container;
                    object.setOpaque(bl);
                }
            }
            object = container.getComponents();
            for (int i = 0; i < object.length; ++i) {
                Container container2 = (Container)object[i];
                if (container2.getComponentCount() <= 0) continue;
                UiLayoutUtilities.setOpaque(container2, bl);
            }
        }
        catch (Exception var2_3) {
            UiLayoutUtilities.debug(var2_3.getMessage());
        }
    }

    public static void update(Component component, int n) {
        UiLayoutUtilities.update((Object)component, (Object)new Integer(n));
    }

    public static void update(Object object, int n) {
        UiLayoutUtilities.update(object, (Object)new Integer(n));
    }

    public static void update(Component component, boolean bl) {
        UiLayoutUtilities.update((Object)component, (Object)bl);
    }

    public static void update(Object object, boolean bl) {
        UiLayoutUtilities.update(object, (Object)bl);
    }

    public static void update(Component component, Object object) {
        UiLayoutUtilities.update((Object)component, object);
    }

    public static void update(Object object, Object object2) {
        new UpdateComponent(object, object2);
    }

    public static void adjustBounds(Container container) {
        try {
            String string = System.getProperty("java.version");
            if (string.compareTo("1.4") >= 0) {
                GraphicsEnvironment graphicsEnvironment = GraphicsEnvironment.getLocalGraphicsEnvironment();
                Rectangle rectangle = graphicsEnvironment.getMaximumWindowBounds();
                Rectangle rectangle2 = UiLayoutUtilities.getComponentBounds(container, rectangle);
                container.setBounds(rectangle2);
                if (container instanceof JFrame) {
                    JFrame jFrame = (JFrame)container;
                    if (rectangle2.width == rectangle.width && rectangle2.height == rectangle.height) {
                        jFrame.setExtendedState(6);
                    }
                }
                container.validate();
            }
        }
        catch (Exception var1_2) {
        }
        catch (NoSuchMethodError var1_3) {
            // empty catch block
        }
    }

    public static void setFocus(final Object object) {
        SwingUtilities.invokeLater(new Runnable(){

            public void run() {
                this.setFieldFocus(object);
            }

            private void setFieldFocus(Object object2) {
                if (object2 instanceof JComboBox) {
                    JComboBox jComboBox = (JComboBox)object2;
                    ComboBoxEditor comboBoxEditor = jComboBox.getEditor();
                    JTextComponent jTextComponent = (JTextComponent)comboBoxEditor.getEditorComponent();
                    int n = this.getEndPosition((String)comboBoxEditor.getItem());
                    jTextComponent.requestFocusInWindow();
                    jTextComponent.setCaretPosition(n);
                } else if (object2 instanceof JTextField) {
                    JTextField jTextField = (JTextField)object2;
                    int n = this.getEndPosition(jTextField.getText());
                    jTextField.requestFocusInWindow();
                    jTextField.setCaretPosition(n);
                } else if (object2 instanceof JButton) {
                    JButton jButton = (JButton)object2;
                    jButton.requestFocusInWindow();
                }
            }

            private int getEndPosition(String string) {
                int n = 0;
                if (string != null) {
                    n = string.length();
                }
                return n;
            }
        });
    }

    public static JPanel wrapInJPanel(Component component) {
        JPanel jPanel = new JPanel();
        jPanel.setLayout(new BorderLayout());
        jPanel.add(component, "Center");
        return jPanel;
    }

    public static JPanel centerLabel(JLabel jLabel) {
        JPanel jPanel = new JPanel();
        jPanel.setLayout(new GridLayout(1, 1));
        jPanel.add(jLabel);
        return jPanel;
    }

    public static JFrame findJFrameParent(Container container) {
        Container container2;
        for (container2 = container; !(container2 == null || container2 instanceof JFrame); container2 = container2.getParent()) {
        }
        return (JFrame)container2;
    }

    public static JFrame forceJFrameParent(Container container) {
        Container container2 = container;
        if ((container2 = UiLayoutUtilities.findJFrameParent(container2)) == null) {
            UiLayoutFrame uiLayoutFrame = new UiLayoutFrame();
            container2 = uiLayoutFrame.getJFrame();
        }
        return (JFrame)container2;
    }

    public static Container findContainerParent(Container container) {
        Container container2 = container;
        Container container3 = container2.getParent();
        while (container3 != null && container3 instanceof Container) {
            container2 = container2.getParent();
            container3 = container2.getParent();
        }
        return container2;
    }

    public static JPanel addBorder(Component component, Border border) {
        JPanel jPanel = UiLayoutUtilities.wrapInJPanel(component);
        jPanel.setBorder(border);
        return jPanel;
    }

    public static JPanel addBevel(Component component, int n) {
        return UiLayoutUtilities.addBorder(component, new BevelBorder(n));
    }

    public static JPanel addBeveledBorder(Component component) {
        BevelBorder bevelBorder = new BevelBorder(1);
        EmptyBorder emptyBorder = new EmptyBorder(12, 12, 12, 12);
        JPanel jPanel = new JPanel(new GridLayout(1, 1));
        jPanel.setBorder(emptyBorder);
        JPanel jPanel2 = new JPanel(new GridLayout(1, 1));
        jPanel2.setBorder(bevelBorder);
        JPanel jPanel3 = new JPanel(new GridLayout(1, 1));
        jPanel3.setBorder(emptyBorder);
        jPanel3.add(component);
        jPanel2.add(jPanel3);
        jPanel.add(jPanel2);
        return jPanel;
    }

    public static JPanel addDoubleBevel(Component component, int n) {
        JPanel jPanel = UiLayoutUtilities.addBorder(component, new BevelBorder(n));
        return UiLayoutUtilities.addBorder(jPanel, new BevelBorder(n));
    }

    public static JPanel addTitledBorder(Component component, String string, int n) {
        AbstractBorder abstractBorder = new BevelBorder(1);
        AbstractBorder abstractBorder2 = string != null ? new TitledBorder(abstractBorder, string, n, 2) : abstractBorder;
        JPanel jPanel = new JPanel(new GridLayout(1, 1));
        jPanel.setName(string + "Border");
        jPanel.setBorder(abstractBorder2);
        jPanel.add(component);
        return jPanel;
    }

    public static JPanel addRoundedCorners(Component component) {
        JPanel jPanel = UiLayoutUtilities.wrapInJPanel(component);
        if (!LookAndFeel.getActiveLookAndFeel().equals("Synth")) {
            jPanel.setBorder(new RoundedBorder());
        }
        jPanel.setOpaque(false);
        return jPanel;
    }

    public static JPanel addMargin(Component component) {
        return UiLayoutUtilities.addBorder(component, UiLayoutUtilities.getMarginBorder());
    }

    public static int getDefaultMargin() {
        return defaultMargin;
    }

    public static void setDefaultMargin(int n) {
        defaultMargin = n;
    }

    public static Border getMarginBorder() {
        return UiLayoutUtilities.getMarginBorder(defaultMargin);
    }

    public static Border getMarginBorder(int n) {
        return new EmptyBorder(n, n, n, n);
    }

    public static void paintNow(JComponent jComponent) {
        jComponent.paintImmediately(jComponent.getVisibleRect());
        if (jComponent.isVisible()) {
            UiLayoutUtilities.forceRepaint(jComponent);
        }
    }

    public static void forceRepaint(Component component) {
        boolean bl = component.isEnabled();
        boolean bl2 = component.isVisible();
        component.setVisible(false);
        component.setEnabled(false);
        if (bl2) {
            component.setVisible(true);
        }
        if (bl) {
            component.setEnabled(true);
        }
    }

    public static void redraw(Component component) {
        new UiLayoutRedraw(component);
    }

    public static void pack(JFrame jFrame) {
        jFrame.pack();
        try {
            UiLayoutUtilities.adjustBounds(jFrame);
        }
        catch (Exception var1_1) {
            ErrorLog.getLog().write(var1_1, "unable to adjust bounds");
        }
        jFrame.pack();
    }

    public static void pack(JWindow jWindow) {
        jWindow.pack();
        try {
            UiLayoutUtilities.adjustBounds(jWindow);
        }
        catch (Exception var1_1) {
            ErrorLog.getLog().write(var1_1, "unable to adjust bounds");
        }
        jWindow.pack();
    }

    public static void centerOnScreen(Container container) {
        try {
            Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
            UiLayoutUtilities.debug("screenSize: (" + dimension.width + ", " + dimension.height + ")");
            Rectangle rectangle = container.getBounds();
            if (rectangle != null) {
                UiLayoutUtilities.debug("bounds: (" + rectangle.width + ", " + rectangle.height + ")");
                int n = (dimension.width - rectangle.width) / 2;
                int n2 = (dimension.height - rectangle.height) / 2;
                UiLayoutUtilities.debug("location: (" + n + ", " + n2 + ")");
                container.setLocation(n, n2);
                UiLayoutUtilities.repaintAll(container);
            }
        }
        catch (Exception var1_2) {
            UiLayoutUtilities.debug(var1_2);
        }
    }

    public static void centerComponent(Component component) {
        try {
            if (component instanceof Container) {
                UiLayoutUtilities.centerOnScreen((Container)component);
            } else {
                Rectangle rectangle = UiLayoutUtilities.getParentBounds(component);
                Rectangle rectangle2 = component.getBounds();
                component.setLocation(rectangle.x + (rectangle.width - rectangle2.width) / 2, rectangle.y + (rectangle.height - rectangle2.height) / 2);
                UiLayoutUtilities.repaintAll(component);
            }
        }
        catch (Exception var1_2) {
            UiLayoutUtilities.debug(var1_2);
        }
    }

    public static Rectangle getParentBounds(Component component) {
        Rectangle rectangle = null;
        try {
            if (component.getParent() != null) {
                rectangle = component.getParent().bounds();
            }
            if (rectangle == null) {
                rectangle = new Rectangle(Toolkit.getDefaultToolkit().getScreenSize());
            }
        }
        catch (Exception var2_2) {
            UiLayoutUtilities.debug(var2_2);
        }
        return rectangle;
    }

    private static void repaintAll(Component component) {
        if (component.isVisible()) {
            component.paintAll(component.getGraphics());
            UiLayoutUtilities.forceRepaint(component);
        }
    }

    private static Rectangle getComponentBounds(Component component, Rectangle rectangle) {
        Rectangle rectangle2 = component.getBounds();
        if (rectangle2.x < 0) {
            rectangle2.x = 0;
        }
        if (rectangle2.y < 0) {
            rectangle2.y = 0;
        }
        if (rectangle2.width >= rectangle.width) {
            rectangle2.width = rectangle.width;
        }
        if (rectangle2.height >= rectangle.height) {
            rectangle2.height = rectangle.height;
        }
        if (rectangle2.x + rectangle2.width > rectangle.width) {
            rectangle2.x = rectangle.width - rectangle2.width;
        }
        if (rectangle2.y + rectangle2.height > rectangle.height) {
            rectangle2.y = rectangle.height - rectangle2.height;
        }
        return rectangle2;
    }

    private static void debug(String string) {
        if (debugging) {
            System.out.println(string);
        }
    }

    private static void debug(Throwable throwable) {
        if (debugging) {
            throwable.printStackTrace();
        }
    }

}
