/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.ui.UiPopups;
import com.denova.ui.Wizard;
import com.denova.util.MessageListener;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.LayoutManager;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class WizardPanel
extends JPanel
implements MessageListener {
    public static final Integer NoDefault = new Integer(0);
    public static final Integer PreviousButton = new Integer(1);
    public static final Integer NextButton = new Integer(2);
    public static final Integer CancelButton = new Integer(3);
    private static final Log log = new Log("wizardpanel");
    private PropertyList properties;
    private Wizard wizard;
    private boolean enabled = true;
    private Integer defaultWizardButton = NoDefault;
    private boolean nextButtonEnabled = true;
    private boolean previousButtonEnabled = true;
    private boolean cancelButtonEnabled = true;

    public WizardPanel(PropertyList propertyList) {
        this();
        this.properties = propertyList;
    }

    public WizardPanel(PropertyList propertyList, Log log) {
        this(propertyList);
    }

    public WizardPanel(JPanel jPanel, PropertyList propertyList) {
        this(propertyList);
        this.setLayout(new BorderLayout());
        this.add(jPanel);
    }

    public WizardPanel(JPanel jPanel, PropertyList propertyList, Log log) {
        this(jPanel, propertyList);
    }

    public WizardPanel() {
    }

    public synchronized void setActive(boolean bl) {
    }

    public synchronized void prepareToEnter() {
    }

    public synchronized void enter() {
        this.setActive(true);
    }

    public synchronized void leave() {
        this.setActive(false);
    }

    public void setPropertyList(PropertyList propertyList) {
        this.properties = propertyList;
    }

    public void setEnabled(boolean bl) {
        this.enabled = bl;
    }

    public void setEnabledNamedPanel(String string, boolean bl) {
        this.wizard.setEnabledNamedPanel(string, bl);
    }

    public void setWizard(Wizard wizard) {
        this.wizard = wizard;
        this.wizard.addListener(this);
    }

    public PropertyList getPropertyList() {
        return this.properties;
    }

    public JButton wizardGetDefaultButton() {
        JButton jButton = PreviousButton == this.defaultWizardButton ? this.wizard.getPreviousButton() : (NextButton == this.defaultWizardButton ? this.wizard.getNextButton() : (CancelButton == this.defaultWizardButton ? this.wizard.getCancelButton() : null));
        return jButton;
    }

    public Integer getDefaultButton() {
        return this.defaultWizardButton;
    }

    public void setDefaultButton(Integer n) {
        this.defaultWizardButton = n == PreviousButton || n == NextButton || n == CancelButton ? n : NoDefault;
        this.updateWizardButtons();
    }

    public boolean getPreviousButtonExists() {
        return true;
    }

    public boolean getNextButtonExists() {
        return true;
    }

    public String getPreviousButtonLabel() {
        return null;
    }

    public String getNextButtonLabel() {
        return null;
    }

    public String getCancelButtonLabel() {
        return null;
    }

    public String getPreviousButtonIconName() {
        return null;
    }

    public String getNextButtonIconName() {
        return null;
    }

    public String getCancelButtonIconName() {
        return null;
    }

    public String getDefaultPreviousButtonIconName() {
        return this.wizard.getDefaultPreviousButtonIconName();
    }

    public String getDefaultNextButtonIconName() {
        return this.wizard.getDefaultNextButtonIconName();
    }

    public String getDefaultCancelButtonIconName() {
        return this.wizard.getDefaultCancelButtonIconName();
    }

    public String getDefaultFinishedButtonIconName() {
        return this.wizard.getDefaultFinishedButtonIconName();
    }

    public void setDefaultFinishedButtonIconName(String string) {
        this.wizard.setDefaultFinishedButtonIconName(string);
    }

    public String getDefaultInstallButtonIconName() {
        return this.wizard.getDefaultInstallButtonIconName();
    }

    public boolean isOk() {
        return true;
    }

    public String getName() {
        return this.getClass().getName();
    }

    public String getTitle() {
        return null;
    }

    public final JButton getNextButton() {
        return this.wizard.getNextButton();
    }

    public final JButton getPreviousButton() {
        return this.wizard.getPreviousButton();
    }

    public final JButton getCancelButton() {
        return this.wizard.getCancelButton();
    }

    public boolean isNextButtonEnabled() {
        return this.nextButtonEnabled;
    }

    public void setNextButtonEnabled(boolean bl) {
        this.nextButtonEnabled = bl;
        this.updateWizardButtons();
    }

    public boolean isPreviousButtonEnabled() {
        return this.previousButtonEnabled;
    }

    public void setPreviousButtonEnabled(boolean bl) {
        this.previousButtonEnabled = bl;
        this.updateWizardButtons();
    }

    public boolean isCancelButtonEnabled() {
        return this.cancelButtonEnabled;
    }

    public void setCancelButtonEnabled(boolean bl) {
        this.cancelButtonEnabled = bl;
        this.updateWizardButtons();
    }

    public final boolean isCurrentPanel() {
        String string = this.wizard.getCurrentPanel().getName();
        return string != null && string.equals(this.getName());
    }

    public final int getMostRecentPanelIndex() {
        return this.wizard.getMostRecentPanelIndex();
    }

    public final String getMostRecentPanelName() {
        return this.wizard.getMostRecentPanelName();
    }

    public final int getPanelIndex() {
        return this.wizard.getPanelIndex();
    }

    public boolean isEnabled() {
        return this.enabled;
    }

    public boolean is32bitJRE() {
        return JRE.is32Bit();
    }

    public boolean is64bitJRE() {
        return JRE.is64Bit();
    }

    public boolean isWindows() {
        return OS.isWindows();
    }

    public boolean isWindows7() {
        return OS.isWindows7();
    }

    public boolean isWindows8() {
        return OS.isWindows8();
    }

    public boolean isWindowsVista() {
        return OS.isWindowsVista();
    }

    public boolean isWindows2000() {
        return OS.isWindows2000();
    }

    public boolean isWindowsServer2003() {
        return OS.isWindowsServer2003();
    }

    public boolean isWindowsServer2008() {
        return OS.isWindowsServer2008();
    }

    public boolean isWindowsNT() {
        return OS.isWindowsNT();
    }

    public boolean isWindows98() {
        return OS.isWindows98();
    }

    public boolean isWindows95() {
        return OS.isWindows95();
    }

    public boolean isWindowsXP() {
        return OS.isWindowsXP();
    }

    public boolean isUnix() {
        return OS.isUnix();
    }

    public boolean isLinux() {
        return OS.isLinux();
    }

    public boolean isAix() {
        return OS.isAix();
    }

    public boolean isHpUnix() {
        return OS.isHpUnix();
    }

    public boolean isSolaris() {
        return OS.isSolaris();
    }

    public boolean isMac() {
        return OS.isMac();
    }

    public boolean isMacOsX() {
        return OS.isMacOsX();
    }

    public boolean isOs2() {
        return OS.isOs2();
    }

    public boolean isNetware() {
        return OS.isNetware();
    }

    public boolean isMpeUnix() {
        return OS.isMpeUnix();
    }

    public void reset() {
    }

    public void userCanceled() {
    }

    public void cancel() {
        this.wizard.cancel();
    }

    public void abort() {
        this.wizard.abort();
    }

    public void showPanel(int n) {
        if (this.isCurrentPanel()) {
            this.wizard.showPanel(n);
        } else {
            log.write(this.getName() + " called showPanel, but the current panel is " + this.wizard.getCurrentPanel().getName());
            log.write(new Throwable());
        }
    }

    public void showPanel(String string) {
        if (this.isCurrentPanel()) {
            this.wizard.showPanel(string);
        } else {
            log.write(this.getName() + " called showPanel, but the current panel is " + this.wizard.getCurrentPanel().getName());
            log.write(new Throwable());
        }
    }

    public void showLastActivePanel() {
        int n = this.wizard.getLastActivePanel();
        if (n > 0) {
            log.write("moving to last panel: " + n);
            this.showPanel(n);
        } else {
            this.showNextPanel();
            log.write(this.getName() + " called showLastActivePanel, but there are no active panels");
        }
    }

    public boolean resetPanel(String string) {
        return this.wizard.resetPanel(string);
    }

    public void showPreviousPanel() {
        if (this.isCurrentPanel()) {
            this.wizard.showPrevious();
        } else {
            log.write(this.getName() + " called showPreviousPanel, but the current panel is " + this.wizard.getCurrentPanel().getName());
            log.write(new Throwable());
        }
    }

    public void showNextPanel() {
        if (this.isCurrentPanel()) {
            this.wizard.showNext();
        } else {
            log.write(this.getName() + " called showNextPanel, but the current panel is " + this.wizard.getCurrentPanel().getName());
            log.write(new Throwable());
        }
    }

    public boolean ask(String string) {
        return UiPopups.ask(string);
    }

    public boolean ask(String string, String string2, String string3, String string4) {
        return UiPopups.ask(string, string2, string3, string4);
    }

    public void note(String string) {
        UiPopups.note(string);
    }

    public void note(String string, String string2) {
        UiPopups.note(string, string2);
    }

    public void note(String[] arrstring) {
        JOptionPane.showMessageDialog(this.wizard, arrstring);
    }

    public void gotMessage(Object object, Object object2) {
    }

    private void updateWizardButtons() {
        if (this.isCurrentPanel()) {
            this.wizard.updateButtons();
        }
    }
}
