/*
 * Decompiled with CFR 0_101.
 */
package com.denova.util;

import com.denova.io.FixZipBugInputFilter;
import com.denova.io.ZipEntryInputStream;
import com.denova.io.Zipper;
import com.denova.util.PathIterator;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class DataFinder {
    private static final boolean debugging = false;
    static List datapath = new Vector();
    static boolean getResourceEnabled = true;
    static boolean datapathEnabled = true;
    static boolean classpathEnabled = true;

    public static InputStream getStream(String string) {
        InputStream inputStream = null;
        DataFinder.debug("Getting stream for " + string);
        if (inputStream == null && datapathEnabled) {
            inputStream = DataFinder.findInDatapath(string);
        }
        if (inputStream == null && getResourceEnabled) {
            inputStream = DataFinder.findAsResource(string);
        }
        if (inputStream == null && classpathEnabled) {
            inputStream = DataFinder.findInClasspath(string);
        }
        if (inputStream == null) {
            inputStream = DataFinder.findAsFile(string);
        }
        if (inputStream == null) {
            DataFinder.debug("Unable to find stream for resource: " + string);
        } else {
            DataFinder.debug("Got stream for resource: " + string);
        }
        return inputStream;
    }

    public static synchronized void addDirectory(String string) {
        DataFinder.addDirectory(new File(string));
    }

    public static synchronized void addDirectory(File file) {
        if (file.isDirectory()) {
            datapath.add(file);
        }
    }

    public static boolean isGetResourceEnabled() {
        return getResourceEnabled;
    }

    public static void setGetResourceEnabled(boolean bl) {
        getResourceEnabled = bl;
    }

    public static boolean isDatapathEnabled() {
        return datapathEnabled;
    }

    public static void setDatapathEnabled(boolean bl) {
        datapathEnabled = bl;
    }

    public static boolean isClasspathEnabled() {
        return classpathEnabled;
    }

    public static void setClasspathEnabled(boolean bl) {
        classpathEnabled = bl;
    }

    private static InputStream findInDatapath(String string) {
        FileInputStream fileInputStream = null;
        DataFinder.debug("Searching for resource in data path");
        Iterator iterator = datapath.iterator();
        while (fileInputStream == null && iterator.hasNext()) {
            File file = (File)iterator.next();
            fileInputStream = DataFinder.getFileStream(file, string);
            DataFinder.debug("   " + file.getPath());
            Thread.yield();
        }
        if (fileInputStream == null) {
            DataFinder.debug("Not in datapath");
        }
        return fileInputStream;
    }

    private static InputStream findAsFile(String string) {
        FileInputStream fileInputStream = null;
        DataFinder.debug("Searching for resource as a file");
        try {
            fileInputStream = new FileInputStream(new File(string));
            if (fileInputStream == null) {
                DataFinder.debug("Not an ordinary file");
            }
        }
        catch (Exception var2_2) {
            DataFinder.debug(var2_2);
        }
        return fileInputStream;
    }

    private static InputStream findAsResource(String string) {
        InputStream inputStream = null;
        DataFinder.debug("Searching for resource as a resourceStream");
        inputStream = new DataFinder().getClass().getResourceAsStream(string);
        if (inputStream == null) {
            DataFinder.debug(string + " not found by getResourceAsStream");
        }
        if (inputStream == null) {
            try {
                inputStream = new DataFinder().getClass().getResource(string).openStream();
            }
            catch (Exception var2_2) {
                DataFinder.debug(var2_2);
            }
        }
        return inputStream;
    }

    private static InputStream findInClasspath(String string) {
        InputStream inputStream = null;
        DataFinder.debug("Searching for resource in classpath");
        String string2 = System.getProperty("java.class.path", "");
        PathIterator pathIterator = new PathIterator(string2);
        while (inputStream == null && pathIterator.hasNext()) {
            String string3 = (String)pathIterator.next();
            DataFinder.debug("   " + string3);
            File file = new File(string3);
            if (file.isDirectory()) {
                inputStream = DataFinder.getFileStream(file, string);
            } else {
                ZipEntry zipEntry;
                ZipFile zipFile = Zipper.getZipFile(string3);
                if (zipFile != null && (zipEntry = Zipper.getZipEntry(zipFile, string)) != null) {
                    try {
                        ZipEntryInputStream zipEntryInputStream = new ZipEntryInputStream(zipFile, zipEntry);
                        inputStream = new FixZipBugInputFilter(zipEntryInputStream);
                    }
                    catch (Exception var8_9) {
                        DataFinder.debug(var8_9);
                    }
                }
            }
            Thread.yield();
        }
        if (inputStream == null) {
            DataFinder.debug("Not in classpath");
        }
        return inputStream;
    }

    private static FileInputStream getFileStream(File file, String string) {
        FileInputStream fileInputStream = null;
        try {
            DataFinder.debug("Getting " + string + " from " + file.getPath());
            File file2 = new File(file, string);
            fileInputStream = new FileInputStream(file2);
        }
        catch (Exception var3_4) {
            DataFinder.debug(var3_4);
        }
        return fileInputStream;
    }

    private static void debug(String string) {
    }

    private static void debug(Exception exception) {
    }
}
